/*
Purpose :  FORTRAN functions to control the PSD interface via a
           16-bit PIO ( only for PC/AT )
Hardware:  Two 8255 chips are used in parallel for 16-bit output
           via PORTA ( chip 1 = low byte, chip 2 = high byte )
           and input via PORTB
*/
#define PIO_BASEADR 0x300
#define PIO_PORTA   PIO_BASEADR
#define PIO_PORTB   PIO_BASEADR+2
#define PIO_PORTC   PIO_BASEADR+4
#define PIO_CTRL    PIO_BASEADR+6

// PIO_PORTC bit definitions for PSD control
#define PSD_STOP    0x0000  // CSR0 & CSR1 = 0 : stop PSD
#define PSD_CSR0    0x0002
#define PSD_CSR1    0x0004
#define PSD_NDRDY   0x0008  // New data ready
#define PSD_DTRNS   0x0010  // Data transition
#define PSD_INIT    0x0020  // Init PSD
#define PSD_DVAL    0x0100  // Data valid
#define PSD_OVF     0x0200  // Overflow
