#include  "rc_def.h"
#include  "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// tbraun_i.cpp
// (C) 1994 by Heiko Brandhorst MPG AG "Rntgenbeugung"
// Virtuelle Erweiterung der Klasse TPsd
// static char	VersionStamp[] = "xx1.13xx";
#include  "m_devcom.h"
#include  "m_psd.h"

extern	LPDList lpDList;

#include <fcntl.h>
#include <fstream.h>
#include <strstrea.h>
#include <iostream.h>

static HINSTANCE  AsaDllInstance;

const char* TBraunError[39][40]={{" Detektor 1. anwaehlen"}                // 0
																,{" Messung abbrechen mit Shutter"}        // 1
																,{" Messung abbrechen ohne Shutter"}       // 2
																,{" Kein Datenfluss zum PC "}              // 3
																,{"Energieskalierung "}                    // 4
																,{"Positionsskalierung "}
																,{"obere Grenze fuer Energiefenster "}
																,{"untere Grenze fuer Energiefenster "}
																,{"Energie-Counts fuer Countstop "}
																,{"Konstante f.Lifetimeberechnungen "}
																,{"mindest notwendigen Impulsabstand "}
																,{"externes Ratemeter selektieren "}
																,{"Multiplexerzeit f. Detektor 1 "}
																,{"HV-Regelung aus "}
																,{"HV-Regelung starten "}
																,{"Real/Lifetimestop "}
																,{"Positions-Counts f. Countstop "}
																,{"Messzeit einstellen "}
																,{"AD-Counts loeschen "}
																,{"Det. Counts loeschen"}
																,{"Positionsdaten loeschen"}
																,{"Messung starten"}
																,{"Messung gestartet ?"}
																,{"Messung gestoppt ?"}
																,{"Positionsdaten loeschen"}
																,{"Positions-Counts loeschen"}
																,{"Energie-Counts loeschen"}
																,{"Energiedaten senden"}
																,{"Positionsdaten senden"}
																,{"Multiplexerzeit f. Detektor 2 "}
																,{"Headerlaenge pruefen"}
																,{"Overflow d. Positionsdaten"}
																,{"Positionsdaten lesen"}
																,{"Hexfile synchronisieren "}
																,{"Hexfile Test auf Hexziffer"}
																,{"Hexfile suchen und ffnen"}
																,{"Hexfile Echo lesen und vergleichen"}
																,{"Hexfile laden mit Handshake"}
																,{"Speicher allocieren "}};

BYTE TBraun_Psd::befehl[30][16]= {{3,255,59,254}       						// 0. Detektor1 angewaehlt
																 ,{4,255,68,36,254}    						// 1. Messung abbrechen Shutter schliessen
																 ,{4,255,68,37,254}    						// 2. Messung abbrechen ohne Shutter
																 ,{3,255,48,254}       						// 3. no Data to PC
																 ,{4,255,65,0,254}     						// 4. Energieskalierung
																 ,{4,255,66,0,254}     						// 5. Positionsskalierung
																 ,{5,255,80,0,0,254}   						// 6. obere Grenz. Energiefen.
																 ,{5,255,81,0,0,254}   						// 7. untere  "       "
																 ,{9,255,144,255,255,255,255,255,239,254}  //8. E-Counts fuer Stop
																 ,{5,255,87,115,5,254}   					// 9. Konstante 0573 hex
																 ,{4,255,64,0,254}       					// 10. notw. Impulsabstand
																 ,{4,255,69,0,254}       					// 11. extern. Ratemeter ?
																 ,{5,255,84,100,0,254}   					// 12. Muxzeit Det 1. 64 hex
																 ,{6,255,103,0,4,0,254}  					// 13. HV-Regelung aus
																 ,{6,255,103,0,4,4,254}  					// 14. HV-Regelung ein
																 ,{4,255,70,0,254}       					// 15. Real/Lifetimestop
																 ,{9,255,145,255,255,255,255,255,239,254}  //16. Positionsstop
																 ,{6,255,96,127,150,152,254}     	// 17. Messzeit =9999999 sec.
																 ,{3,255,53,254 }            			// 18. AD-Counts loeschen
																 ,{4,255,73,0,254}           			// 19. Det. Counts loeschen
																 ,{5,255,82,81,82,254}       			// 20. Energiedaten loeschen
																 ,{3,255,49,254}             			// 21. Messung starten
																 ,{3,255,51,254}             			// 22. Messung gestartet ja ?
																 ,{3,255,51,254}             			// 23. Messung gestoppt ?
																 ,{5,255,83,81,83,254}       			// 24. Positionsdaten loeschen
																 ,{3,255,57,254}             			// 25. Positions-Counts loeschen
																 ,{3,255,55,254}             			// 26. Energie-Counts loeschen
																 ,{4,255,67,0,254}           			// 27. Energiedaten senden
																 ,{4,255,67,1,254}           			// 28. Positionsdaten senden
																 ,{5,255,85,0,0,254} };      			// 29. Muxzeit Det 2. 0 hex

BYTE TBraun_Psd::echo[30][16]=   {{2,255,59}
																 ,{2,255,68}
																 ,{2,255,68}
																 ,{2,255,48}
																 ,{4,255,65,254,0}
																 ,{4,255,66,254,0}
																 ,{6,255,80,254,0,254,0}
																 ,{6,255,81,254,0,254,0}
																 ,{14,255,144,254,255,254,255,254,255,254,255,254,255,254,239}
																 ,{6,255,87,254,115,254,5}
																 ,{4,255,64,254,0}
																 ,{4,255,69,254,0}
																 ,{6,255,84,254,100,254,0}
																 ,{7,255,103,0,254,4,254,0}
																 ,{7,255,103,0,254,4,254,4}
																 ,{4,255,70,254,0}
																 ,{14,255,145,254,255,254,255,254,255,254,255,254,255,254,239}
																 ,{7,255,96,127,254,150,254,152}
																 ,{2,255,53}
																 ,{2,255,73}
																 ,{2,255,82}
																 ,{2,255,49}
																 ,{4,255,51,254,1}
																 ,{4,255,51,254,0}
																 ,{2,255,83}
																 ,{2,255,57}
																 ,{2,255,55}
																 ,{4,255,67,254,0}
																 ,{4,255,67,254,1}
																 ,{6,255,85,254,0,254,0}};

static char		buf[MaxString];
void 					(WINAPI *lpfnSetPort)			(WORD,WORD);
BYTE 					(WINAPI *lpfnGetPort)			(WORD);
void 					(WINAPI *lpfnSetTimeout)	(DWORD);
int 					(WINAPI *lpfnGetData)			(WORD,WORD,WORD,LPLONG,WORD,long&);

//******** Funktionen **********************************************************
TBraun_Psd::TBraun_Psd(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::TBraun_Psd(void)\n",time(zidx));
//pph***************************************************************************
	long_to_bytes  	transform;
	char  					Ident[MaxString];
	UINT						uMaxEnergy;

	sprintf(Ident,"Device%d",GetId());
	bSetError = FALSE;
	SetDataType(PsdPositionData);
	AsaDllInstance = LoadLibrary("asa.dll");
	(FARPROC)lpfnSetPort 		= GetProcAddress(AsaDllInstance,"SetPort");
	(FARPROC)lpfnGetPort 		= GetProcAddress(AsaDllInstance,"GetPort");
	(FARPROC)lpfnSetTimeout = GetProcAddress(AsaDllInstance,"SetTimeout");
	(FARPROC)lpfnGetData 		= GetProcAddress(AsaDllInstance,"GetData");

	GetPrivateProfileString(Ident,"EnergyScale","2",Buffer,16,GetCFile());
	uEnergyScale = atoi(Buffer);
	if(uEnergyScale > 0x3)
		uEnergyScale = 0x2;
	befehl[4][3]	= (BYTE)uEnergyScale;
	echo[4][4]		= (BYTE)uEnergyScale;

	GetPrivateProfileString(Ident,"AbbruchMitShutter","0",Buffer,16,GetCFile());
	bAbbruchmitShutter = (0 < atoi(Buffer));

	GetPrivateProfileString(Ident,"PositionScale","2",Buffer,16,GetCFile());
	uPositionScale = atoi(Buffer);
	if(uPositionScale > 0x3)
		uPositionScale = 0x2;
	befehl[5][3]	=	(BYTE)uPositionScale;
	echo[5][4]		=	(BYTE)uPositionScale;

	uMaxEnergy = 0xFFF / (uEnergyScale+1);
	GetPrivateProfileString(Ident,"EnergyHigh","870",Buffer,16,GetCFile());
	uEnergyHigh = min(uMaxEnergy,(UINT)atoi(Buffer));
	transform.IWert[0]	=	(WORD)uEnergyHigh;
	befehl[6][3]				=	transform.SWert[0];
	echo[6][4]					=	transform.SWert[0];
	befehl[6][4]				=	transform.SWert[1];
	echo[6][6]					=	transform.SWert[1];

	GetPrivateProfileString(Ident,"EnergyLow","526",Buffer,16,GetCFile());
	uEnergyLow = min(uEnergyHigh,(UINT)atoi(Buffer));
	transform.IWert[0]	=	(WORD)uEnergyLow;
	befehl[7][3]				=	transform.SWert[0];
	echo[7][4]					=	transform.SWert[0];
	befehl[7][4]				=	transform.SWert[1];
	echo[7][6]					=	transform.SWert[1];

	GetPrivateProfileString(Ident,"MuxTimeDet1","40",Buffer,16,GetCFile());
	uMuxTimeDet1 = atoi(Buffer);
	if(uMuxTimeDet1 > 0xEFFF)
		uMuxTimeDet1 = 0x64;
	transform.IWert[0]	=	(WORD)uMuxTimeDet1;
	befehl[12][3]				=	transform.SWert[0];
	echo[12][4]					=	transform.SWert[0];
	befehl[12][4]				=	transform.SWert[1];
	echo[12][6]					=	transform.SWert[1];

	GetPrivateProfileString(Ident,"Ratemeter","0",Buffer,16,GetCFile());
	bRatemeter = (0 < atoi(Buffer));
	befehl[11][3]	= (WORD)bRatemeter;
	echo[11][4]		= (WORD)bRatemeter;

	GetPrivateProfileString(Ident,"RealLifeTime","0",Buffer,16,GetCFile());
	bRealLifeTime = (0 < atoi(Buffer));
	befehl[15][3]	= (WORD)bRealLifeTime;
	echo[15][4]		= (WORD)bRealLifeTime;

	GetPrivateProfileString(Ident,"DeathTime","10",Buffer,16,GetCFile());
	nDeathTime = atoi(Buffer);
	if(nDeathTime > 99)
		nDeathTime = 10;
	befehl[10][3]	= (WORD)nDeathTime;
	echo[10][4]		= (WORD)nDeathTime;

	GetPrivateProfileString(Ident,"DelayFast","2",Buffer,16,GetCFile());
	nDelayFast = atoi(Buffer);
	WritePrivateProfileString(Ident,"DelayFast",Buffer,GetCFile());

	GetPrivateProfileString(Ident,"DelaySlow","4",Buffer,16,GetCFile());
	nDelaySlow = atoi(Buffer);
	WritePrivateProfileString(Ident,"DelaySlow",Buffer,GetCFile());

	GetPrivateProfileString(Ident,"DebugInfo","0",Buffer,16,GetCFile());
	bDebugInfo = atoi(Buffer);

	hReadBuf = GlobalAlloc(GHND,GetBufferSize() * sizeof(DWORD));
	if(NULL == hReadBuf)
	 {
	 bDeviceOk 	= FALSE;
	 bSetError 	= TRUE;
	 nErrorCode = 38;
	 // Message
	 return;
	 }
	};

TBraun_Psd::~TBraun_Psd(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::~TBraun_Psd(void)\n",time(zidx));
//pph***************************************************************************
	char 	HeadLine[] = "Braun-Psd: Destruktor";
	int 	ExitList[3] = {2,3,13};
	char  aBuf[MaxString];
	char  Ident[MaxString];

	sprintf(Ident,"Device%d",GetId());
	bSetError = FALSE;
	for(int i = 0;i < 3;i++)
		if(0 != BuildOperation(&(befehl[ExitList[i]][0]),&(echo[ExitList[i]][0]),nDelayFast))
			{
			nErrorCode = ExitList[i];
			MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
			bSetError = TRUE;
			break;
			}
	GlobalUnlock(hReadBuf);
	FreeLibrary(AsaDllInstance);
	GlobalFree(hReadBuf);

	sprintf(aBuf,"%u",uEnergyHigh);
	WritePrivateProfileString(Ident,"EnergyHigh",aBuf,GetCFile());
	sprintf(aBuf,"%u",uEnergyLow);
	WritePrivateProfileString(Ident,"EnergyLow",aBuf,GetCFile());
	};

int	TBraun_Psd::GetBufferSize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::GetBufferSize(void)\n",time(zidx));
//pph***************************************************************************
	uCBufferLength = ((4096 >> uPositionScale)+18);
	if(uCBufferLength < ((4096 >> uEnergyScale)+18))
		uCBufferLength = ((4096 >> uEnergyScale)+18);
	return uCBufferLength+1;
	};

int TBraun_Psd::Initialize(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::Initialize(void)\n",time(zidx));
//pph***************************************************************************
	if(R_OK != TPsd::Initialize())
		return R_Failure;
	eHardware = BraunHW;
	return R_OK;
	};

void TBraun_Psd::SetDataType(TPsdDataType type)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::SetDataType(TPsdDataType type)\n",time(zidx));
//pph***************************************************************************
	eDataType = type;
	switch(eDataType) {
		case PsdEnergyData: case	PsdPositionData:
		break;

		default:
		MessageBox(GetFocus(),"Kein gltiger Typ.","TPsdDataType",MBINFO);
		eDataType = PsdPositionData;
		}
	};

int TBraun_Psd::PsdReadOut(THowReadOutPsd eReadType)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::PsdReadOut(THowReadOutPsd eReadType)\n",time(zidx));
//pph***************************************************************************
	UINT 						Words,wordstoread;
	char						HeadLine[] = "Braun-Psd: PsdReadOut()";
	int							retval = R_OK;
	int   					idx,bid;
	int							nDelay = nDelaySlow;
	long						detectorcounts;
	LPDWORD 				lpdwCountBuf;
	LPDWORD 				lpdwReadBuf;
	long_to_bytes 	HVTest;

	bSetError = FALSE;
	// Bei hoher Interrupt-Rate des Controllers ist eine greres Delay zu verwenden
	for(;;)
		{
		if(Header.HighADCCounts < 6000l)
			{ nDelay += 1; break; }
		if(Header.HighADCCounts < 8000l)
			{ nDelay += 2; break; }
		if(Header.HighADCCounts < 12000l)
			{ nDelay += 3; break; }
		if(Header.HighADCCounts < 15000l)
			{ nDelay += 4; break; }
		nDelay = 5;
		break;
		}
	DelayTime(1);
	//	sprintf(::buf,"Detektor-Rate: %ld", Header.HighADCCounts);
	//	Main.SetInfoLine(::buf);
	switch(eDataType) {
		case PsdEnergyData:
		wordstoread = (8192 >> uEnergyScale);
		bid = 27;
		break;

		case PsdPositionData: default:
		wordstoread = (8192 >> uPositionScale);
		bid = 28;
		}
	if(BuildOperation(&(befehl)[bid][0],&(echo)[bid][0],nDelay))
		{
		bSetError = TRUE;
		nErrorCode = bid;
		// MessageBox(GetFocus(),TBraunError[ErrorCode][0],HeadLine,MBINFO);
		return R_Failure;
		}
	lpdwReadBuf 	= (LPDWORD)GlobalLock(hReadBuf);
	// Daten vom Psd lesen
	Words = (UINT)lpfnGetData(	(WORD)(nBaseAddr+3),(WORD)(nBaseAddr+2),
															(WORD)(nBaseAddr+1),(LPLONG)lpdwReadBuf,
															(WORD)wordstoread,detectorcounts);
	if(Words != wordstoread)
		{
		bSetError = TRUE;
		nErrorCode = 31;
		// MessageBox(GetFocus(),TBraunError[ErrorCode][0],HeadLine,MBINFO);
		GlobalUnlock(hReadBuf);
		return R_Failure;
		}
	// berlauf aufgetreten ?
	memcpy((LPLONG)&Header,(LPLONG)lpdwReadBuf,16 * sizeof(long));
	if(Header.Ueberlauf & 0x80)
		{
		nErrorCode = 30;
		bSetError = TRUE;
		MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
		bHardOverflow = TRUE;
		GlobalUnlock(hReadBuf);
		return R_HardOverflow;
		};
	if(bHVRegelung)
		{
		float  val;

		HVTest.LWert = Header.HVParameter;
		val = (float)(int)(HVTest.IWert[0] - HVTest.IWert[1]) / HVTest.IWert[0] *100.0;
		sprintf(::buf,"dHV : %.1f %%",val);
		SetStatus(::buf);
		nHVRegelung_OK = (int)val;
		}
		else
		nHVRegelung_OK = 0;
	// Daten bernehemen
	lpdwCountBuf 	= (LPDWORD)GlobalLock(hCountBuf);
	uMaximumChannel = 0; dwMaxCounts = 0; dwIntegratedCounts = 0l;
	// Anzahl der Kanle fr die GetData() setzen
	switch(eDataType) {
		case PsdEnergyData:
		nChannelNumber  = (4096 >> uEnergyScale)-1;
		memcpy((LPSTR)lpdwCountBuf,(LPSTR)(lpdwReadBuf+16),(nChannelNumber+1)*sizeof(long));
		break;

		case PsdPositionData: default:
		nChannelNumber  = nMaxChannel-nMinChannel+1;
		memcpy((LPSTR)lpdwCountBuf,(LPSTR)(lpdwReadBuf+nMinChannel+16),(nChannelNumber+1)*sizeof(long));
		}
	switch(eReadType) {
		case FinalRead: default:
		for(idx=0;idx <= nChannelNumber;idx++)
			{
			dwIntegratedCounts += *lpdwCountBuf;
			if(dwMaxCounts < *lpdwCountBuf)
				{
				dwMaxCounts = *lpdwCountBuf;
				uMaximumChannel = idx;
				}
			lpdwCountBuf++;
			}
		break;

		case IntermediateRead:
		for(idx=0;idx <= nChannelNumber;idx++)
			{
			dwIntegratedCounts += *lpdwCountBuf;
			if(dwMaxCounts < *lpdwCountBuf)
				{
				dwMaxCounts = *lpdwCountBuf;
				uMaximumChannel = idx;
				}
			lpdwCountBuf++;
			}
		break;

		case AccumulationRead:
		for(idx=0;idx <= nChannelNumber;idx++)
			{
			dwIntegratedCounts 	+= *lpdwCountBuf;
			if(dwMaxCounts < *lpdwCountBuf)
				{
				dwMaxCounts = *lpdwCountBuf;
				uMaximumChannel = idx;
				}
			lpdwCountBuf++;
			}
		break;
		} // switch
	GlobalUnlock(hCountBuf);
	GlobalUnlock(hReadBuf);
	return retval;
	};

int  TBraun_Psd::PsdInit(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::PsdInit(void)\n",time(zidx));
//pph***************************************************************************
	char 				HeadLine[] = "Braun-Psd: Init()";
	int 				i;
	int 				nDelay = nDelayFast;
	const int		CntLst = 21;
	//! BOOL 				FirstTime = FALSE;
	int 				InitList[CntLst] = {1,2,3,0,4,5,6,7,8,16,9,20,10,11,12,13,14,15,17,26,29};

	bSetError = FALSE;
	if(11 != bDebug)
		{
		lpfnSetTimeout(10000);
		ResetDelayTime();
		}
		else
		{
		SetInfo("Debug BPsd");
	  return R_OK;
		}
	if(LoadHexFile()!= R_OK)
		{
		MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
		bDeviceOk = FALSE;
		return R_Failure;
		}
	for (i=0;i<CntLst;i++)
		{
		if ((!bHVRegelung)&&(InitList[i]==14)) continue;
		if ((bHVRegelung)&&(InitList[i]==13)) continue;
		if ((!bAbbruchmitShutter)&&(InitList[i]==1)) continue;
		if ((bAbbruchmitShutter)&&(InitList[i]==2)) continue;
		switch(InitList[i]) {
			case 4: 	nDelay += 1; break;
			case 3:		nDelay += 1; break;
			}
		if(0 != BuildOperation(&(befehl)[InitList[i]][0],&(echo)[InitList[i]][0],nDelay))
			{
			nErrorCode = InitList[i];
			bSetError	= TRUE;
			MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
			return R_Failure;
			}
		}
	return R_OK;
	};

int TBraun_Psd::PsdStart(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::PsdStart(void)\n",time(zidx));
//pph***************************************************************************
	char 		 	HeadLine[] 	 = "Braun-Psd: PsdStart()";
	int 		 	StartList[8] = {		/* Konstanter Teil */ 18,19,21,22,

																/* Variabler Teil  */ 24,25,26,20};
																// old {0,18,19,20,24,25,26,21,22};
	int				CntLst 			 = 7; 	// Anzahl der Kommandos
	int 		 	nDelay 			 = nDelayFast;

	// Regelung luft wahrscheinlich stndig autark im Controller
	// Mode Energiedaten anzeigen 20
	// Mode Positionsdaten anzeigen 24
	// Fr Regelung sollen Energiedaten nicht gelscht werden
	if(eDataType == PsdEnergyData)
		CntLst = 8;
	bSetError = FALSE;
	for(int i = 0;i < CntLst;i++)
		{
		switch(StartList[i]) {
			case 24: case 20:	case 22: nDelay += 1; break;
			}
		if(0 != BuildOperation(&(befehl)[StartList[i]][0],&(echo)[StartList[i]][0],nDelay))
			{
			nErrorCode = StartList[i];
			bSetError = TRUE;
			MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
			return R_Failure;
			}
		}
	return R_OK;
	};

int  TBraun_Psd::SetEnergyRange(UINT uLowerRange,UINT uHigherRange)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::SetEnergyRange(UINT uLowerRange,UINT uHigherRange)\n",time(zidx));
//pph***************************************************************************
	char 					HeadLine[]= "Braun-Psd: SetEnergieRange";
	int 					nDelay = nDelayFast;
	long_to_bytes transform;
	UINT					uMaxEnergy = 0xFFF / (uEnergyScale+1);
	char					Ident[20];
	const int			CntLst = 2;
	char					buf[MaxString];
	int 					CmdList[CntLst] = {6,7};

	uEnergyHigh = min(uMaxEnergy,uHigherRange);
	transform.IWert[0]	=	(WORD)uEnergyHigh;
	befehl[6][3]				=	transform.SWert[0];
	echo[6][4]					=	transform.SWert[0];
	befehl[6][4]				=	transform.SWert[1];
	echo[6][6]					=	transform.SWert[1];

	uEnergyLow = min(uEnergyHigh,uLowerRange);
	transform.IWert[0]	=	(WORD)uEnergyLow;
	befehl[7][3]				=	transform.SWert[0];
	echo[7][4]					=	transform.SWert[0];
	befehl[7][4]				=	transform.SWert[1];
	echo[7][6]					=	transform.SWert[1];

	bSetError = FALSE;
	for(int i = 0;i < CntLst;i++)
		{
		if(0 != BuildOperation(&(befehl)[CmdList[i]][0],&(echo)[CmdList[i]][0],nDelay))
			{
			nErrorCode = CmdList[i];
			bSetError = TRUE;
			MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
			return R_Failure;
			}
		}
	sprintf(Ident,"Device%d",GetId());
	sprintf(buf,"%u",uEnergyHigh);
	WritePrivateProfileString(Ident,"EnergyHigh",buf,GetCFile());
	sprintf(buf,"%u",uEnergyLow);
	WritePrivateProfileString(Ident,"EnergyLow",buf,GetCFile());
	return R_OK;
	}

int  TBraun_Psd::PsdStop(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::PsdStop(void)\n",time(zidx));
//pph***************************************************************************
	char 					HeadLine[]= "Braun-Psd: PsdStop";
	int 					nDelay = nDelayFast;
	const int			CntLst = 3;
	int 					StopList[CntLst] = {2,1,23}; // 2,1,23,28

	bSetError = FALSE;
	for(int i = 0;i < CntLst;i++)
		{
		switch(StopList[i]) {
			case 23: 	nDelay += 1; break;
			}
		if((!bAbbruchmitShutter)&&(StopList[i]==1)) continue;
		if((bAbbruchmitShutter)&&(StopList[i]==2)) continue;
		if(0 != BuildOperation(&(befehl)[StopList[i]][0],&(echo)[StopList[i]][0],nDelay))
			{
			nErrorCode = StopList[i];
			bSetError = TRUE;
			MessageBox(GetFocus(),TBraunError[nErrorCode][0],HeadLine,MBINFO);
			return R_Failure;
			}
		}
	return R_OK;
	};

int  TBraun_Psd::BuildOperation(BYTE* zgrbefehl,BYTE* zgrecho,int delay)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::BuildOperation(BYTE* zgrbefehl,BYTE* zgrecho,int delay)\n",time(zidx));
//pph***************************************************************************
	int   i,j;
	BYTE  EchoRead[18];

	if(11 == bDebug)
		{
		SetInfo("Debug BPsd");
		return 0;
		}
	j = (int)zgrbefehl[0];
	for(i=1;i<j+1;i++)
		{
		lpfnSetPort((WORD)nBaseAddr,zgrbefehl[i]);
		Delay(50+(delay*50));
		}
	j = (int)zgrecho[0];
	for(i=0;i<j;i++)
		{
		if(Look_till_BaseAddr1(delay)) break;
		EchoRead[i+2] = lpfnGetPort((WORD)(nBaseAddr+2));
		EchoRead[i+1] = lpfnGetPort((WORD)(nBaseAddr+3));
		i++;
		if((i == 3) && (j == 7))
			{
			EchoRead[3] = EchoRead[4];
			i--;
			}
		}
	EchoRead[0] = (BYTE)j;
	return strncmp((char*)EchoRead,(char*)zgrecho,j+1);
	};

void TBraun_Psd::ResetDelayTime(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::ResetDelayTime(void)\n",time(zidx));
//pph***************************************************************************
	struct time t1,t2;

	if(11 == bDebug)
		{
		SetInfo("Debug BPsd");
		return;
		}
	gettime(&t1);
	do
		{
		gettime(&t2);
		lpfnSetPort((WORD)(nBaseAddr+1),0x00);
		}
	while((abs(t2.ti_sec - t1.ti_sec)) < 2);
	};

int TBraun_Psd::Look_till_BaseAddr1(int Delay)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::Look_till_BaseAddr1(int Delay)\n",time(zidx));
//pph***************************************************************************
	//! BYTE 				doppelpunkt;
	const BYTE 	Bit7 = 0x7F;
	int 				k = 0;

	if(11 == bDebug)
		{
		SetInfo("Debug BPsd");
		return 0;
		}
	//! while((doppelpunkt = lpfnGetPort((WORD)(nBaseAddr+1))) > Bit7)
	while((lpfnGetPort((WORD)(nBaseAddr+1))) > Bit7)
		{
		if (k > 1000*Delay)
			return 1;
		k++;
		}
	 return 0;
	};

int TBraun_Psd::SynchronHexFile(BYTE& W_String,BYTE& R_String)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::SynchronHexFile(BYTE& W_String,BYTE& R_String)\n",time(zidx));
//pph***************************************************************************
	int zaehler	=	0;

	if(11 == bDebug)
		{
		SetInfo("Debug BPsd");
		return 0;
		}
	W_String = 0x3A;
	do
	 {
	 lpfnSetPort((WORD)nBaseAddr,0x3A);
	 Look_till_BaseAddr1(1);
	 lpfnGetPort((WORD)(nBaseAddr+3));
	 R_String = lpfnGetPort((WORD)(nBaseAddr+2));
	 if (zaehler > 99) return 1;
	 zaehler++;
	 }
	while(R_String != 0x3A);
	return 0;
	};

BYTE TBraun_Psd::konvert(char z)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::konvert(char z)\n",time(zidx));
//pph***************************************************************************
	BYTE  zb = (BYTE)z;
	if(isdigit(zb))
		return (BYTE)(zb-48);
	if(z <= 70)
		return (BYTE)(zb-55);
	return (BYTE)(zb-87);
	};

int TBraun_Psd::LoadHexFile(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		braunpsd.cpp		TBraun_Psd::LoadHexFile(void)\n",time(zidx));
//pph***************************************************************************
//!	char 		HeadLine[] = "Braun-Psd: Load Hex-File";
	BYTE 		zeichen,HighWert,LowWert;
	int 		laenge = 0,i;
//!	int 		k=0;
	int 		anzahl=0;
//!	int 		l=0;
	BOOL 		ReadError=FALSE;
	BYTE 		Buffer[80];
	BYTE 		ReadString[70];
	BYTE 		WriteString[70];
	float		anzln = 350;
	int			acln	= 0;
	char 		Filename[] = "asa23.hex";

	bSetError = FALSE;
#ifndef __WIN32__
	ifstream myfile(Filename);
	if(!myfile)
		{
		bSetError = TRUE;
		nErrorCode = 35;
		return R_Failure;
		}
	do {
		if(ReadError)
			myfile.seekg((myfile.tellg())-(laenge+2));
		myfile.getline (Buffer,80,'\n');
		if(!(++acln % 40))
			{
			sprintf(buf,"HEX-File laden: %.1f %% sind geladen.",(float)acln/anzln);
			SetInfo(buf);
			}
		if(myfile.eof())
			break;
		if(11 == bDebug)
			{
			SetInfo("Debug BPsd");
			return R_OK;
			}
		laenge=strlen((char*)Buffer);
		istrstream mystream(Buffer,laenge);
		if((mystream.get())==0x3A)
			{
			if(SynchronHexFile(WriteString[0],ReadString[0]))
				{
				bSetError = TRUE;
				nErrorCode = 33;
				return R_Failure;
				};
			for(i=0;i<(laenge-1)/2;i++)
				{
				mystream.get(HighWert);
				if(!isxdigit(HighWert))
					{
					bSetError = TRUE;
					nErrorCode = 34;
					return R_Failure;
					};
			mystream.get(LowWert);
			if(!isxdigit(LowWert))
				{
				bSetError = TRUE;
				nErrorCode = 34;
				return R_Failure;
				}
			zeichen = (BYTE)((konvert(HighWert) << 4) + konvert(LowWert));
			WriteString[i+1] = zeichen;
			lpfnSetPort((WORD)nBaseAddr,zeichen);
			if(Look_till_BaseAddr1(1))
				{
				bSetError = TRUE;
				nErrorCode = 37;
				return R_Failure;
				}
			lpfnGetPort((WORD)(nBaseAddr+3));
			ReadString[i+1] = lpfnGetPort((WORD)(nBaseAddr+2));
			}
		if(strncmp((char*)WriteString,(char*)ReadString,i+1))
			{
			ReadError=TRUE;
			anzahl++;
			if(anzahl >= 3)
				{
				bSetError = TRUE;
				nErrorCode = 36;
				return R_Failure;
				}
			}
			else
			{
			ReadError = FALSE;
			anzahl = 0;
			}
		}
		else
		{
		ReadError = TRUE;
		if(anzahl >= 3)
			{
			bSetError = TRUE;
			nErrorCode = 36;
			return R_Failure;
			}
		anzahl++;
		}
		}
	while(!myfile.eof() || ReadError);
#endif
	SetInfo("HEX-File erfolgreich geladen.");
	return R_OK;
	};
// __LastLine__
