#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// m_arscan.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Rntgenbeugung"
// (C) 1996 by Heiko Damerow DLR
// modul for execution of area scan's with psd and sld

#include		"m_devcom.h"
#include		"m_layer.h"
#include		"m_steerg.h"
#include    "m_dlg.h"
#include    "m_xscan.h"
#include  	"c_layer.h"

extern	TMain						Main;
extern	LPDList 				lpDList;
extern  LPDataBase  		lpDBase;
extern	TSteering				Steering;
extern  TModelessDlg*   TheModeless;

char szMsgFailure[] = "Failure";
char szMessage[]    = "Message";
char szMsgLine001[] = "Measurement!  Omega: %s  2Theta: %s Intensity: %%.3f";
char szMsgLine002[] = "The Device %s is tagged as Monitor !";
char szMsgLine003[] = "Starting Omega/2Theta-Scan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine004[] = "Starting Omega/2Theta-Scan(SLD)\nwith Omega from %s to %s ?";
char szMsgLine005[] = "Starting OmegaScan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine006[] = "Theta is relative!\nSkip relative Angle ?";
char szMsgLine007[] = "Omega is relative !\nSkip relative Angle ?";
char szMsgLine008[] = "Scan-Number exceeds %d !";
char szMsgLine009[] = "Measurement! Omega:%s";
char szMsgLine010[] = "%s P(%s<>%%.1f) Integral Intensity: %%.1f > %%d";
char szMsgLine011[] = "%d Scan's has been measured";
char szMsgLine012[] = "The Measurement is ready and was saved";
char szMsgLine013[] = "Measurement has been interrupted !";
char szMsgLine014[] = "Incorrect Header.";
char szMsgLine015[] = "No valid Scan Type";
char szMsgLine016[] = "No Device as Monitor specified!";

char	aTempPath[120] = {0};
char	aTempName[12] = {0};

// variables for data aquisition
typedef struct
				{
				double	dX,dY,dOmega,dTheta;
				float		fDelta,fIntensity;
				} TData;

static	int 					nLinePoints = 100;
static	int						nEnvironment = 0;
static	char					DataFile[40];
				float					PointX[2],PointY[2];
				int						nMouseAction = 0;
static	TData*	    	lpData;
static	BOOL					bAquisitionActive = FALSE;
static	int						nSetMarker = 0;
static	BOOL					bSetDXZero = FALSE;
static	BOOL					bSetDYZero = FALSE;

static	int						nFirstReadColumn = 0;
static	int						nLastReadColumn = 0;

static	float					fPsdRange;
static 	char					szODF[7],szOWF[7],szTDF[7],szTWF[7];
static	TUnitType			eThetaUnitType = Grad;

// #define DEBUG
// #define OldVersion
// #ifdef Peak_and_Cross

void SetHKL(THKL& refl,LPCSTR info)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		SetHKL(THKL& refl,LPCSTR info)\n",time(zidx));
//pph***************************************************************************
	int		i;
	THKL  nr;

	i = 0;
	while('[' == info[i]) i++;
	while(' ' == info[i]) i++;
	if('-' == info[i])
		nr.h = max('0' - info[++i],-9);
		else
		nr.h = min(info[i] - '0',9);
	if('-' == info[++i])
		nr.k = max('0' - info[++i],-9);
		else
		nr.k = min(info[i] - '0',9);
	if('-' == info[++i])
		nr.l = max('0' - info[++i],-9);
		else
		nr.l = min(info[i] - '0',9);
  refl = nr;
	};

void GetHKL(THKL& refl,LPSTR info)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		GetHKL(THKL& refl,LPSTR info)\n",time(zidx));
//pph***************************************************************************
	sprintf(info,"[%d%d%d]",refl.h,refl.k,refl.l);
	};

//******************************************************************************
//**********         Klasse TAreaScan    ***************************************
//******************************************************************************
TAreaScanParameters::TAreaScanParameters()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScanParameters::TAreaScanParameters()\n",time(zidx));
//pph***************************************************************************
	char    	Ident[] = "AreaScan";
	char    	buf[MaxString];
	double		dDistance;
	int				nOldId = mlGetAxis();

	strcpy(::DataFile,"*.dtn");
	eScanType	= Omega2ThetaScan;
	SetDevice(dlGetIdByName(PsdDevice));
	nAddedChannels 		= Device->GetAddedChannels();
	bThetaAddsPsd 		= TRUE;
	fMaxTime          = 6.0;
	dwMaxCounts       = 30000l;
	fFailure          = 0.02;
	eSaveFormat       = StandardFile;
	bSaveOnReady      = FALSE;
	dMoveRelation     = 2.0;
	dThetaOffset			= 0.0;
	nOmega           	= mlGetIdByName(Omega);
	nTheta          	= mlGetIdByName(Theta);
	bAbsorberUsed     = FALSE;
	mlSetAxis(nOmega);
	dOmegaWidth       = mGetValue(Width);
	if(!mGetDistance(dDistance))
		{
		dOmegaMin        = 40.0;
		dOmegaMax        = 46.0;
		}
		else
		{
		dOmegaMin        = dDistance;
		dOmegaMax        = dDistance + 4.0;
		}
	mlSetAxis(nTheta);
	dThetaWidth = dMoveRelation * dOmegaWidth;
	dThetaMin 	= dMoveRelation * dOmegaMin;
	dThetaMax 	= dMoveRelation * dOmegaMax;
	dThetaWindow = dThetaMax - dThetaMin;
	GetPrivateProfileString(Ident,"ExposureTime","1.0",buf,MaxString,GetCFile());
	if(CreateDefaults())
		WritePrivateProfileString(Ident,"ExposureTime",buf,GetCFile());
	fMaxTime = atof(buf);
	GetPrivateProfileString(Ident,"Report","Integral",buf,MaxString,GetCFile());
	strupr(buf);
	while(1) {
		eNotifyValue = PeakPosition;
		if(!strcmp(buf,"MONITOR"))
			{
			eNotifyValue = MonitorIntensity;
			if(!dlIsDeviceValid(MonitorDevice))
				{
				MessageBox(GetFocus(),szMsgLine016,szMessage,MBINFO);
				break;
				}
			Monitor = lpDList->DP(dlGetIdByName(MonitorDevice));
			break;
			}
		if(!strcmp(buf,"ABSORBER"))
			{
			eNotifyValue = AbsorberPosition;
			break;
			}
		if(!strcmp(buf,"INTEGRAL"))
			{
			eNotifyValue = IntegralIntensity;
			break;
			}
		if(!strcmp(buf,"TIME"))
			{
			eNotifyValue = MeasurementTime;
			break;
			}
		if(!strcmp(buf,"PEAK"))
			{
			eNotifyValue = PeakPosition;
			break;
			}
		break;
		}
	mlSetAxis(nTheta);
	eThetaUnitType = mGetUnitType();
	::fPsdRange = Device->GetAngleRange(eThetaUnitType);
	mlSetAxis(nOldId);
	};

void TAreaScanParameters::SetDevice(int id)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScanParameters::SetDevice(int id)\n",time(zidx));
//pph***************************************************************************
	Device = lpDList->DP(id);
	bPsdDevice = (Device->GetId() == dlGetIdByName(PsdDevice));
	};
//##############################################################################
TAreaScan::TAreaScan(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::TAreaScan(void)\n",time(zidx));
//pph***************************************************************************
	HMENU   	hMAdd;

	bInterrupted        = FALSE;
	bMacroRunning       = FALSE;
	bCalibrationActive  = FALSE;
	bShowPsdContinuous  = FALSE;
	bSaveContinuous     = FALSE;
	bThetaScanCompleted = FALSE;
	LowerBound					= 0.5;
	UpperBound					= 800.0;
	// Registrieren der Kindfenster-Klasse
	TMDIWindow::RegisterWnd();
	WindowType = W_PSDWindow;
	bMeasurementActive = FALSE;
	TheMenu = CreatePopupMenu();
	AppendMenu(TheMenu,MF_STRING,cm_SetupAreaScan,"Setup &Measurement...");
	AppendMenu(TheMenu,MF_STRING,cm_ShowCurveParam,"Visualising &Options...");
	AppendMenu(TheMenu,MF_STRING,cm_InitializeAreaScan,"Start &AreaScan");
	AppendMenu(TheMenu,MF_SEPARATOR,0,NULL);
	AppendMenu(TheMenu,MF_STRING,cm_ShowPsdP_Data,"Show &Impulse-Spectrum");
	AppendMenu(TheMenu,MF_STRING,cm_PSDRemoteSyncCtl,"Measure external synchonized..");
	AppendMenu(TheMenu,MF_STRING,cm_ChooseScan,"C&hoose Scan...");
	hMAdd = CreatePopupMenu();
	AppendMenu(hMAdd,MF_STRING,cm_FreezeCurve,"&Fixing");
	AppendMenu(hMAdd,MF_STRING,cm_KillSecondCurve,"&Clear");
	AppendMenu(hMAdd,MF_STRING,cm_SaveSecondCurve,"&Save");
	AppendMenu(TheMenu,MF_POPUP,(WORD)hMAdd,"&Scan");
	hMAdd = CreatePopupMenu();
	AppendMenu(hMAdd,MF_STRING,cm_ShowPsdE_Data,"Show &Energy-Spectrum");
	AppendMenu(hMAdd,MF_STRING,cm_SetupPsd,"&Settings...");
	AppendMenu(hMAdd,MF_STRING,cm_CalibratePsd,"&Calibrate...");
	AppendMenu(TheMenu,MF_POPUP,(WORD)hMAdd,"&Psd");
	AppendMenu(TheMenu,MF_STRING,cm_DataAquisition,"Inquire &Data...");
	// Reportstruktur fr Absorber-Position, Omega und ???
	ScanReport = lpDBase->GetScanReport();
	lpDBase->New();
	nActiveScan = 0;
	MainCurve 	= lpDBase->GetCurve(nActiveScan);
	// Fr TPlotData
	LowerBound    = 0.1;
	UpperBound    = 10000.0;
	bXY_Scaling		= TRUE;
	// pointer to output formats
	mlSetAxis(nOmega);
	strcpy(szODF,mGetDF());
	strcpy(szOWF,mGetSF());
	mlSetAxis(nTheta);
	eThetaUnitType = mGetUnitType();
	strcpy(szTDF,mGetDF());
	strcpy(szTWF,mGetSF());
	if(!dlIsDeviceValid(PsdDevice))
		{
		EnableMenuItem(TheMenu,cm_ShowPsdE_Data,MF_GRAYED);
		EnableMenuItem(TheMenu,cm_SetupPsd,MF_GRAYED);
		EnableMenuItem(TheMenu,cm_CalibratePsd,MF_GRAYED);
		EnableMenuItem(TheMenu,cm_ShowPsdP_Data,MF_GRAYED);
		}
	};

TAreaScan::~TAreaScan()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::~TAreaScan()\n",time(zidx));
//pph***************************************************************************
	char			buf[MaxString];
	RECT			rc,rcm;

	Main.hAreaScanWindow = NULL;
	lpDBase->New();
	DestroyMenu(TheMenu);
	Device->MeasureStop();
	Device->SetHost(NULL);
	if(bPsdDevice)
		Device->SetDisplay(NULL);
	Device->MeasureStart();
	GetWindowRect(GetFrameHandle(),&rcm);
	GetWindowRect(hWndChild,&rc);
	sprintf(buf,"%d",rc.left - rcm.left - 4);
	WritePrivateProfileString("AreaScan","xo",buf,GetCFile());
	sprintf(buf,"%d",rc.top - rcm.top - 42);
	WritePrivateProfileString("AreaScan","yo",buf,GetCFile());
	sprintf(buf,"%d",rc.right - rc.left);
	WritePrivateProfileString("AreaScan","dx",buf,GetCFile());
	sprintf(buf,"%d",rc.bottom - rc.top);
	WritePrivateProfileString("AreaScan","dy",buf,GetCFile());
	WritePrivateProfileString("AreaScan","DataPath",szDataPath,GetCFile());
	sprintf(buf,"%.2f",fMaxTime);
	WritePrivateProfileString("AreaScan","ExposureTime",buf,GetCFile());
	sprintf(buf,"%d",bSaveOnReady);
	WritePrivateProfileString("AreaScan","SaveOnReady",buf,GetCFile());
	};
#pragma argsused
LRESULT TAreaScan::CallLocalAction(WPARAM wParam,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::CallLocalAction(WPARAM wParam,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	switch(GET_WM_COMMAND_ID(wParam,lParam)){
		case cm_ChooseScan:
		TheModeless = (TChooseScan*)new TChooseScan(this);
		if(TheModeless)
			TheModeless->Initialize();
		return 0l;

		case cm_ShowPsdE_Data:
		ShowSensorContinuous(PsdEnergyData);
		return 0l;

		case cm_ShowPsdP_Data:
		ShowSensorContinuous(PsdPositionData);
		return 0l;

		case cm_SetupPsd:
		TheModeless = (TPsdParameters*)new TPsdParameters();
		if(TheModeless)
			TheModeless->Initialize();
		break;

		}
	return 0l;
	};

//***************** Mausbedienung **********************************************
void TAreaScan::rButtonDown(LONG lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::rButtonDown(LONG lParam)\n",time(zidx));
//pph***************************************************************************
	POINT		pp;
	if(bMeasurementActive && !bInterrupted)
		EnableMenuItem(TheMenu,cm_InitializeAreaScan,MF_GRAYED);
		else
		EnableMenuItem(TheMenu,cm_InitializeAreaScan,MF_ENABLED);
	if(TheModeless)
		EnableMenuItem(TheMenu,cm_ChooseScan,MF_GRAYED);
		else
		EnableMenuItem(TheMenu,cm_ChooseScan,MF_ENABLED);
	if(!bPsdDevice)
		EnableMenuItem(TheMenu,cm_SetupPsd,MF_GRAYED);
		else
		EnableMenuItem(TheMenu,cm_SetupPsd,MF_ENABLED);
	if(eOutputType <= MatrixBitmap)
		{
		EnableMenuItem(TheMenu,cm_FreezeCurve,MF_GRAYED);
		EnableMenuItem(TheMenu,cm_DataAquisition,MF_ENABLED);
		}
		else
		{
		EnableMenuItem(TheMenu,cm_DataAquisition,MF_GRAYED);
		EnableMenuItem(TheMenu,cm_FreezeCurve,MF_ENABLED);
		}
	pp.x = LOWORD(lParam);
	pp.y = HIWORD(lParam);
	ClientToScreen(hWndChild,&pp);
	TrackPopupMenu(TheMenu,0,pp.x,pp.y,0,hWndChild,NULL);
	};

void TAreaScan::lButtonUp(WPARAM wParam,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::lButtonUp(WPARAM wParam,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	TPlotData::lButtonUp(wParam,lParam);
	if(nMouseAction == 100)
		{
		nMouseAction = 0;
		PostMessage(hWndChild,WM_COMMAND,cm_DataAquisition,0l);
		}
	};

void TAreaScan::lButtonDown(WPARAM wParam,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::lButtonDown(WPARAM wParam,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	if(bAquisitionActive)
		nMouseAction = 100;
		else
		nMouseAction = 0;
	TPlotData::lButtonDown(wParam,lParam);
	};

void TAreaScan::InitializeDlg(WPARAM task,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::InitializeDlg(WPARAM task,LPARAM)\n",time(zidx));
//pph***************************************************************************
	TModalDlg*	dlg;

	switch(task) {
		case cm_SetupAreaScan:
		dlg = (TSetupAreaScan*)new TSetupAreaScan(this);
		dlg->ExecuteDialog(hWndChild);
		delete dlg;
		break;

		case cm_DataAquisition:
		if(bAquisitionActive)
			{
			FILE*			hFile;
			char      buf[MaxString];
			int				cnt,env,row,column;
			float			Odelta,Tdelta,x,y,z,offset,value;;
			double		yDelta,xDelta,Omega,Theta,cache,X,Y;
			double		a = M_PI / Main.WaveLength;
			TData*		p;
			TCurve*   Scan;

			bAquisitionActive = FALSE;
			//*** calculate the points in angle space
			//** set the points in reciproke space map
			if(bSetDYZero)
				PointY[1] = PointY[0];
			if(bSetDXZero)
				PointX[1] = PointX[0];
			yDelta = (PointY[1] - PointY[0]) / nLinePoints;
			xDelta = (PointX[1] - PointX[0]) / nLinePoints;
			if((fabs(yDelta) < 1e-7) && (fabs(xDelta) < 1e-7))
				{
				MessageBox(GetFocus(),"Eingabe wird verworfen !","Fehler",MBINFO);
				break;
				}
			//*** Point0 and Point1 are valid
			lpData = (TData*) new TData [nLinePoints];
			switch(eOutputType) {
				case MatrixBitmap:
				lpData[0].dTheta = PointX[0];
				lpData[0].dOmega = PointY[0];
				lpData[0].fDelta = lpData[0].fIntensity = 0.0;
				for(cnt = 1;cnt < nLinePoints;cnt++)
					{
					lpData[cnt].fDelta = lpData[cnt].fIntensity = 0.0;
					lpData[cnt].dOmega = lpData[cnt-1].dOmega + yDelta;
					lpData[cnt].dTheta = lpData[cnt-1].dTheta + xDelta;
					}
				break;

				case ReciprokeLatticeBitmap:
				lpData[0].dTheta = PointX[0];
				lpData[0].dOmega = PointY[0];
				lpData[0].fDelta = lpData[0].fIntensity = 0.0;
				for(cnt = 1;cnt < nLinePoints;cnt++)
					{
					lpData[cnt].fDelta = lpData[cnt].fIntensity = 0.0;
					lpData[cnt].dY = lpData[cnt-1].dY + yDelta;
					lpData[cnt].dX = lpData[cnt-1].dX + xDelta;
					X = lpData[cnt].dX;
					Y = lpData[cnt].dY;
					if(Y == 0.0)
						{
						lpData[cnt].dTheta = 0.0;
						lpData[cnt].dOmega = 0.0;
						continue;
						}
					//** transform to angle space
					cache = asin(sqrt(pow(X,2)+pow(Y,2)) / (2 / a));
					lpData[cnt].dTheta = 2 * cache;
					lpData[cnt].dOmega = cache - atan(X / Y);
					//* transform from RAD to DEG
					lpData[cnt].dOmega = RadToDeg (lpData[cnt].dOmega);
					lpData[cnt].dTheta = RadToDeg (lpData[cnt].dTheta);
					}
				break;
				}
			//*** search the related intensities
			switch(eOutputType) {
				case MatrixBitmap:
				for(cnt = 0;cnt < nLinePoints;cnt++)
					{
					p = &lpData[cnt];
					Omega = p->dOmega;
					Theta = p->dTheta;
					row = ScanReport->GetValueByValue(Omega,Odelta,offset);
					Scan = lpDBase->GetCurve(row);
					Omega += Odelta;
					//** pick out the intensity
					column = Scan->GetValueByValue(Theta,Tdelta,value);
					Theta += Tdelta + offset;
					//** transform to reciproke lattice space
					Omega = DegToRad (Omega);
					Theta	= DegToRad (Theta);
					p->dX = ArToRLx (Omega,Theta) * a;
					p->dY = ArToRLx (Omega,Theta) * a;
					p->fIntensity = value;
					env = nEnvironment;
					if(xDelta > yDelta)
						while(env)
							{
							Scan->SetPP(column + env);
							Scan->PGet(x,y,z);
							value += y;
							Scan->SetPP(column - env);
							Scan->PGet(x,y,z);
							value += y;
							env--;
							}
						else
						while(env)
							{
							Scan = lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x,y,z);
							value += y;
							Scan = lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x,y,z);
							value += y;
							env--;
							}
					p->fIntensity = value / (nEnvironment * 2 + 1);
					p->fDelta = pow(pow(Odelta,2) + pow(Tdelta,2),0.5);
					}
				break;

				case ReciprokeLatticeBitmap:
				for(cnt = 0;cnt < nLinePoints;cnt++)
					{
					p = &lpData[cnt];
					Omega = p->dOmega;
					Theta = p->dTheta;
					row = ScanReport->GetValueByValue(Omega,Odelta,offset);
					//** reverse connection between psd and theta-axis
					Theta -= offset;
					Scan = lpDBase->GetCurve(row);
					//** pick out the intensity
					column = Scan->GetValueByValue(Theta,Tdelta,value);
					p->fIntensity = value;
					env = nEnvironment;
					if(Tdelta > Odelta)
						while(env)
							{
							Scan->SetPP(column + env);
							Scan->PGet(x,y,z);
							value += y;
							Scan->SetPP(column - env);
							Scan->PGet(x,y,z);
							value += y;
							env--;
							}
						else
						while(env)
							{
							Scan = lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x,y,z);
							value += y;
							Scan = lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x,y,z);
							value += y;
							env--;
							}
					p->fIntensity = value / (nEnvironment * 2 + 1);
					p->fDelta = pow(pow(Odelta,2) + pow(Tdelta,2),0.5);
					}
				}
			//*** save data
			hFile = fopen(DataFile,"w");
			if(!hFile)
				{
				strcpy(buf,"Probleme beim Anlegen des File !");
				MessageBox(GetFocus(),buf,"Meldung",MBINFO);
				delete[] lpData;
				return;
				}
			sprintf(buf,"# Source = %s\n",FileName);
			fwrite(buf,strlen(buf),1,hFile);
			sprintf(buf,"# Order = Omega Theta Intensity Y X Delta\n",FileName);
			fwrite(buf,strlen(buf),1,hFile);
			for(cnt = 0;cnt < nLinePoints;cnt++)
				{
				sprintf(buf,"%.3e\t %.3e\t %.3e\t %.3e\t %.3e\t %.2e\n",
														lpData[cnt].dOmega,lpData[cnt].dTheta,
														lpData[cnt].fIntensity,
														lpData[cnt].dY,lpData[cnt].dX,
														lpData[cnt].fDelta);
				fwrite(buf,strlen(buf),1,hFile);
				}
			fclose(hFile);
			delete[] lpData;
			sprintf(buf,"Die Daten wurden im File %s gespeichert !",DataFile);
			MessageBox(GetFocus(),buf,"Daten-Erhebung",MBINFO);
			return;
			}
		dlg = (TAquisition*)new TAquisition();
		dlg->ExecuteDialog(hWndChild);
		delete dlg;
		break;
		}
	UpdateWnd(0);
	};

BOOL TAreaScan::CanOpen(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::CanOpen(void)\n",time(zidx));
//pph***************************************************************************
	if(!TMDIWindow::CanOpen()) return FALSE;
	return TRUE;
	};

BOOL TAreaScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	if(!TMDIWindow::CanClose()) return FALSE;
	return TRUE;
	};

BOOL TAreaScan::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::New(void)\n",time(zidx));
//pph***************************************************************************
	lpDBase->New();
	nActiveScan = 0;
	MainCurve = lpDBase->GetCurve(nActiveScan);
	return TPlotData::New();
	};

void TAreaScan::Create(HWND hwnd)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::Create(HWND hwnd)\n",time(zidx));
//pph***************************************************************************
	RECT		rc;

	hWndChild = hwnd;
	Main.hAreaScanWindow = hwnd;
	Main.AreaScanWindow = this;
	Delay(2000);
	rc.left 	= GetPrivateProfileInt("AreaScan","xo",500,GetCFile());
	rc.top  	= GetPrivateProfileInt("AreaScan","yo",400,GetCFile());
	rc.right	= rc.left + GetPrivateProfileInt("AreaScan","dx",170,GetCFile());
	rc.bottom = rc.top + GetPrivateProfileInt("AreaScan","dy",50,GetCFile());
	GetPrivateProfileString("AreaScan","DataPath","c:\\",szDataPath,MaxString,GetCFile());
	if(szDataPath[strlen(szDataPath) - 1] != '\\')
		strcat(szDataPath,"\\");
	strcpy(szFilter,"HRM Standard (*.psd)|*.psd||");
	strcpy(szExtension,"psd");
	SetTitle();
	UpdateMenu();
	SetWindowPos(	hWndChild,NULL,rc.left,rc.top,rc.right - rc.left,
								rc.bottom - rc.top,SWP_NOZORDER);
	};

BOOL TAreaScan::SetTitle()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SetTitle()\n",time(zidx));
//pph***************************************************************************
	char  aTitle[MaxString];

#ifdef GermanVersion
	strcpy(aTitle,"HRM:");
#else
	strcpy(aTitle,"AreaScan:");
#endif
	if(bIsNewFile)
		strcat(aTitle,"<untitled.psd>");
		else
		strcat(aTitle,FileName);
	SetWindowText(hWndChild,aTitle);
	return TRUE;
	};

void  TAreaScan::UpdateWnd(int act)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::UpdateWnd(int act)\n",time(zidx));
//pph***************************************************************************
	switch(eOutputType) {
		case ReciprokeLatticeBitmap:
		BSource->UpdateBitmapSource();
		break;
		case MatrixBitmap:
		BSource->UpdateBitmapSource();
		break;
		}
	TMDIWindow::UpdateWnd(act);
	};

void TAreaScan::SetRanges(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SetRanges(void)\n",time(zidx));
//pph***************************************************************************
	float	xshift;

	switch(eOutputType) {
		case Curve:
		CoorSys.yMin 	= LowerBound;
		CoorSys.yMax 	= UpperBound;
		if(!bPsdDevice)
			{
			if(1 > MainCurve->GetPNumber())
				{
				CoorSys.xMin 	= - dThetaWindow / 2.0;
				CoorSys.xMax 	= dThetaWindow / 2.0;
				break;
				}
			CoorSys.xMin 	= MainCurve->Min[P_X];
			CoorSys.xMax 	= CoorSys.xMin + dThetaWindow;
			break;
			}
		if(2 > MainCurve->GetPNumber())
			{
			if(bSecondaryCoor)
				{
				CoorSys.xMin 	= 0.0;
				CoorSys.xMax 	= Device->GetAngleRange(Sekunden) / Device->GetAngleStep();
				break;
				}
			CoorSys.xMin 	= dOmegaMin * dMoveRelation;
			CoorSys.xMax 	= CoorSys.xMin + Device->GetAngleRange();
			break;
			}
		if(bSecondaryCoor)
			{
			CoorSys.xMin 	= MainCurve->Min[P_Z];
			CoorSys.xMax 	= MainCurve->Max[P_Z];
			break;
			}
		xshift    = GetThetaOffset(0);
		CoorSys.xMin 	= MainCurve->Min[P_X] + xshift;
		CoorSys.xMax 	= MainCurve->Max[P_X] + xshift;
		break;

		case ReciprokeLatticeBitmap:
		CoorSys.zMax = UpperBound;
		CoorSys.zMin = LowerBound;
		// The AltCoorSys is now used and will be setted in TransformDBaseToBitmap()
		break;

		case MatrixBitmap:
		CoorSys.zMax = UpperBound;
		CoorSys.zMin = LowerBound;
		CoorSys.yMin = dOmegaMin;
		CoorSys.yMax = dOmegaMax;
		if(7 > MainCurve->GetPNumber())
			{
			CoorSys.xMin 	= dOmegaMin * dMoveRelation;
			CoorSys.xMax 	= CoorSys.xMin + Device->GetAngleRange();
			break;
			}
		xshift = GetThetaOffset(0);
		CoorSys.xMin 	= MainCurve->Min[P_X] + xshift;
		CoorSys.xMax 	= MainCurve->Max[P_X] + xshift;
		break;

		default:
		MessageBox(GetFocus(),"Kein gltiger Darstellungstyp !","Meldung",MBINFO);
		break;
		}
	};

double	TAreaScan::GetThetaOffset(int scid)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::GetThetaOffset(int scid)\n",time(zidx));
//pph***************************************************************************
	float		theta,v;

	// this function returns an absolute Theta Value
	switch(eOutputType) {
		case Curve:
		if(bShowPsdContinuous)
			return (mlGetValue(nTheta,Distance) - mlGetOffset(nTheta));
		if(!bPsdDevice)
			theta = 0.0;
			else
			{
			ScanReport->SetPP(10000);
			ScanReport->PGet(v,theta,v);
			if((theta > 1000.0) || (theta < -1000.0))
				theta = 0.0;
			}
		return theta;

		case ReciprokeLatticeBitmap:
		if(2 > lpDBase->GetCNumber()) return 0.0;
		ScanReport->SetPP(scid);
		ScanReport->PGet(v,theta,v);
		return theta - dThetaOffset;

		case MatrixBitmap:
		if(2 > lpDBase->GetCNumber()) return 0.0;
		ScanReport->SetPP(0);
		ScanReport->PGet(v,theta,v);
		return theta - dThetaOffset;

		default:
		MessageBox(GetFocus(),"Kein gltiger Darstellungstyp !","Meldung",MBINFO);
		return 0.0;
		}
	};

BOOL TAreaScan::SetMeasurementArea(TKSystem &ks)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SetMeasurementArea(TKSystem &ks)\n",time(zidx));
//pph***************************************************************************
	float	 fdTheta,thetamin;

	/*
	::fPsdRange wird fr jede Messung mit Device->GetAngleRange()
	oder nach dem Einlesen in LoadMeasurementInfo() und LoadOldData() gesetzt.
	*/
	switch(eOutputType) {
		case ReciprokeLatticeBitmap:
		fdTheta  	= (dOmegaMax - dOmegaMin) * dMoveRelation;
		thetamin 	= GetThetaOffset(0); //  + dOmegaMin * dMoveRelation;
		thetamin	+= MainCurve->Min[0];
		ks[0].x 	= DegToRad (thetamin);
		ks[0].y 	= DegToRad (dOmegaMin);
		ks[0].Ord = 0;
		ks[1].x 	= DegToRad (thetamin + ::fPsdRange);
		ks[1].y 	= DegToRad (dOmegaMin);
		ks[1].Ord = 1;
		ks[2].x 	= DegToRad (thetamin + fdTheta + ::fPsdRange);
		ks[2].y 	= DegToRad (dOmegaMax);
		ks[2].Ord = 2;
		ks[3].x 	= DegToRad (thetamin + fdTheta);
		ks[3].y 	= DegToRad (dOmegaMax);
		ks[3].Ord = 3;
		break;

		case MatrixBitmap:
		ks[0].x 	= 0.0;
		ks[0].y 	= dOmegaMin;
		ks[0].Ord = 0.0;
		ks[1].x 	= ::fPsdRange;
		ks[1].y 	= dOmegaMin;
		ks[1].Ord = 1;
		ks[2].x 	= ::fPsdRange;
		ks[2].y 	= dOmegaMax;
		ks[2].Ord = 2;
		ks[3].x 	= 0.0;
		ks[3].y 	= dOmegaMax;
		ks[3].Ord = 3;
		break;
		}
	return TRUE;
	};

void TAreaScan::InitializeTask(WPARAM,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::InitializeTask(WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
	char    buf[101];
	char    fmt[MaxString];
#ifdef GermanVersion
	char		HeadLine[] = "Start AreaScan";
#else
	char		HeadLine[] = "Starting AreaScan";
#endif
	char    msg[101];

	if(bShowPsdContinuous)
		{
		LoadString(Main.hInstance,sth_StopContiniousPsd,msg,100);
		MessageBox(hWndChild,msg,HeadLine,MBSTOP);
		return;
		}
	// Alte Daten sichern bzw. neuen Namen vergeben
	if(((dOmegaMax - dOmegaMin) / dOmegaWidth) > lpDBase->GetMaxScanNumber())
			{
			sprintf(msg,szMsgLine008,lpDBase->GetMaxScanNumber());
			MessageBox(hWndChild,msg,HeadLine,MBSTOP);
			return;
			}
	// Motoren initialisieren
	mlSetAxis(nOmega);
	mSetValue(Speed,10000.0);
	switch(eScanType) {
		case Omega2ThetaScan:
		if(!mIsDistanceRelative()) break;
		strcpy(msg,szMsgLine007);
		if(IDYES == MessageBox(hWndChild,msg,HeadLine,MBASK))
			mSetRelativeZero(NO,0.0);
		}
	mlSetAxis(nTheta);
	mSetValue(Speed,10000.0);
	switch(eScanType) {
		case Omega2ThetaScan:
		if(!mIsDistanceRelative()) break;
		strcpy(msg,szMsgLine006);
		if(IDYES == MessageBox(hWndChild,msg,HeadLine,MBASK))
			{
			mSetRelativeZero(NO,0.0);
			dThetaOffset = 0.0;
			}
			else
			dThetaOffset = mlGetOffset(nTheta);
		}
	switch(eScanType) {
		case Omega2ThetaScan:
		if(bPsdDevice)
			sprintf(fmt,szMsgLine003,szODF,szODF);
			else
			{
			sprintf(fmt,szMsgLine004,szODF,szODF);
			dThetaOffset = 0.0;
			}
		break;

		case StandardScan:
		if(!bPsdDevice) break;
		sprintf(fmt,szMsgLine005,szODF,szODF);
		break;
		default:
		return;
		}
	sprintf(msg,fmt,dOmegaMin,dOmegaMax);
	if(IDNO == MessageBox(GetFocus(),msg,HeadLine,MBASK))
		return;
	SaveFile(SaveWithNewName);
	// Sensoren initialisieren
	Device->MeasureStop();
	Steering.Reset();
	Steering.StartUp(hWndChild,nOmega,Device->GetId());
	Device->SetExposureValues(fMaxTime,dwMaxCounts,fFailure);
	Device->SetParameters();
	switch(eNotifyValue) {
		case MonitorIntensity:
		if(dlGetIdByName(MonitorDevice) == Device->GetId())
			{
			sprintf(buf,szMsgLine002,Device->Characteristic);
			MessageBox(GetFocus(),buf,szMsgFailure,MBSTOP);
			return;
			}
		Monitor->MeasureStop();
		Monitor->SetHost(hWndChild);
		Monitor->SetExposureValues(fMaxTime * 0.8,dwMaxCounts,fFailure);
		break;

		case AbsorberPosition:
		break;
		}
	switch(eScanType) {
		case Omega2ThetaScan:
		if(bPsdDevice)
			{
			Device->SetSignalGrowUp(TRUE);
			Device->SetAddedChannels(nAddedChannels);
			::fPsdRange = Device->GetAngleRange(eThetaUnitType);
			}
			else
			::fPsdRange = dThetaWindow;
		break;

		case StandardScan:
		if(!bPsdDevice)
			{
			SetInfo("Standard-Scan nur mit PSD");
			return;
			}
		Device->SetSignalGrowUp(TRUE);
		Device->SetAddedChannels(nAddedChannels);
		::fPsdRange = Device->GetAngleRange(eThetaUnitType);
		break;
		}
	// ******* Alte Daten verwerfen **********************************************
	bFirstScan = TRUE;
	Steering.Visualising(0,0,0,0,0,0);
	// Scan starten
	switch(eScanType) {
		case Omega2ThetaScan:
		if(bPsdDevice)
			{
			Device->SetSignalGrowUp(TRUE);
			Device->SetAddedChannels(nAddedChannels);
			strcpy(buf,"");
			Steering.StartCmdExecution(Scan,ForAreaScan,Omega2ThetaScan,buf,GetWndHandle());
			}
			else
			{
			bThetaScanCompleted = FALSE;
			mlSetAxis(nTheta);
			mSetRelativeZero(YES,mGetValue(Distance));
			mlSetAxis(nOmega);
			mSetRelativeZero(YES,mGetValue(Distance));
			strcpy(buf,"");
			Steering.StartCmdExecution(AreaScan,Omega2ThetaScan,0,buf,GetWndHandle());
			}
		break;

		case StandardScan:
		if(!bPsdDevice)
			{
			SetInfo("Standard-Scan nur mit PSD");
			return;
			}
		Device->SetSignalGrowUp(TRUE);
		Device->SetAddedChannels(nAddedChannels);
		strcpy(buf,"");
		Steering.StartCmdExecution(Scan,ForAreaScan,StandardScan,buf,GetWndHandle());
		break;
		}
	MainCurve->New();
	bMeasurementActive = TRUE;
	};

//********* Schnittstellen fr Ablaufsteuerung *********************************
void TAreaScan::CounterSetRequest(LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::CounterSetRequest(LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	float   				absorber,channel,psdtheta,peakpos;
	float   				x,y,intens,integral,time;
	char    				buf[2*MaxString],fmt[2*MaxString],msg[MaxString];
	double					dTheta,dOmega;
	static	float 	fMonitorSignal;
	int             nNumOffs = 0;

	if(bShowPsdContinuous)
		{
		strcpy(msg,"Anzeige Psd-Spektrum ...");
		Device->GetData(*MainCurve);
		Device->GetData(integral);
		if(!bCalibrationActive && Device->bDataValid)
			Device->MeasureStart();
		sprintf(fmt,"%s Peak( %s | %s)  Integral Intensity : %s",msg,szTDF,"%.2f","%.2f");
		if(bSecondaryCoor)
			{
			channel = Device->GetMaximumChannel();
			intens 	= Device->GetMaximumIntensity();
			sprintf(buf,fmt,channel,intens,integral);
			}
			else
			{
			MainCurve->GetGravityCenter(psdtheta,intens,channel,2);
			psdtheta += GetThetaOffset(0);
			sprintf(buf,fmt,psdtheta,intens,integral);
			}
		SetInfo(buf);
		UpdateWnd(0);
		return;
		}
	if(bInterrupted) return;
	if(!bMeasurementActive) return;
	switch(eNotifyValue) {
		case MonitorIntensity:
		if(lParam == dlGetIdByName(MonitorDevice))
			{
			Monitor->GetData(fMonitorSignal);
			return;
			}
		break;
		}
	bFileChanged = TRUE;
	dOmega = mlGetValue(nOmega,Distance);
	dTheta = mlGetValue(nTheta,Distance);
	x = (float)dOmega;
	// Theta will be stored in absolute Koordinates
	y = (float)dTheta - dThetaOffset;
	//****************************************************************************
	//**** Datenbasis aktualisieren **********************************************
	//****************************************************************************
	if(bFirstScan)
		nNumOffs = (Device->bDataValid)?0:0;
		else
		nNumOffs = (Device->bDataValid)?0:1;
	switch(eScanType) {
		case Omega2ThetaScan:
		//###########################################################
		if(bPsdDevice)
			{
			if(Device->bDataValid)
				{
				if(bFirstScan)
					bFirstScan = FALSE;
					else
					{
					lpDBase->AddCurve(MainCurve->GetPNumber());
					MainCurve = lpDBase->GetCurve(10000);
					nActiveScan = lpDBase->GetCNumber()-1;
					}
				}
			Device->GetData(*MainCurve);
			Device->GetData(integral);
			if(bAbsorberUsed)
				absorber = mlGetValue(mlGetIdByName(Absorber),Distance);
				else
				absorber = Device->GetMaximumChannel();
			MainCurve->GetGravityCenter(psdtheta,intens,peakpos,2);
			psdtheta += x;
			if(Device->bDataValid)
				{
				switch(eNotifyValue) {
					case MonitorIntensity:
					Monitor->MeasureStop();
					ScanReport->PAdd(x,y,fMonitorSignal);
					break;

					case AbsorberPosition:
					ScanReport->PAdd(x,y,absorber);
					break;

					case MeasurementTime:
					time = Device->dRealTime;
					ScanReport->PAdd(x,y,time);
					break;

					default: case IntegralIntensity:
					ScanReport->PAdd(x,y,integral);
					}
				if(bSaveContinuous)
					UpdateFile();
				Steering.DeviceRequest();
				}
			}
		//###########################################################
			else
			{
			if(bFirstScan)
				bFirstScan = FALSE;
				else
				if(bThetaScanCompleted)
					{
					bThetaScanCompleted = FALSE;
					// save data about last scan
					// MainCurve->SetPP(0);
					// MainCurve->PGet(x,y,z);
					// MainCurve->GetGravityCenter(intens,intens,peakpos,2);
					// ScanReport->PAdd(x,y,intens);
					lpDBase->AddCurve(MainCurve->GetPNumber());
					MainCurve = lpDBase->GetCurve(10000);
					nActiveScan = lpDBase->GetCNumber()-1;
					}
			Device->GetData(intens);
			MainCurve->PAdd(y,intens,y);
			bFileChanged = TRUE;
			if(bSaveContinuous)
				UpdateFile();
			Steering.DeviceRequest();
			}
		break;

		//########################################################################
		case StandardScan:
		if(!bPsdDevice) return;
		if(Device->bDataValid)
			{
			if(bFirstScan)
				bFirstScan = FALSE;
				else
				{
				lpDBase->AddCurve(MainCurve->GetPNumber());
				MainCurve = lpDBase->GetCurve(10000);
				nActiveScan = lpDBase->GetCNumber()-1;
				}
			}
		Device->GetData(*MainCurve);
		Device->GetData(integral);
		if(bAbsorberUsed)
			absorber = mlGetValue(mlGetIdByName(Absorber),Distance);
			else
			absorber = Device->GetMaximumChannel();
		MainCurve->GetGravityCenter(psdtheta,intens,peakpos,2);
		psdtheta += x;
		if(Device->bDataValid)
			{
			switch(eNotifyValue) {
				case MeasurementTime:
				Device->GetData(integral);
				ScanReport->PAdd(x,y,absorber);
				break;

				case MonitorIntensity:
				Monitor->MeasureStop();
				ScanReport->PAdd(x,y,fMonitorSignal);
				break;

				case AbsorberPosition:
				ScanReport->PAdd(x,y,absorber);
				break;

				case PeakPosition:
				ScanReport->PAdd(x,y,peakpos);
				break;

				default: case IntegralIntensity:
				ScanReport->PAdd(x,y,integral);
				}
			bFileChanged = TRUE;
			if(bSaveContinuous)
				UpdateFile();
			Steering.DeviceRequest();
			}
		break;
		}
	//****************************************************************************
	//**** Anzeige fr Signalaufbau aktualisieren ********************************
	//****************************************************************************
//! UpdateWindow:
	switch(eScanType) {
		case Omega2ThetaScan:
		if(!bPsdDevice)
			{
			sprintf(fmt,szMsgLine001,szODF,szTDF);
			sprintf(buf,fmt,dOmega,dTheta,intens);
			if(1 == MainCurve->GetPNumber())
				UpdateWnd(0);
				else
				UpdateWnd(O_PaintPoint);
			}
			else
			{
			#ifdef GermanVersion
			sprintf(fmt,"Messung luft! O:%s T:%s",szODF,szTDF);
			sprintf(buf,"%s P(%s<>%%.1f) Gesamt-Intensitt:%%.1f > %%d",fmt,szTDF);
			#else
			sprintf(fmt,"Measurement ! O:%s T:%s",szODF,szTDF);
			sprintf(buf,"%s P(%s<>%%.1f) Integral Intensity:%%.1f > %%d",fmt,szTDF);
			#endif
			strcpy(fmt,buf);
			nNumOffs += lpDBase->GetCNumber() - 1;
			if(bSecondaryCoor)
				sprintf(buf,fmt,dOmega,dTheta,peakpos,intens,integral,nNumOffs);
				else
				sprintf(buf,fmt,dOmega,dTheta,psdtheta,intens,integral,nNumOffs);
			UpdateWnd(0);
			if(Device->IsSoftOverflow())
				strcat(buf,"  Overflow !");
			}
		break;

		case StandardScan:
		if(!bPsdDevice) return;
		sprintf(fmt,szMsgLine009,szODF);
		sprintf(buf,szMsgLine010,fmt,szTDF);
		strcpy(fmt,buf);
		nNumOffs += lpDBase->GetCNumber() - 1;
		if(bSecondaryCoor)
			sprintf(buf,fmt,dOmega,peakpos,intens,integral,nNumOffs);
			else
			sprintf(buf,fmt,dOmega,psdtheta,intens,integral,nNumOffs);
		UpdateWnd(0);
		if(Device->IsSoftOverflow())
			strcat(buf,"  Overflow !");
		}
	SetInfo(buf);
	};

void TAreaScan::SteeringReady(LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SteeringReady(LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];

	// Funktion behandelt Meldung cm_CmdExecuted
	bMeasurementActive = FALSE;
	Device->MeasureStop();
	// Scan wurde ausgefhrt
	switch(HIWORD(lParam)){
		case R_Failure:
		sprintf(buf,"Es ist ein Fehler aufgetreten. %d",LOWORD(lParam));
		MessageBox(hWndChild,buf,"Fehler",MB_OK);
		break;

		default:
		sprintf(buf,szMsgLine011,lpDBase->GetCNumber());
		SetInfo(buf);
		if(bSaveContinuous)
			// Header aktualisieren
			{
			SaveMeasurementInfo(1);
			SaveReport();
			}
		if(bSaveOnReady)
			if(SaveFile(NoAskForSave))
				sprintf(buf,szMsgLine012);
				else
				sprintf(buf,"Die Messung wurde abgeschlossen. Fehler beim Speichern.");
			else
			sprintf(buf,"Die Messung wurde abgeschlossen.");
		MessageBox(hWndChild,(LPSTR)buf,"Meldung",MBINFO);
		}
	Device->MeasureStop();
	Device->PopSettings();
	Device->SetHost(NULL);
	};

void TAreaScan::ShowSensorContinuous(int type)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::ShowSensorContinuous(int type)\n",time(zidx));
//pph***************************************************************************
	static 	int  	datatype;
	char  				msg[MaxString];

	if(eOutputType != Curve)
		{
		strcpy(msg,"Bitte die Darstellung >Curve< whlen. ");
		MessageBox(hWndChild,msg,"Show Psd-Spectrum",MBSTOP);
		return;
		}
	if(type == 99)
		type = datatype;
	if(!dlIsDeviceValid(PsdDevice))
		{
		MessageBox(GetFocus(),"Kein Psd verfgbar.",szMessage,MBINFO);
		return;
		}
	bShowPsdContinuous = !bShowPsdContinuous;
	lpDList->SetDevice(dlGetIdByName(PsdDevice));
	SetDevice(dlGetDevice());
	Device->MeasureStop();
	if(bShowPsdContinuous)
		{
		// Eingeschrnkte Auflsung einstellen
		Device->SetSignalGrowUp(FALSE);
		Device->SetHost(hWndChild);
		bSecondaryCoor = TRUE;
		datatype = type;
		switch(type) {
			case PsdEnergyData:
			Device->SetDataType(PsdEnergyData);
			CheckMenuItem(TheMenu,cm_ShowPsdE_Data,MF_CHECKED);
			break;

			case PsdPositionData:
			Device->SetDataType(PsdPositionData);
			CheckMenuItem(TheMenu,cm_ShowPsdP_Data,MF_CHECKED);
			}
		Device->MeasureStart();
		}
		else
		{
		//*** switch off visialising
		if(datatype != type)
			{
			bShowPsdContinuous = !bShowPsdContinuous;
			Device->MeasureStart();
			strcpy(msg,"Bitte erst Daueranzeige deaktivieren. ");
			MessageBox(hWndChild,msg,"Show Psd-Spectrum",MBINFO);
			return;
			}
		Device->PopSettings();
		Device->SetHost(NULL);
		Device->MeasureStart();
		bSecondaryCoor = FALSE;
		UpdateWnd(0);
		if(type == PsdEnergyData)
			{
			CheckMenuItem(TheMenu,cm_ShowPsdE_Data,MF_UNCHECKED);
			Device->SetDataType(PsdPositionData);
			}
			else
			CheckMenuItem(TheMenu,cm_ShowPsdP_Data,MF_UNCHECKED);
		}
	};

void TAreaScan::CalibratePsd(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::CalibratePsd(void)\n",time(zidx));
//pph***************************************************************************
	char      	buf[MaxString];
	HWND				holddp;
	TModalDlg*	dlg;
	BOOL      	bsCoor,bshowpsd;

	if(!mlIsAxisValid(Theta) || !dlIsDeviceValid(PsdDevice))
		{
		strcpy(buf,"Hardware ist nicht vollstndig verfgbar !");
		MessageBox(hWndChild,(LPSTR)buf,szMsgFailure,MB_OK);
		return ;
		}
	bCalibrationActive    = TRUE;
	lpDList->SetDevice(dlGetIdByName(PsdDevice));
	SetDevice(dlGetDevice());
	bshowpsd = bShowPsdContinuous;
	if(bShowPsdContinuous)
		ShowSensorContinuous(0);
	bShowPsdContinuous = TRUE;
	holddp = Device->GetDisplay();
	Device->SetDisplay(hWndChild);
	Device->SetSignalGrowUp(FALSE);
	bsCoor                = bSecondaryCoor;
	bSecondaryCoor        = TRUE;
	dlg = (TCalibratePsd*)new TCalibratePsd(*MainCurve);
	dlg->ExecuteDialog(hWndChild);
	delete dlg;
	// lpDList->CalibrateDlg(*MainCurve);
	bShowPsdContinuous = FALSE;
	bSecondaryCoor = bsCoor;
	bCalibrationActive = FALSE;
	Device->SetDisplay(NULL);
	if(bshowpsd)
		ShowSensorContinuous(0);
		else
		{
		Device->SetDisplay(holddp);
		Device->MeasureStart();
		}
	};

void TAreaScan::ExternSychronized(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::ExternSychronized(void)\n",time(zidx));
//pph***************************************************************************
	char      	buf[MaxString];
	HWND				holddp;
	TModalDlg*	dlg;
	BOOL      	bsCoor,bshowpsd;

	if(!mlIsAxisValid(Theta) || !dlIsDeviceValid(PsdDevice))
		{
		strcpy(buf,"Hardware ist nicht vollstndig verfgbar !");
		MessageBox(hWndChild,(LPSTR)buf,szMsgFailure,MB_OK);
		return ;
		}
	lpDList->SetDevice(dlGetIdByName(PsdDevice));
	SetDevice(dlGetDevice());
	holddp = Device->GetDisplay();
	Device->SetDisplay(hWndChild);
	Device->SetSignalGrowUp(TRUE);
  bshowpsd = bShowPsdContinuous;
	bsCoor                = bSecondaryCoor;
	bSecondaryCoor        = TRUE;
	dlg = (TPsdRemoteSync*)new TPsdRemoteSync(*MainCurve);
	dlg->ExecuteDialog(hWndChild);
	delete dlg;
	bSecondaryCoor = bsCoor;
	Device->SetDisplay(NULL);
	if(bshowpsd)
		ShowSensorContinuous(0);
		else
		{
		Device->SetDisplay(holddp);
		Device->MeasureStart();
		}
	};

void  TAreaScan::Interrupt()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::Interrupt()\n",time(zidx));
//pph***************************************************************************
	if(bShowPsdContinuous)
		{
		ShowSensorContinuous(99);
		return;
		}
	if(!bMeasurementActive)
		return;
	TMDIWindow::Interrupt();
	if(!bInterrupted)
		{
		// Messung weiterfren
		Steering.ToggleInterrupt();
		bNewCurveNeeded = FALSE;
		}
		else
		{
		Steering.ToggleInterrupt();
		SetInfo(szMsgLine013);
		}
	};

//******************* Read/Write ***********************************************
int TAreaScan::GetAdditionalColumns(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::GetAdditionalColumns(void)\n",time(zidx));
//pph***************************************************************************
	if(eSaveFormat != ShiftedStandard)
		return 0;
	if(dOmegaWidth == 0.0)
		return 0;
	return GetShift(((dOmegaMax - dOmegaMin) / dOmegaWidth) + 1);
	};

int	TAreaScan::GetShift(int ScanNumber)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::GetShift(int ScanNumber)\n",time(zidx));
//pph***************************************************************************
	if(Device->GetWidth() == 0.0)
		return 0;
	if(eScanType == StandardScan)
		return 0;
	return ScanNumber * (dOmegaWidth * dMoveRelation) / Device->GetWidth();
	};

BOOL TAreaScan::SaveMeasurementInfo(BOOL UpdateHeader)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SaveMeasurementInfo(BOOL UpdateHeader)\n",time(zidx));
//pph***************************************************************************
	int          	hFile;
	UINT         	nSize;
	char         	*data;
	TCurve*			 	Report = lpDBase->GetScanReport();
	char         	buf[MaxString+1],buf2[MaxString / 2],buf3[MaxString / 2];
	char         	format[2*MaxString+1];
	int          	dataoffset = 1000,ival;
	OFSTRUCT     	of;
	struct date  	d;
	struct time  	t;

	if(UpdateHeader)
		hFile = OpenFile(FileName,&of,OF_WRITE);
		else
		hFile = OpenFile(FileName,&of,OF_CREATE);
	if(-1 == hFile)
		{
		LoadString(Main.hInstance,sth_CannotOpenFile,buf,MaxString);
		MessageBox(GetFocus(),buf,szMsgFailure, MB_OK | MB_ICONSTOP);
		return FALSE;
		}
	getdate(&d);
	gettime(&t);
	data = new char[1001];
	strcpy(format,"Comment=%s");
	sprintf(buf,format,Main.Comment);
	strcpy(data,buf); strcat(data,EOL);

	strcat(data,"[Header]"); strcat(data,EOL);
	strcpy(format,"User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d");
	sprintf(buf,format,Main.User,d.da_day,d.da_mon,d.da_year,t.ti_hour,\
											t.ti_min,t.ti_sec);
	strcat(data,buf); strcat(data,EOL);

	switch(eSaveFormat){
		case Tripel:
		strcpy(format,"Scan_Number=%d Point_Number_per_Scan=%d FileType=%d");
		break;

		default:
		strcpy(format,"DataRows=%d DataColumns=%d FileType=%d");
		// HD 960106
		strcat(format,EOL);
		strcat(format,"FirstColumn=0 LastColumns=%d");
		}
	ival = lpDBase->GetCurve(0)->GetPNumber() + GetAdditionalColumns();
	sprintf(buf,format,lpDBase->GetCNumber(),ival,(BOOL)(eSaveFormat==StandardFile),ival-1);
	strcat(data,buf); strcat(data,EOL);

	// aktuelle Bereiche abspeichern
	sprintf(format,"OmegaMin=%s OmegaStep=%s OmegaMax=%s",szODF,szOWF,szODF);
	sprintf(buf,format,Report->Min[P_X],dOmegaWidth,Report->Max[P_X]);
	strcat(data,buf); strcat(data,EOL);
	sprintf(format,"ThetaMin=%s ThetaStep=%s ThetaMax=%s MoveRelation=%%.2f",szTDF,szTWF,szTDF);
	sprintf(buf,format,	Report->Min[P_Y],
											dOmegaWidth * dMoveRelation,
											Report->Max[P_Y],
											dMoveRelation);
	strcat(data,buf); strcat(data,EOL);

	strcpy(format,"Target=%s  Reflection=%s Orientation=%s");
	GetHKL(Main.Reflection,buf2);
	GetHKL(Main.Orientation,buf3);
	sprintf(buf,format,Main.Target,buf2,buf3);
	strcat(data,buf); strcat(data,EOL);
	strcpy(format,"WaveLength=%.3f Current=%d  HV=%d");
	sprintf(buf,format,Main.WaveLength,Main.Current,Main.Voltage);
	strcat(data,buf); strcat(data,EOL);

	if(bPsdDevice)
		{
		strcpy(format,"TimePerScan=%.2f PsdStep=%.6f PsdAddedChannels=%d");
		sprintf(buf,format,fMaxTime,Device->GetWidth(),nAddedChannels);
		strcat(data,buf);
		}
		else
		{
		strcpy(format,"TimePerScan=%.2f");
		sprintf(buf,format,fMaxTime);
		strcat(data,buf);
		}
	nSize = strlen(data);
	for(;nSize < dataoffset-10;nSize++)
		data[nSize] = ' ';
	data[nSize] = 0x0;
	strcat(data,EOL); strcat(data,"[Data]"); strcat(data,EOL);
	_lwrite(hFile,data,strlen(data));
	_lclose(hFile);
	delete[] data;
	return TRUE;
	};

BOOL TAreaScan::SaveFile(int ask)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SaveFile(int ask)\n",time(zidx));
//pph***************************************************************************
	HCURSOR   		hCursor;
	TCurve*    		TheCurve;
	float      		fOmega,fIntensity,fPsdTheta,fTheta;
	float      		d0,d2;
	char       		*buf,fmt[MaxString],msg[MaxString];
	int       		hFile,idx,numbercolumn,nCIdx;
	OFSTRUCT   		of;

	if(!TMDIWindow::SaveFile(ask))
		return FALSE;
	//*** explicite repaint of window, since it's normally not possible.
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(hWndChild,&ps);
	Paint(hdc,&ps);
	EndPaint(hWndChild,&ps);
	//****************************
	if(!SaveMeasurementInfo(0))
		{
		MessageBox(GetFocus(),szMsgLine014,szMsgFailure,MBINFO);
		return FALSE;
		}
	SaveReport();
	hFile     = OpenFile(FileName,&of,OF_WRITE);
	hCursor   = SetCursor(LoadCursor(NULL,IDC_WAIT));
	// Daten an den Header anhngen
	_llseek(hFile,0,SEEK_END);
	// Hier zwischen den einzelnen Formaten whlen
	switch(eSaveFormat) {
		case ShiftedStandard:
		// 1. Scan ist noch nicht mit gltigen Daten belegt
		if(bSaveContinuous && (1 == lpDBase->GetCNumber()))
			break;
		buf = new char [8 * 3000];
		for(nCIdx = 0;nCIdx < lpDBase->GetCNumber();nCIdx++)
			{
			sprintf(buf,"Scan %d von %d schreiben.",nCIdx+1,lpDBase->GetCNumber());
			SetInfo(buf);
			TheCurve = lpDBase->GetCurve(nCIdx);
			TheCurve->SetPP(0);
			TheCurve->FastOpen();
			numbercolumn = GetAdditionalColumns() + MainCurve->GetPNumber();
			for(idx=0;idx < numbercolumn;idx++)
				{
				if(GetShift(nCIdx) <= idx)
					if(TheCurve->FastPGet(d0,fIntensity,d2))
						if(0.0 != fIntensity)
							{
							short pp = 3 - log10(fIntensity);
							strcpy(fmt,"%.3f ");
							if(pp < 0) pp = 0;
							fmt[2] = (char)('0' + pp);
							sprintf(buf,fmt,fIntensity);
							goto Ready2;
							}
				sprintf(buf,"0 ");
				Ready2:
				_lwrite(hFile,(LPSTR)buf,strlen(buf));
				}
			TheCurve->FastClose();
			strcpy(buf,EOL);
			_lwrite(hFile,(LPSTR)buf,strlen(buf));
			}
		delete[] buf;
		break;

		case StandardFile:
		// 1. Scan ist noch nicht mit gltigen Daten belegt
		if(bSaveContinuous && (1 == lpDBase->GetCNumber()))
			break;
		buf = new char [8 * 3000];
		numbercolumn = lpDBase->GetCurve(0)->GetPNumber();
		for(nCIdx = 0;nCIdx < lpDBase->GetCNumber();nCIdx++)
			{
			sprintf(buf,"Scan %d von %d schreiben.",nCIdx+1,lpDBase->GetCNumber());
			SetInfo(buf);
			TheCurve = lpDBase->GetCurve(nCIdx);
			TheCurve->SetPP(0);
			TheCurve->FastOpen();
			for(idx=0;idx < numbercolumn;idx++)
				{
				if(TheCurve->FastPGet(d0,fIntensity,d2))
					while(1)
						{
						if(0.00001 > fIntensity)
							{
							sprintf(msg,"0 ");
							break;
							}
						if(10.0 > fIntensity)
							{
							sprintf(msg,"%.4f ",fIntensity);
							break;
							}
						if(100.0 > fIntensity)
							{
							sprintf(msg,"%.3f ",fIntensity);
							break;
							}
						if(1000.0 > fIntensity)
							{
							sprintf(msg,"%.2f ",fIntensity);
							break;
							}
						sprintf(msg,"%.1f ",fIntensity);
						break;
						}
					else
					strcpy(msg,"0 ");
				if(0 == idx)
					strcpy(buf,msg);
					else
					strcat(buf,msg);
				}
			strcat(buf,EOL);
			TheCurve->FastClose();
			_lwrite(hFile,(LPSTR)buf,strlen(buf));
			}
		delete[] buf;
		break;

		case Tripel:
		// 1. Scan ist noch nicht mit gltigen Daten belegt
		if(bSaveContinuous && (1 == lpDBase->GetCNumber()))
			break;
		nCIdx = 0;
		buf = new char [MaxString];
		ScanReport->SetPP(0);
		ScanReport->FastOpen();
		sprintf(fmt,"%s %s %s %s",szODF,szTDF,"%.3f",EOL);
		while(nCIdx < lpDBase->GetCNumber())
			{
			TheCurve = lpDBase->GetCurve(nCIdx);
			TheCurve->SetPP(0);
			TheCurve->FastOpen();
			ScanReport->FastPGet(fOmega,fTheta,d2);
			while(TheCurve->FastPGet(fPsdTheta,fIntensity,d0))
				{
				if(bThetaAddsPsd)
					fPsdTheta += fTheta;
				sprintf(buf,fmt,fOmega,fPsdTheta,fIntensity);
				_lwrite(hFile,buf,strlen(buf));
				}
			TheCurve->FastClose();
			nCIdx++;
			}
		ScanReport->FastClose();
		delete[] buf;
		break;

		case Bitmap:
		;
		}
	_lclose(hFile);
	SetCursor(hCursor);
	bFileChanged = FALSE;
	return TRUE;
	};

BOOL TAreaScan::UpdateFile(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::UpdateFile(void)\n",time(zidx));
//pph***************************************************************************
	HCURSOR     	hCursor;
	TCurve*     	TheCurve;
	float       	fOmega,fIntensity,fPsdTheta,fTheta;
	float       	d0,d2;
	char        	buf[MaxString],fmt[MaxString];
	int         	hFile,idx,numbercolumn;
	OFSTRUCT    	of;
	//! int						nOldId = mlGetAxis();

	hFile     = OpenFile(FileName,&of,OF_WRITE);
	hCursor   = SetCursor(LoadCursor(NULL,IDC_WAIT));
	_llseek(hFile,0,SEEK_END);
	lpDBase->GetCurve(10000)->SetPP(0);  // first point of last curve
	sprintf(buf,"Scan %d schreiben.",lpDBase->GetCNumber()-1);
	SetInfo(buf);
	switch(eSaveFormat) {
		case StandardFile:
		numbercolumn = lpDBase->GetCurve(0)->GetPNumber();
		TheCurve = lpDBase->GetCurve(10000);
		TheCurve->FastOpen();
		TheCurve->SetPP(0);
		for(idx=0;idx < numbercolumn;idx++)
			{
			if(TheCurve->FastPGet(d0,fIntensity,d2))
				if(0.0 != fIntensity)
					{
					short pp = 3 - log10(fIntensity);
					if(pp < 0) pp = 0;
					strcpy(fmt,"%.3f ");
					fmt[2] = (char)('0'+pp);
					sprintf(buf,fmt,fIntensity);
					goto Ready;
					}
			sprintf(buf,"0 ");
			Ready:
			_lwrite(hFile,(LPSTR)buf,strlen(buf));
			}
		TheCurve->FastClose();
		strcpy(buf,EOL);
		_lwrite(hFile,(LPSTR)buf,strlen(buf));
		break;

		case Tripel:
		ScanReport->BackStep();
		ScanReport->PGet(fOmega,fTheta,d2);
		TheCurve = lpDBase->GetCurve(10000);
		TheCurve->SetPP(0);
		TheCurve->FastOpen();
		sprintf(fmt,"%s %s %s %s",szODF,szTDF,"%.3f",EOL);
		while(TheCurve->FastPGet(fPsdTheta,fIntensity,d0))
			{
			if(bThetaAddsPsd)
				fPsdTheta += fTheta;
			sprintf(buf,fmt,fOmega,fPsdTheta,fIntensity);
			_lwrite(hFile,(LPSTR)buf,strlen(buf));
			}
		TheCurve->FastClose();
		}
	_lclose(hFile);
	SetCursor(hCursor);
	bFileChanged = FALSE;
	return TRUE;
	};

BOOL TAreaScan::SaveReport(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::SaveReport(void)\n",time(zidx));
//pph***************************************************************************
	HCURSOR    hCursor;
	float      fOmega,fReport,fTheta;
	char       buf[MaxString];
	char       fmt[MaxString];
	int        hFile,cnt;
	OFSTRUCT   of;
	char       fn[MAXPATH];
	char       drive[MAXDRIVE],path[MAXDIR],name[MAXFILE],ext[MAXEXT];

	fnsplit(FileName,drive,path,name,ext);
	fnmerge(fn,drive,path,name,"rep");
	hFile     = OpenFile(fn,&of,OF_CREATE);
	hCursor   = SetCursor(LoadCursor(NULL,IDC_WAIT));
	switch(eNotifyValue) {
		case MonitorIntensity:
		sprintf(buf,"# Report: ScanId Omega : Theta : Monitor Signal");
		break;
		case MeasurementTime:
		sprintf(buf,"# Report: ScanId Omega : Theta : MeasurementTime");
		break;
		case AbsorberPosition:
		sprintf(buf,"# Report: ScanId Omega : Theta : AbsorberPosition");
		break;
		case PeakPosition:
		sprintf(buf,"# Report: ScanId Omega : Theta : PeakPosition");
		break;
		default: case IntegralIntensity:
		sprintf(buf,"# Report: ScanId Omega : Theta : Integral Intensity");
		break;
		}
	strcat(buf,EOL);
	_lwrite(hFile,(LPSTR)buf,strlen(buf));
	ScanReport->SetPP(0);
	ScanReport->FastOpen();
	cnt = 0;
	sprintf(fmt,"%s %s %s %s %s","%d",szODF,szTDF,"%.3f",EOL);
	while(ScanReport->FastPGet(fOmega,fTheta,fReport))
		{
		sprintf(buf,fmt,cnt,fOmega,fTheta,fReport);
		_lwrite(hFile,(LPSTR)buf,strlen(buf));
		cnt++;
		}
	_lclose(hFile);
	ScanReport->FastClose();
	SetCursor(hCursor);
	return TRUE;
	};

BOOL TAreaScan::LoadReport(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::LoadReport(void)\n",time(zidx));
//pph***************************************************************************
	HCURSOR     hCursor;
	float       fOmega,fPeakPos,fTheta;
	char        *data;
	HFILE       hFile;
	char        line[MaxString];
	int         cnt;
	UINT        wSize;
	OFSTRUCT    of;
	char        fn[MAXPATH];
	char        drive[MAXDRIVE],path[MAXDIR],name[MAXFILE],ext[MAXEXT];

	fnsplit(FileName,drive,path,name,ext);
	fnmerge(fn,drive,path,name,"rep");
	hFile = OpenFile(fn,&of,OF_READ);
	if(-1 == hFile)
		return FALSE;
	hCursor   = SetCursor(LoadCursor(NULL,IDC_WAIT));
	data = new char [25000];
	wSize = (int)_llseek(hFile,0,2);
	_llseek(hFile,0,0);
	wSize = _lread(hFile,(LPSTR)data,wSize);
	_lclose(hFile);
	data[wSize] = '\0';
	// erste Zeile verwerfen
	GetBufferLine(data,line,MaxString);
	ScanReport->FastOpen();
	while(GetBufferLine(NULL,line,MaxString))
		{
		if(!strlen(line))
			continue;
		sscanf(line,"%d %f %f %f",&cnt,&fOmega,&fTheta,&fPeakPos);
		ScanReport->FastPAdd(fOmega,fTheta,fPeakPos);
		}
	delete[] data;
	ScanReport->FastClose();
	SetCursor(hCursor);
	if(3 > ScanReport->GetPNumber())
		return FALSE;
	return TRUE;
	};

BOOL TAreaScan::LoadMeasurementInfo(HFILE hFile)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::LoadMeasurementInfo(HFILE hFile)\n",time(zidx));
//pph***************************************************************************
	char        header[2048];
	UINT        wReadCnt;
	int					columns;
	char        *token,*info,*keyword;
	BOOL        retval = FALSE,bCheckHeader = FALSE;

	nFirstReadColumn = nLastReadColumn = 0;
	// Header-Marke suchen
	_llseek(hFile,0,0);
	wReadCnt = _lread(hFile,(LPSTR)header,2048);
	if(wReadCnt < 50)
		goto Exit;  // File korrupt
	token = strtok(header," \r\n");
	do
		{
		if(strstr(token,"[Header]"))
			break;
		token = strtok(NULL," \r\n");
		if(!token)
			goto Exit; // Kein Header enthalten
		}
		while(1);
	dThetaOffset = 0.0;
	// Header-Informationen auswerten
	while(1) {
		keyword = strtok(NULL," =\n\r"); info = strtok(NULL," =\n\r");
		if(	!strcmp("Date",keyword) ||
				!strcmp("DataRows",keyword) ||
				!strcmp("Time",keyword) ||
				!strcmp("HV",keyword)
				)
			continue;
		if(!strcmp("User",keyword))
			{
			strcpy(Main.User,info);
			continue;
			}
		if(!strcmp("Target",keyword))
			{
			strcpy(Main.Target,info);
			continue;
			}
		if(!strcmp("Substrat",keyword))
			{
			strcpy(Main.TargetBulk,info);
			continue;
			}
		if(!strcmp("Reflection",keyword))
			{
			SetHKL(Main.Reflection,info);
			continue;
			}
		if(!strcmp("Orientation",keyword))
			{
			SetHKL(Main.Orientation,info);
			continue;
			}
		if(!strcmp("DataColumns",keyword))
			{
			columns = atof(info);
			continue;
			}
		if(!strcmp("FirstColumn",keyword))
			{
			nFirstReadColumn = atof(info);
			continue;
			}
		if(!strcmp("LastColumn",keyword))
			{
			nLastReadColumn = atof(info);
			continue;
			}
		if(!strcmp("WaveLength",keyword))
			{
			Main.WaveLength = atof(info);
			continue;
			}
		if(!strcmp("PsdStep",keyword))
			{
			::fPsdRange = atof(info);
			continue;
			}
		if(!strcmp("ThetaMin",keyword))
			{
			dThetaMin = atof(info);
			continue;
			}
		if(!strcmp("MoveRelation",keyword))
			{
			dMoveRelation = atof(info);
			continue;
			}
		if(!strcmp("OmegaMin",keyword))
			{
			dOmegaMin = atof(info);
			continue;
			}
		if(!strcmp("OmegaStep",keyword))
			{
			dOmegaWidth = atof(info);
			continue;
			}
		if(!strcmp("TimePerScan",keyword))
			{
			fMaxTime = atof(info);
			continue;
			}
		if(!strcmp("PsdAddedChannels",keyword))
			{
			nAddedChannels = atoi(info);
			continue;
			}
		if(!strcmp(keyword,"FileType"))
			{
			if(*info == '1')
				eSaveFormat = StandardFile;
				else
				goto Exit; // Falsches File-Format
			continue;
			}

		if(strstr(keyword,"[Data]"))
			break;
		if(strstr(info,"[Data]"))
			break;
		}
	// check infos
	if(!nLastReadColumn)
		nLastReadColumn = columns;
		else
		if(nLastReadColumn > columns)
			nLastReadColumn = columns;
	if(!nFirstReadColumn)
		nFirstReadColumn = 0;
	if(!dOmegaWidth)
		bCheckHeader = TRUE;
	dThetaOffset = dOmegaMin * dMoveRelation - dThetaMin;
	if(bCheckHeader)
		{
		MessageBox(GetFocus(),szMsgLine014,szMsgFailure,MBINFO);
		goto Exit;
		}
	retval = TRUE;
	Exit:
	return retval;
	};

BOOL TAreaScan::LoadOldData(int)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAreaScan::LoadOldData(int)\n",time(zidx));
//pph***************************************************************************
	char        buf[MAXPATH];
	HFILE       hFile;
	TCurve*     TheCurve;
	HPSTR				daten;
	HCURSOR     hCursor;
	float       omega,theta,intens,channel;
	int         cnt,column;
	HGLOBAL     hMem;
	DWORD       dwReadCnt;
	OFSTRUCT    of;
	BOOL        retval = FALSE;

	chdir(szDataPath);
	sprintf(buf,"*.%s",szExtension);
	FileOpen("File nachladen",szFilter,buf,szDataPath);
	if(buf[0] == '*')
		return FALSE;
	if(!strcmp(strupr(&(buf[strlen(buf)-3])),"BMP"))
		{
		strcpy(buf,"*.bmp");
		hFile = OpenFile(buf,&of,OF_READ);
		retval = BSource->ProcessBitmapFile(hFile);
		_lclose(hFile);
		return retval;
		}
	if(strcmp(strupr(&(buf[strlen(buf)-3])),"PSD"))
		return FALSE;
	//*** clear data base
	lpDBase->New();
	strcpy(FileName,buf);
	nActiveScan = 0;
	MainCurve = lpDBase->GetCurve(nActiveScan);
	UpdateWnd(0);
	//*** explicite repaint of window, since it's normally not possible.
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(hWndChild,&ps);
	Paint(hdc,&ps);
	EndPaint(hWndChild,&ps);
	//*** open file and allocate of memory for read buffer
	hFile = OpenFile(FileName,&of,OF_READ);
	dwReadCnt = _llseek(hFile,0,2);
	//*** load header information
	if(!LoadMeasurementInfo(hFile))
		{
		MessageBox(GetFocus(),szMsgLine014,szMsgFailure,MBINFO);
		return FALSE;
		}
	if(!SetFPOnData(hFile)) return FALSE;
	hMem      = GlobalAlloc(GMEM_MOVEABLE,dwReadCnt+100);
	daten     = (HPSTR)GlobalLock(hMem);
	hCursor   = SetCursor(LoadCursor(NULL,IDC_WAIT));
	dwReadCnt = _hread(hFile,(HPSTR)daten,dwReadCnt);
	daten[dwReadCnt-2] = '\0';
	daten[dwReadCnt-1] = '\0';
	daten[dwReadCnt] = '\0';
	_lclose(hFile);
	// read of old data
	while(1)
		{
		if(!(lpDBase->GetCNumber() % 5))
			{
			sprintf(buf,"%d Scan's gelesen",lpDBase->GetCNumber());
			SetInfo(buf);
			}
		TheCurve = lpDBase->GetCurve(10000);
		TheCurve->FastOpen();
		channel = theta = 0.0;
		column = 0;
		while(1)
			{
			cnt = 0;
			while(1)
				{
				if(*(daten+cnt) == ' ') break;
				if(*(daten+cnt) == '\t') break;
				if(*(daten+cnt) == '\r') break;
				if(*(daten+cnt) == '\n') break;
				if(*(daten+cnt) == '\0') goto Exit;
				cnt++;
				}
#ifdef __WIN32__
			memcpy((HPSTR)buf,(HPSTR)daten,(long)cnt);
#else
			memcpy((HPSTR)buf,(HPSTR)daten,cnt);
#endif
			daten += cnt;
			buf[cnt] = 0;
			intens = atof(buf);
			if(column <= nLastReadColumn)
				{
				if(column >= nFirstReadColumn)
					TheCurve->FastPAdd(theta,intens,channel);
				column++;
				channel += nAddedChannels;
				theta 	+= ::fPsdRange; // contains here the PsdStep
				}
			while(*daten == ' ') daten++;
			while(*daten == '\t') daten++;
			if(*daten == '\r')  break;
			if(*daten == '\n') 	break;
			if(*daten == '\0') 	goto Exit;
			}
		daten++;
		if((*daten == '\r') || (*daten == '\n'))
			daten++;
		TheCurve->FastClose();
		lpDBase->AddCurve(nLastReadColumn - nFirstReadColumn + 10);
		}
Exit:
	::fPsdRange = TheCurve->Max[0] - TheCurve->Min[0];
	//*** Generation of ScanRep from ranges witch corrections of measurement area
	{
	omega 			= dOmegaMin;
	theta 			= omega * dMoveRelation;
	intens 			= -1.0;
	dThetaWidth = dOmegaWidth * dMoveRelation;
	dOmegaMax		= dOmegaMin + dOmegaWidth * (lpDBase->GetCNumber()-1);
	ScanReport->New();
	ScanReport->FastOpen();
	for(cnt = 0;cnt < lpDBase->GetCNumber();cnt++)
		{
		ScanReport->FastPAdd(omega,theta,intens);
		omega += dOmegaWidth;
		theta += dThetaWidth;
		}
	ScanReport->FastClose();
	}
	//*** format data for output
	SetCursor(hCursor);
	bFileChanged = FALSE;
	bIsNewFile  = FALSE;
	if(eOutputType <= MatrixBitmap)
		BSource->FormatDBaseToBitmapSource();
	UpdateWnd(0);
	SetInfo("Altes Datenfile wurde gelesen.");
	GlobalUnlock(hMem);
	GlobalFree(hMem);
#ifdef Peak_and_Cross
	//**** Daten aquirieren Peak- und Cross-Scan speichern ***********************
	{
	float   psdtheta,intens,channel,maxintens = 0.0;
	int     maxcu,maxch;

	XShift = 0.0;
	for(Idx=0;Idx < lpDBase->GetCNumber();Idx++)
		{
		TheCurve = lpDBase->GetCurve(Idx);
		TheCurve->GetGravityCenter(psdtheta,intens,channel,2);
		if(intens > maxintens)
			{
			maxintens = intens;
			maxcu  = Idx;
			maxch  = channel;
			}
		}
	TheCurve = lpDBase->GetCurve(maxcu);
	*SecondCurve = *TheCurve;
	SaveSecondCurve();
	SecondCurve->Delete();
	for(Idx=0;Idx < lpDBase->GetCNumber();Idx++)
		{
		TheCurve = lpDBase->GetCurve(Idx);
		TheCurve->SetPP(maxch);
		TheCurve->PGet(psdtheta,intens,channel);
		psdtheta = OmegaMin + Idx * OmegaWidth;
		SecondCurve->PAdd(psdtheta,intens,channel);
		}
	// Speichern der Curven
	SaveSecondCurve();
	}
#endif
	bOldDataLoaded = TRUE;
	return retval;
	};
//******************************************************************************
//******* Dialog zum Messen mit PSD unter externer Sychronisation **************
//******************************************************************************
TPsdRemoteSync::TPsdRemoteSync(TCurve& curve) : TModalDlg("PSDRemoteSync")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TModalDlg(PSDRemoteSync)\n",time(zidx));
//pph***************************************************************************
	Curve = &curve;    // MainCurve vom Daten-Fenster
	hDlgItem        = NULL;
	bCalibrationOk  = FALSE;
	if(!strlen(aTempPath))
		strcpy(aTempPath,"c:\\Work\\");
	strcpy(aPath,aTempPath);
	if(!strlen(aTempName))
		strcpy(aTempName,"GESI_474");
	strcpy(aName,aTempName);
	nAskTime        = 80;
	nCurveCount			= 0;
	Device		      = lpDList->DP(dlGetIdByName(PsdDevice));
	if(Device)
		Device->GetExposureValues(fExposureTime,dwExposureCounts,fError);
	};

#pragma argsused
BOOL TPsdRemoteSync::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	if(!Device)
		return FALSE;
	Device->MeasureStop();
	Device->SetHost(GetHandle());
	Device->SetSignalGrowUp(TRUE);
	// External Sync
	// Die Mezeit wird quasi auf unendlich gestellt
	// Ein Abbruch der Messung wird durch ein explizites ndern der Exposure-
	// Time erreicht.
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	hDlgItem = NULL;
	return TRUE;
	};

void TPsdRemoteSync::Dlg_OnTimer(HWND hwnd,UINT id)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::Dlg_OnTimer(HWND hwnd,UINT id)\n",time(zidx));
//pph***************************************************************************
	switch(id) {
		case TimerIdInformation:
		KillTimer(hwnd,TimerIdInformation);
		// Messung starten
		// Messung stoppen
		}
	return;
	};

void TPsdRemoteSync::PrintFileName(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::PrintFileName(void)\n",time(zidx));
//pph***************************************************************************
	char	aBuf[20];

	SetDlgItemText(GetHandle(),IDC_DirPSDCycle,aPath);
	SetDlgItemText(GetHandle(),IDC_TargetName,aName);
	sprintf(aBuf,".%03d",nCurveCount);
	SetDlgItemText(GetHandle(),IDC_Extension,aBuf);
	};

LPCSTR	TPsdRemoteSync::GetFileName(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::GetFileName(void)\n",time(zidx));
//pph***************************************************************************
	sprintf(aFileName,"%s\\%s.%03d",aPath,aName,nCurveCount);
	return aFileName;
	};

void TPsdRemoteSync::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	switch(id)
		{
		case cm_ParamSet:
		PrintFileName();
		if(Device)
			SetDlgItemText(hwnd,IDC_Messages,"Initialisation OK");
		break;

		case cm_CounterSet:
		Device->UpdateDisplay();
		if(Curve->Save(GetFileName(),100,2))
			{
			PrintFileName();
			Device->SetExposureValues(fExposureTime,dwExposureCounts,fError);
			SetDlgItemText(hwnd,IDC_Messages,"Scan acquisition was ok");
			break;
			}
		SetDlgItemText(hwnd,IDC_Messages,"Scan acquisition failed");
		break;

		case IDC_StopPSDCycle:
		KillTimer(hwnd,TimerIdInformation);
		break;

		case IDC_InterruptPSDCycle:
		KillTimer(hwnd,TimerIdInformation);
		break;

		case IDC_StartPSDCycle:
		GetDlgItemText(hwnd,IDC_DirPSDCycle,aPath,10);
		strcpy(aTempPath,aPath);
		GetDlgItemText(hwnd,IDC_TargetName,aName,10);
		strcpy(aTempName,aName);
		// check whether exist or not writable

		SetTimer(hwnd,TimerIdInformation,100,NULL);
		break;


		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TPsdRemoteSync::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};

BOOL TPsdRemoteSync::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TPsdRemoteSync::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	KillTimer(GetHandle(),TimerIdInformation);
	Device->MeasureStop();
	Device->SetExposureValues(fExposureTime,dwExposureCounts,fError);
	Device->SetHost(NULL);
	return TRUE;
	};

//******************************************************************************
//******* Dialog zum Kalibrieren des Psd ***************************************
//******************************************************************************
TCalibratePsd::TCalibratePsd(TCurve &curve) : TModalDlg("CalibratePsd")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TModalDlg(CalibratePsd)\n",time(zidx));
//pph***************************************************************************
	Curve = &curve;    // MainCurve vom Daten-Fenster
	hDlgItem        = NULL;
	bLongMove       = FALSE;
	LeftPeak.Valid  = FALSE;
	RightPeak.Valid = FALSE;
	bGetRightPeak   = FALSE;
	bGetLeftPeak    = FALSE;
	bMoveActive     = FALSE;
	bCalibrationOk  = FALSE;
	nAskTime        = 80;
	Device		      = lpDList->DP(dlGetIdByName(PsdDevice));
	nMotor        	= mlGetIdByName(Theta);
	mlSetAxis(nMotor);
	// Die Schrittweite des Psd dAngleStep wird stets in Winkelsekunden angegeben.
	if(Grad == mGetUnitType())
		fRelationFactor  = 1.0 / 3600.0;
		else
		if(Minuten == mGetUnitType())
			fRelationFactor  = 1.0 / 60.0;
			else
			fRelationFactor  = 1.0;
	};

#pragma argsused
BOOL TCalibratePsd::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	dOldMotorWidth = mGetValue(Width);
	mSetValue(Width,1800.0 * fRelationFactor);
	Device->MeasureStop();
	Device->SetAddedChannels(2);
	Device->SetHost(GetHandle());
	Device->SetExposureValues(2.0,10000,0.02);
	Device->MeasureStart();
	Delay(5000);
	hBar = GetDlgItem(GetHandle(),id_Bar);
	SetTimer(GetHandle(),TimerIdInformation,nAskTime,NULL);
	FORWARD_WM_COMMAND(hwnd,cm_MotorInit,hwndCtl,0,SendMessage);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	hDlgItem = NULL;
	return TRUE;
	};

void TCalibratePsd::Dlg_OnTimer(HWND hwnd,UINT id)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::Dlg_OnTimer(HWND hwnd,UINT id)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	double	dDistance;

	switch(id) {
		case TimerIdInformation:
		KillTimer(hwnd,TimerIdInformation);
		SetCursor(LoadCursor(NULL,IDC_WAIT));
		if(mIsMoveFinish())
			{
			if(!mGetDistance(dDistance))
				{
				SetTimer(hwnd,TimerIdInformation,nAskTime,NULL);
				return;
				}
			sprintf(buf,mGetDF(),dDistance);
			SetDlgItemText(hwnd,id_NewAngle,buf);
			sprintf(buf,mGetDF(),dDistance);
			SetDlgItemText(hwnd,id_Angle,buf);
			SetScrollPos(hBar,SB_CTL,GetBarPos(),TRUE);
			bMoveActive = FALSE;
			SetCursor(LoadCursor(NULL,IDC_ARROW));
			}
			else
			{
			if(bLongMove)
				{
				mGetDistance(dDistance);
				sprintf(buf,mGetDF(),dDistance);
				SetDlgItemText(hwnd,id_Angle,buf);
				SetScrollPos(hBar,SB_CTL,GetBarPos(),TRUE);
				}
			SetTimer(hwnd,TimerIdInformation,nAskTime,NULL);
			}
		}
	return;
	};

void TCalibratePsd::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char            buf[MaxString];
	float           val_f,channel,dd;
	static int      MsgCnt = FALSE;

	switch(id)
		{
		case cm_ParamSet:
		SetDlgItemText(GetHandle(),id_Unit,mGetAxisUnit());
		sprintf(buf,"%.3f",Device->GetAngleStep());
		SetDlgItemText(GetHandle(),id_StepWidth,buf);
		// Initialisieren des Motor-Scroll-Bar's
		SetScrollRange(hBar,SB_CTL,GetBarEgde(LEFT),GetBarEgde(RIGHT),TRUE);
		SetFocus(hBar);
		break;

		case cm_MotorInit:
		mActivateDrive();
		// Initialisieren des Positions-Eingabefenster's
		bMoveActive = TRUE;
		SetTimer(GetHandle(),TimerIdInformation,nAskTime,NULL);
		break;

		case cm_CounterSet:
		Device->UpdateDisplay();
		if(bGetRightPeak)
			{
			Curve->GetGravityCenter(dd,dd,channel,2);
			RightPeak.Pt[0] = channel;
			RightPeak.Valid = TRUE;
			bGetRightPeak = FALSE;
			if(LeftPeak.Valid)
				{
				val_f = (LeftPeak.Pt[1] - RightPeak.Pt[1]);
				if(val_f == 0.0)
					{
					RightPeak.Valid = FALSE;
					bGetRightPeak = TRUE;
					}
					else
					{
					if(0 != (RightPeak.Pt[0] - LeftPeak.Pt[0]))
						{
						val_f = val_f / (RightPeak.Pt[0] - LeftPeak.Pt[0]) / fRelationFactor;
						Device->SetAngleStep(val_f);
						}
						else
						MessageBox(GetFocus(),"Vorgang bitte wiederholen !",szMsgFailure,MBINFO);
					}
				}
			EnableWindow(GetDlgItem(GetHandle(),cm_RightPositionReached),bGetRightPeak);
			}
		if(bGetLeftPeak)
			{
			Curve->GetGravityCenter(dd,dd,channel,2);
			LeftPeak.Pt[0] = channel;
			LeftPeak.Valid = TRUE;
			bGetLeftPeak  = FALSE;
			if(RightPeak.Valid)
				{
				val_f = (LeftPeak.Pt[1] - RightPeak.Pt[1]);
				if(val_f == 0.0)
					{
					LeftPeak.Valid = FALSE;
					bGetLeftPeak = TRUE;
					}
					else
					{
					if(0 != (RightPeak.Pt[0] - LeftPeak.Pt[0]))
						{
						val_f = val_f / (RightPeak.Pt[0] - LeftPeak.Pt[0]) / fRelationFactor;
						Device->SetAngleStep(val_f);
						}
						else
						MessageBox(GetFocus(),"Vorgang bitte wiederholen !","Fehler",MBINFO);
					}
				}
			EnableWindow(GetDlgItem(GetHandle(),cm_LeftPositionReached),bGetLeftPeak);
			}
		sprintf(buf,"%.3f",Device->GetAngleStep());
		SetDlgItemText(GetHandle(),id_StepWidth,buf);
		Device->SetAddedChannels(2);
		Device->MeasureStart();
		break;

		case cm_RightPositionReached:
		if(bMoveActive)
			break;
		Device->MeasureStop();
		bGetRightPeak = TRUE;
		bGetLeftPeak  = FALSE;
		RightPeak.Pt[1] = mGetValue(Distance);
		Device->SetAddedChannels(1);
		Device->MeasureStart();
		SetFocus(hBar);
		break;

		case cm_LeftPositionReached:
		if(bMoveActive)
			break;
		Device->MeasureStop();
		bGetRightPeak = FALSE;
		bGetLeftPeak  = TRUE;
		LeftPeak.Pt[1] = mGetValue(Distance);
		Device->SetAddedChannels(1);
		Device->MeasureStart();
		SetFocus(hBar);
		break;

		case id_NewAngle:
		hDlgItem = GetDlgItem(GetHandle(),id_NewAngle);
		MsgCnt--;
		if(MsgCnt == 1)
			{
			hDlgItem = NULL;
			MsgCnt = 0;
			}
		break;

		case IDOK:
		if(!hDlgItem)
			{
			TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
			break;
			}
		// Der Nutzer hat mit Return eine neue Position eingegeben
		if(hDlgItem == GetDlgItem(GetHandle(),id_NewAngle))
			{
			mStopDrive(TRUE);
			GetDlgItemText(GetHandle(),id_NewAngle,buf,10);
			bLongMove = TRUE;
			mMoveToDistance(atof(buf));
			FORWARD_WM_COMMAND(hwnd,cm_MoveButton,hwndCtl,0,SendMessage);
			MsgCnt = 3;
			}
		hDlgItem = NULL;
		SetFocus(hBar);
		break;

		case cm_MoveButton:
		if(bMoveActive)
			break;
		bMoveActive = TRUE;
		SetTimer(GetHandle(),TimerIdInformation,nAskTime,NULL);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

#pragma argsused
void TCalibratePsd::Dlg_OnHScrollBar(HWND hwnd, HWND hwndCtl, UINT code, int pos)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::Dlg_OnHScrollBar(HWND hwnd, HWND hwndCtl, UINT code, int pos)\n",time(zidx));
//pph***************************************************************************
	switch(code) {
		case SB_LINEUP:
		if(bMoveActive)
			break;
		mMoveToDistance(mGetValue(Distance) - mGetValue(Width));
		FORWARD_WM_COMMAND(hwnd,cm_MoveButton,hwndCtl,0,SendMessage);
		break;

		case SB_LINEDOWN:
		if(bMoveActive)
			break;
		mMoveToDistance(mGetValue(Distance) + mGetValue(Width));
		FORWARD_WM_COMMAND(hwnd,cm_MoveButton,hwndCtl,0,SendMessage);
		break;

		case SB_ENDSCROLL: case SB_PAGEUP: case SB_PAGEDOWN:
		break;
		}
	};

int TCalibratePsd::GetBarEgde(int side)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::GetBarEgde(int side)\n",time(zidx));
//pph***************************************************************************
	int steps,ret;
	// Geht vom symmetrischen Fall aus
	if(side == LEFT)
		{
		steps = (int)(mGetValue(MinDistance) / mGetValue(Width));
		BarFactor = (abs(steps)<20000)?1:2;
		ret = steps / BarFactor;
		}
		else
		{
		ret = (mGetValue(MaxDistance) / (mGetValue(Width) * BarFactor));
		}
	return ret;
	};

int TCalibratePsd::GetBarPos()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::GetBarPos()\n",time(zidx));
//pph***************************************************************************
	int ret;

	ret = ((mGetValue(Distance))/(mGetValue(Width) * BarFactor));
	return ret;
	};

BOOL TCalibratePsd::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char  buf[MaxString];
	char  ident[MaxString];

	if(Device->GetAngleStep() == 0.0)
		{
		MessageBeep(0);
		return FALSE;
		}
	sprintf(buf,"%.5f",Device->GetAngleStep());
	sprintf(ident,"Device%d",Device->GetId());
	WritePrivateProfileString(ident,"AngleStep",buf,GetCFile());
	return TRUE;
	};

BOOL TCalibratePsd::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TCalibratePsd::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	KillTimer(GetHandle(),TimerIdInformation);
	Device->MeasureStop();
	Device->SetHost(NULL);
	return TRUE;
	};
//******************************************************************************
//******* Dialog zum Auswhlen von Scan's **************************************
//******************************************************************************
TChooseScan::TChooseScan(TAreaScan* ascan) : TModelessDlg("ChooseScan")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TModelessDlg(ChooseScan)\n",time(zidx));
//pph***************************************************************************
	AScan = ascan;
	Report = AScan->ScanReport;
	};

BOOL TChooseScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TChooseScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)\n",time(zidx));
//pph***************************************************************************
	char   buf[MaxString];

	nMaxScan = lpDBase->GetCNumber() - 1;
	sprintf(buf,"%d",nMaxScan);
	SetDlgItemText(hwnd,id_Limit,buf);
	BarHandle = GetDlgItem(hwnd,id_Bar);
	SetScrollRange(BarHandle,SB_CTL,0,nMaxScan,TRUE);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	return(TRUE);
	};

void TChooseScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TChooseScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	float   x,y,z;

	switch(id)
		{
		case id_CurveShow:
		GetDlgItemText(hwnd,id_ScanNumber,buf,MaxString);
		lpDBase->SetCIdx(atoi(buf));
		FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
		break;

		case cm_ParamSet:
		AScan->nActiveScan = lpDBase->GetCIdx();
		AScan->MainCurve = lpDBase->GetCurve(AScan->nActiveScan);
		sprintf(buf,"%d",AScan->nActiveScan);
		SetDlgItemText(hwnd,id_ScanNumber,buf);
		SetScrollPos(BarHandle,SB_CTL,nMaxScan - AScan->nActiveScan,TRUE);
		Report->SetPP(AScan->nActiveScan);
		Report->PGet(x,y,z);
		sprintf(buf,"%.3f",y);
		SetDlgItemText(hwnd,id_Omega,buf);
		Curve = AScan->MainCurve;
		sprintf(buf,"%.3f",Curve->Max[1]);
		SetDlgItemText(hwnd,id_PeakIntensity,buf);
		AScan->UpdateWnd(0);
		break;

		default:
		TModelessDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

#pragma argsused
void TChooseScan::Dlg_OnLButtonUp(HWND hwnd,int,int,UINT)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TChooseScan::Dlg_OnLButtonUp(HWND hwnd,int,int,UINT)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];

	nMaxScan = lpDBase->GetCNumber() - 1;
	sprintf(buf,"%d",nMaxScan);
	SetDlgItemText(hwnd,id_Limit,buf);
	BarHandle = GetDlgItem(hwnd,id_Bar);
	SetScrollRange(BarHandle,SB_CTL,0,nMaxScan,TRUE);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
	};

#pragma argsused
void TChooseScan::Dlg_OnVScrollBar(HWND hwnd,HWND hwndCtl,UINT code,int pos)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TChooseScan::Dlg_OnVScrollBar(HWND hwnd,HWND hwndCtl,UINT code,int pos)\n",time(zidx));
//pph***************************************************************************
	switch(code)
		{
		case SB_LINEUP:
		lpDBase->SetCIdx(AScan->nActiveScan + 1);
		break;

		case SB_LINEDOWN:
		lpDBase->SetCIdx(AScan->nActiveScan - 1);
		break;

		case SB_THUMBPOSITION:
		lpDBase->SetCIdx(nMaxScan - pos);
		break;

		case SB_ENDSCROLL:
		FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
		break;

		case SB_PAGEUP:
		lpDBase->SetCIdx(AScan->nActiveScan + 10);
		break;

		case SB_PAGEDOWN:
		lpDBase->SetCIdx(AScan->nActiveScan - 10);
		break;
		}
	};

BOOL TChooseScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TChooseScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};
//##############################################################################

//******************************************************************************
//******* Dialog zum Setzen der AreaScan-Parameter *****************************
//******************************************************************************
#ifdef GermanVersion
TSetupAreaScan::TSetupAreaScan(TAreaScan* scan) : TModalDlg("AreaScanParameters")
#else
TSetupAreaScan::TSetupAreaScan(TAreaScan* scan) : TModalDlg("AreaScanParametersEng")
#endif
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		#endif\n",time(zidx));
//pph***************************************************************************
	Scan			  = scan;
	nOmega     	= Scan->nOmega;
	nTheta    	= Scan->nTheta;
	Device      = Scan->Device;
	nOldMotor		= mlGetAxis();
	if(Scan->bPsdDevice)
		Device->SetAddedChannels(Scan->nAddedChannels);
	};

#pragma argsused
BOOL TSetupAreaScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TSetupAreaScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	int       i = 0;
	char      buf[MaxString];

	CheckDlgButton(hwnd,id_SaveOnReady,Scan->bSaveOnReady);
	CheckDlgButton(hwnd,id_AbsorberUsed,Scan->bAbsorberUsed);
	if(Scan->bPsdDevice)
		CheckDlgButton(GetHandle(),id_FixThetaAxis,FALSE);
		else
		CheckDlgButton(GetHandle(),id_FixThetaAxis,TRUE);
	sprintf(buf,"%.1f",Scan->fMaxTime);
	SetDlgItemText(GetHandle(),id_MaxTime,buf);
	mlSetAxis(nTheta);
	SetDlgItemText(GetHandle(),id_ThetaUnit,mGetAxisUnit());
	mlSetAxis(nOmega);
	SetDlgItemText(GetHandle(),id_Unit,mGetAxisUnit());
	sprintf(buf,mGetDF(),Scan->dOmegaMax);
	SetDlgItemText(GetHandle(),id_AngleMax,buf);
	sprintf(buf,mGetDF(),Scan->dOmegaMin);
	SetDlgItemText(GetHandle(),id_AngleMin,buf);
	sprintf(buf,"%lu",Scan->dwMaxCounts);
	SetDlgItemText(GetHandle(),id_MaxCounts,buf);
	CheckDlgButton(GetHandle(),id_Standard,Scan->eSaveFormat == StandardFile);
	CheckDlgButton(GetHandle(),id_DIB_Format,Scan->eSaveFormat == Bitmap);
	hDeviceList = GetDlgItem(GetHandle(),id_ChooseDevice);
	i=0;
	while(i <= lpDList->LastId())
		ComboBox_AddString(hDeviceList,lpDList->DP(i++)->Characteristic);
	ComboBox_SelectString(hDeviceList,0,Device->Characteristic);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	FORWARD_WM_COMMAND(hwnd,cm_SetupParameters,hwndCtl,0,SendMessage);
	return TRUE;
	};

void TSetupAreaScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TSetupAreaScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char      buf[MaxString];
	int       idx;

	switch(id)
		{
		case cm_ParamSet:
		CheckDlgButton(hwnd,id_SaveContinuous,Scan->bSaveContinuous);
		sprintf(buf,szOWF,Scan->dOmegaWidth);
		SetDlgItemText(hwnd,id_AngleWidth,buf);
		SetDlgItemText(hwnd,id_Catalog,Scan->szDataPath);
		switch(Scan->eScanType) {
			case Omega2ThetaScan:
			EnableWindow(GetDlgItem(hwnd,id_Relation),TRUE);
			if(Scan->bPsdDevice)
				{
				EnableWindow(GetDlgItem(hwnd,id_FixThetaAxis),TRUE);
				EnableWindow(GetDlgItem(hwnd,id_ThetaWidth),FALSE);
				EnableWindow(GetDlgItem(hwnd,id_ThetaWindow),FALSE);
				Scan->nAddedChannels = Device->GetAddedChannels();
				Device->SetAddedChannels(Scan->nAddedChannels);
				sprintf(buf,"%.3f",Device->GetWidth());
				SetDlgItemText(hwnd,id_ThetaWidth,buf);
				}
				else
				{
				EnableWindow(GetDlgItem(hwnd,id_FixThetaAxis),FALSE);
				EnableWindow(GetDlgItem(hwnd,id_ThetaWindow),TRUE);
				EnableWindow(GetDlgItem(hwnd,id_ThetaWidth),TRUE);
				sprintf(buf,szTWF,Scan->dThetaWindow);
				SetDlgItemText(hwnd,id_ThetaWindow,buf);
				sprintf(buf,szTWF,Scan->dThetaWidth);
				SetDlgItemText(GetHandle(),id_ThetaWidth,buf);
				}
			sprintf(buf,"%.2lf",Scan->dMoveRelation);
			SetDlgItemText(hwnd,id_Relation,buf);
			break;

			case StandardScan:
			EnableWindow(GetDlgItem(hwnd,id_FixThetaAxis),TRUE);
			EnableWindow(GetDlgItem(hwnd,id_ThetaWindow),FALSE);
			EnableWindow(GetDlgItem(hwnd,id_ThetaWidth),FALSE);
			EnableWindow(GetDlgItem(hwnd,id_Relation),FALSE);
			Scan->nAddedChannels = Device->GetAddedChannels();
			Device->SetAddedChannels(Scan->nAddedChannels);
			sprintf(buf,"%.3f",Device->GetWidth(mGetUnitType()));
			SetDlgItemText(hwnd,id_ThetaWidth,buf);
			sprintf(buf,szTWF,Scan->dThetaWindow);
			SetDlgItemText(hwnd,id_ThetaWindow,buf);
			break;

			default:
			MessageBox(GetFocus(),szMsgLine015,szMsgFailure,MBSTOP);
			break;
			}
		SetFocus(GetDlgItem(hwnd,IDOK));
		break;

		case cm_SetupParameters:
		FORWARD_WM_COMMAND(hwnd,cm_InquireRelevantData,hwndCtl,0,SendMessage);
		FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
		break;

		case cm_InquireRelevantData:
		GetDlgItemText(GetHandle(),id_Catalog,(LPSTR)Scan->szDataPath,MaxString);
		Scan->bSaveContinuous   = IsDlgButtonChecked(GetHandle(),id_SaveContinuous);
		// Bestimmen der Schrittweite und Schrittrelation
		GetDlgItemText(GetHandle(),id_AngleWidth,buf,MaxString);
		Scan->dOmegaWidth = atof(buf);
		GetDlgItemText(GetHandle(),id_Relation,buf,MaxString);
		Scan->dMoveRelation = atof(buf);
		switch(Scan->eScanType) {
			case Omega2ThetaScan:
			if(Scan->bPsdDevice)
				{
				if(IsDlgButtonChecked(GetHandle(),id_FixThetaAxis))
					{
					Scan->eScanType = StandardScan;
					break;
					}
				sprintf(buf,szTWF,Scan->dMoveRelation * Scan->dOmegaWidth);
				SetDlgItemText(GetHandle(),id_ThetaWidth,buf);
				}
				else
				{
				GetDlgItemText(GetHandle(),id_ThetaWindow,buf,MaxString);
				Scan->dThetaWindow = atof(buf);
				GetDlgItemText(GetHandle(),id_ThetaWidth,buf,MaxString);
				Scan->dThetaWidth = atof(buf);
				}
			break;

			case StandardScan:
			if(!IsDlgButtonChecked(GetHandle(),id_FixThetaAxis))
				{
				Scan->eScanType = Omega2ThetaScan;
				if(Scan->bPsdDevice)
					{
					sprintf(buf,szTWF,Scan->dMoveRelation * Scan->dOmegaWidth);
					SetDlgItemText(GetHandle(),id_ThetaWidth,buf);
					}
				}
			break;

			default:
			MessageBox(GetFocus(),szMsgLine015,szMsgFailure,MBSTOP);
			break;
			}
		Scan->eSaveFormat = StandardFile;
		if(IsDlgButtonChecked(GetHandle(),id_DIB_Format))
			Scan->eSaveFormat = Bitmap;
		if(IsDlgButtonChecked(GetHandle(),id_Standard))
			Scan->eSaveFormat = StandardFile;
		break;

		case id_ChooseDevice:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hDeviceList);
			if((Device != lpDList->DP(idx)) && (idx != CB_ERR))
				{
				Device = lpDList->DP(idx);
				Scan->SetDevice(Device->GetId());
				Scan->eScanType = Omega2ThetaScan;
				FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,PostMessage);
				}
			}
		break;

		case cm_SpecificParameters:
		// spezifische Parameter fr einen Sensor setzen
		if(Scan->bPsdDevice)
			{
			TheModeless = (TPsdParameters *)new TPsdParameters();
			if(TheModeless)
				TheModeless->Initialize();
			}
			else
			Device->SetSpezificParametersDlg();
		FORWARD_WM_COMMAND(GetHandle(),cm_SetupParameters,0,0,SendMessage);
		break;

		case id_DIB_Format:
		case id_FixThetaAxis: case id_Standard:
		FORWARD_WM_COMMAND(GetHandle(),cm_SetupParameters,0,0,PostMessage);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TSetupAreaScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TSetupAreaScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char    	buf[MaxString],dir[MAXDIR],drv[MAXDRIVE],name[MAXFILE],ext[MAXEXT];
	float   	valueF;
	OFSTRUCT	of;
	long    	valueL;
	int    		hFile;
	BOOL			bFailure = FALSE;

	FORWARD_WM_COMMAND(GetHandle(),cm_SetupParameters,0,0,SendMessage);
	Scan->bSaveOnReady  = IsDlgButtonChecked(GetHandle(),id_SaveOnReady);
	Scan->bAbsorberUsed = IsDlgButtonChecked(GetHandle(),id_AbsorberUsed);
	GetDlgItemText(GetHandle(),id_AngleMax,buf,MaxString);
	valueF = atof(buf);
	if(valueF < mlGetValue(nOmega,MaxDistance))
		Scan->dOmegaMax = valueF;
		else
		{
		Scan->dOmegaMax = (mlGetValue(nOmega,MaxDistance) - mlGetValue(nOmega,Width));
		sprintf(buf,mGetDF(),Scan->dThetaWindow);
		SetDlgItemText(GetHandle(),id_ThetaWindow,buf);
		bFailure = TRUE;
		}

	GetDlgItemText(GetHandle(),id_AngleMin,buf,MaxString);
	valueF = atof(buf);
	if(valueF > mlGetValue(nOmega,MinDistance))
		Scan->dOmegaMin = valueF;
		else
		{
		Scan->dOmegaMin = (mlGetValue(nOmega,MinDistance) + mlGetValue(nOmega,Width));
		sprintf(buf,mGetDF(),Scan->dOmegaMin);
		SetDlgItemText(GetHandle(),id_AngleMin,buf);
		bFailure = TRUE;
		}

	GetDlgItemText(GetHandle(),id_ThetaWindow,buf,MaxString);
	valueF = atof(buf);
	if(valueF != 0)
		Scan->dThetaWindow = valueF;
		else
		{
		Scan->dThetaWindow = (Scan->dOmegaMax - Scan->dOmegaMin) * Scan->dMoveRelation;
		sprintf(buf,szTWF,Scan->dThetaWindow);
		SetDlgItemText(GetHandle(),id_ThetaWindow,buf);
		bFailure = TRUE;
		}

	GetDlgItemText(GetHandle(),id_ThetaWidth,buf,MaxString);
	valueF = atof(buf);
	if(valueF != 0)
		Scan->dThetaWidth = valueF;
		else
		{
		Scan->dThetaWidth = Scan->dOmegaWidth * Scan->dMoveRelation;
		sprintf(buf,mGetDF(),Scan->dThetaWidth);
		SetDlgItemText(GetHandle(),id_ThetaWidth,buf);
		bFailure = TRUE;
		}

	GetDlgItemText(GetHandle(),id_MaxTime,buf,MaxString);
	valueF = atof(buf);
	if(0.0 != valueF)
		{
		Scan->fMaxTime = valueF;
		}
		else
		bFailure = TRUE;

	GetDlgItemText(GetHandle(),id_MaxCounts,buf,MaxString);
	valueL = atol(buf);
	if(0 != valueL)
		{
		Scan->dwMaxCounts = valueL;
		}
		else
		bFailure = TRUE;

	GetDlgItemText(GetHandle(),id_Catalog,(LPSTR)Scan->szDataPath,MaxString);
	// Testen, ob sich der Pfad auch beschreiben lt
	if(Scan->szDataPath[strlen(Scan->szDataPath) - 1] != '\\')
		strcat(Scan->szDataPath,"\\");
	fnsplit(Scan->szDataPath,drv,dir,name,ext);
	fnmerge(Scan->szDataPath,drv,dir,"check","tmp");
	hFile = OpenFile(Scan->szDataPath,&of,OF_CREATE);
	if(-1 != hFile)
		{
		_lclose(hFile);
		remove(Scan->szDataPath);
		fnmerge(Scan->szDataPath,drv,dir,"","");
		}
		else
		{
		bFailure = TRUE;
		strcpy(Scan->szDataPath,"c:\\");
		}
	if(bFailure)
		{
		PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0l);
		return FALSE;
		}
	return TRUE;
	};

BOOL TSetupAreaScan::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TSetupAreaScan::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	}

//******************************************************************************
//******* Dialog fr Data Aquisition	******************************************
//******************************************************************************
TAquisition::TAquisition(void) : TModalDlg("Aquisition")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TModalDlg(Aquisition)\n",time(zidx));
//pph***************************************************************************
	bAquisitionActive = FALSE;
	};

#pragma argsused
BOOL TAquisition::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAquisition::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	//! int i = 0;
	char buf[MaxString];

	sprintf(buf,"%d",nLinePoints);
	SetDlgItemText(GetHandle(),id_LinePoints,buf);
	sprintf(buf,"%d",nEnvironment);
	SetDlgItemText(GetHandle(),id_AddedPoints,buf);
	sprintf(buf,"%s",DataFile);
	SetDlgItemText(GetHandle(),id_FileName,buf);
	CheckDlgButton(GetHandle(),id_DX,bSetDXZero);
	CheckDlgButton(GetHandle(),id_DY,bSetDYZero);
	return TRUE;
	};

void TAquisition::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAquisition::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
	};

BOOL TAquisition::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAquisition::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	int 			value;
	OFSTRUCT  of;
	char      buf[MaxString];

	bSetDXZero = IsDlgButtonChecked(GetHandle(),id_DX);
	bSetDYZero = IsDlgButtonChecked(GetHandle(),id_DY);
	if(bSetDXZero * bSetDYZero)
		{
		bSetDXZero = !bSetDYZero;
		CheckDlgButton(GetHandle(),id_DX,bSetDXZero);
		CheckDlgButton(GetHandle(),id_DY,bSetDYZero);
		return FALSE;
		}
	GetDlgItemText(GetHandle(),id_AddedPoints,buf,MaxString);
	value = atoi(buf);
	nEnvironment = max(0,min(3,value));
	if(value != nEnvironment)
		{
		sprintf(buf,"%d",nEnvironment);
		SetDlgItemText(GetHandle(),id_AddedPoints,buf);
		return FALSE;
		}
	GetDlgItemText(GetHandle(),id_LinePoints,buf,MaxString);
	value = atoi(buf);
	nLinePoints = max(0,min(1100,value));
	if(value != nLinePoints)
		{
		sprintf(buf,"%d",nLinePoints);
		SetDlgItemText(GetHandle(),id_LinePoints,buf);
		return FALSE;
		}
	GetDlgItemText(GetHandle(),id_FileName,DataFile,MaxString);
	// Testen, ob sich das File auch erzeugen lt
	if(HFILE_ERROR != OpenFile(DataFile,&of,OF_EXIST))
		{
		strcpy(buf,"File existiert bereits !\r\nberschreiben ?");
		if(IDYES == MessageBox(GetFocus(),buf,"Meldung",MBASK))
			goto Exit;
			else
			return FALSE;
		}
	if(HFILE_ERROR == OpenFile(DataFile,&of,OF_CREATE))
		{
		strcpy(buf,"Probleme beim Anlegen des File !");
		MessageBox(GetFocus(),buf,"Meldung",MBINFO);
		return FALSE;
		}
	remove(DataFile);
Exit:
	bAquisitionActive = TRUE;
	nSetMarker = 0;
	SetInfo("Bitte mit der Maus eine Linie festlegen.");
	return TRUE;
	};

BOOL TAquisition::LeaveDialog(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_arscan.cpp		TAquisition::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};
// __LastLine__
