#include  "rc_def.h"
#include  "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// m_curve.cpp
// modul for the data base
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// Klassen und Instanzen fr die Datenhaltung

#define CINT  const int

const   int     TDataBase::nMaxCurve = 1000;
static  CINT    GrowUnit = 50;
				int     TCurve::LastId  = -1;
extern  BOOL    bModulLoaded;

LPDataBase  lpDataBase;

//******************************************************************************
//****************    Module TDataBase  ***************************************
//******************************************************************************
TDataBase::TDataBase(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TDataBase::TDataBase(void)\n",time(zidx));
//pph***************************************************************************
	nMaxCurveIdx  = 0;
	nActualIdx    = 0;
	CurveList 		= new TCurve* [nMaxCurve];
	CurveList[0] 	= new TCurve(100);
	ScanReport    = new TCurve(50);
	};

TDataBase::~TDataBase(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TDataBase::~TDataBase(void)\n",time(zidx));
//pph***************************************************************************
	TDataBase::New();
	delete CurveList[0];
	delete CurveList;
	delete ScanReport;
	};

BOOL TDataBase::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TDataBase::New(void)\n",time(zidx));
//pph***************************************************************************
	nActualIdx = nMaxCurveIdx;
	while(0 < nActualIdx)
		delete CurveList[nActualIdx--];
	nMaxCurveIdx  = 0;
	nActualIdx    = 0;
	CurveList[0]->New();
	ScanReport->New();
	return TRUE;
	};

BOOL TDataBase::AddCurve(int size)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TDataBase::AddCurve(int size)\n",time(zidx));
//pph***************************************************************************
	if(nMaxCurveIdx+2 > nMaxCurve)
		{
		eFault = MaxScanExceeded;
		return FALSE;
		}
	CurveList[++nMaxCurveIdx] = new TCurve(size+1);
	if(NULL != CurveList[nMaxCurveIdx])
		return TRUE;
	eFault = NoMemory;
	return FALSE;
	};

void TDataBase::SetCIdx(int idx)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TDataBase::SetCIdx(int idx)\n",time(zidx));
//pph***************************************************************************
	nActualIdx = max(0,min(nMaxCurveIdx,idx));
	};

TCurve *TDataBase::GetCurve(int idx)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		*TDataBase::GetCurve(int idx)\n",time(zidx));
//pph***************************************************************************
	if(idx < 0)
		return CurveList[0];
	if(idx > nMaxCurveIdx)
		return CurveList[nMaxCurveIdx];
	return CurveList[idx];
	};

//******************************************************************************
//****************    Module TCurve   ******************************************
//******************************************************************************
TCurve::TCurve(int npoints)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::TCurve(int npoints)\n",time(zidx));
//pph***************************************************************************
	//! long      retval;
	// Anzahl der Werte je Punkt
	ActualIdx    = -1;
	MaxPointIdx  = -1;
	MaxMemIdx    = -1;
  eOrder 			 = X_Sorted;
	bEnd				 = FALSE;
  bStreamOpen  = FALSE;

	TCurve::LastId++;
	Id = TCurve::LastId;
	MaxMemIdx = max(GrowUnit,npoints+2);
	//! retval  = GlobalCompact(MaxMemIdx * sizeof(CPoint));
   //! GlobalCompact hat keine Bedeutung bei Win32API
   GlobalCompact(MaxMemIdx * sizeof(CPoint));
	hMemX   = GlobalAlloc(GHND,MaxMemIdx * sizeof(float));
	hMemY   = GlobalAlloc(GHND,MaxMemIdx * sizeof(float));
	hMemZ 	= GlobalAlloc(GHND,MaxMemIdx * sizeof(float));
	hMemV   = GlobalAlloc(GHND,MaxMemIdx * sizeof(BOOL));
	if(!hMemX || !hMemY || !hMemZ || !hMemV)
		{
		MessageBox(GetFocus(),"Kein Speicher TCurve","Fehler",MB_OK | MB_ICONSTOP);
		MaxMemIdx = -1;
		return;
		}
	Max[0] = -(Min[0] = 1000000.0);
	Max[1] = -(Min[1] = 1000000.0);
	Max[2] = -(Min[2] = 1000000.0);
	};

TCurve::~TCurve(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::~TCurve(void)\n",time(zidx));
//pph***************************************************************************
	New();
	// Gibt Segment entgltig frei
	TCurve::LastId--;
	MaxMemIdx = -1;
	GlobalFree(hMemX);
	GlobalFree(hMemY);
	GlobalFree(hMemZ);
	GlobalFree(hMemV);
	};

BOOL TCurve::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::New(void)\n",time(zidx));
//pph***************************************************************************
	ActualIdx   = -1;
	MaxPointIdx = -1;
	bEnd				= FALSE;

	hMemX = GlobalReAlloc(hMemX,GrowUnit * sizeof(float),GMEM_ZEROINIT);
	hMemY = GlobalReAlloc(hMemY,GrowUnit * sizeof(float),GMEM_ZEROINIT);
	hMemZ = GlobalReAlloc(hMemZ,GrowUnit * sizeof(float),GMEM_ZEROINIT);
	hMemV = GlobalReAlloc(hMemV,GrowUnit * sizeof(BOOL),GMEM_ZEROINIT);
	MaxMemIdx = (int)GrowUnit-1;
	--MaxMemIdx;
	Max[0] = -(Min[0] = 1000000.0);
	Max[1] = -(Min[1] = 1000000.0);
	Max[2] = -(Min[2] = 1000000.0);
	return TRUE;
	};

void TCurve::BackStep(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::BackStep(void)\n",time(zidx));
//pph***************************************************************************
	bEnd = FALSE;
	if(ActualIdx > 0)
		--ActualIdx;
	};

TCurve&	 TCurve::operator=(const TCurve& crv)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::operator=(const TCurve& crv)\n",time(zidx));
//pph***************************************************************************
	long				lSize;
	float*			lpp;
	BOOL*				lpv;

	if(this == &crv) return *this;
	memcpy(Min,crv.Min,3*sizeof(float));
	memcpy(Max,crv.Max,3*sizeof(float));
	bEnd 				= FALSE;
	ActualIdx 	= -1;
	MaxPointIdx = -1;
	MaxMemIdx   = -1;

	lSize = (crv.MaxPointIdx+1) * sizeof(CPoint);
   //! GlobalCompact hat keine Bedeutung bei Win32API
	if(lSize > GlobalCompact(lSize))
		return *this;

	// Segment erweitern
	hMemX = GlobalReAlloc(hMemX,(crv.MaxPointIdx+1) * sizeof(float),0);
	hMemY = GlobalReAlloc(hMemY,(crv.MaxPointIdx+1) * sizeof(float),0);
	hMemZ = GlobalReAlloc(hMemZ,(crv.MaxPointIdx+1) * sizeof(float),0);
	hMemV = GlobalReAlloc(hMemV,(crv.MaxPointIdx+1) * sizeof(BOOL),0);
	if(!hMemX || !hMemY || !hMemZ || !hMemV)
		return *this;
	MaxMemIdx   = (int)crv.MaxPointIdx;
  ActualIdx 	= 0;
	MaxPointIdx = crv.MaxPointIdx;
	lpPX  = (float*)GlobalLock(hMemX);
	lpp 	= (float*)GlobalLock(crv.hMemX);
	memcpy(lpPX,lpp,(MaxPointIdx+1)*sizeof(float));
	GlobalUnlock(hMemX);
	GlobalUnlock(crv.hMemX);
	lpPY  = (float*)GlobalLock(hMemY);
	lpp 	= (float*)GlobalLock(crv.hMemY);
	memcpy(lpPY,lpp,(MaxPointIdx+1)*sizeof(float));
	GlobalUnlock(hMemY);
	GlobalUnlock(crv.hMemY);
	lpPZ  = (float*)GlobalLock(hMemZ);
	lpp 	= (float*)GlobalLock(crv.hMemZ);
	memcpy(lpPZ,lpp,(MaxPointIdx+1)*sizeof(float));
	GlobalUnlock(hMemZ);
	GlobalUnlock(crv.hMemZ);
	lpPV  = (BOOL*)GlobalLock(hMemV);
	lpv 	= (BOOL*)GlobalLock(crv.hMemV);
	memcpy(lpPV,lpv,(MaxPointIdx+1)*sizeof(BOOL));
	GlobalUnlock(hMemV);
	GlobalUnlock(crv.hMemV);
	return *this;
	};

BOOL TCurve::FastPAdd(float &x,float &y,float &z)
  {
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::FastPAdd(float &x,float &y,float &z)\n",time(zidx));
//pph***************************************************************************
  if(MaxPointIdx > (MaxMemIdx-5))
    FastOpen();
  if(!bStreamOpen)
    if(!FastOpen())
      return FALSE;
	++MaxPointIdx;
	bEnd = FALSE;
	ActualIdx = MaxPointIdx;
	lpPX[MaxPointIdx] = x;
	lpPY[MaxPointIdx] = y;
	lpPZ[MaxPointIdx] = z;
	lpPV[MaxPointIdx] = TRUE;
	if(Max[0] < lpPX[MaxPointIdx])
		Max[0] = lpPX[MaxPointIdx];
	if(Min[0] > lpPX[MaxPointIdx])
		Min[0] = lpPX[MaxPointIdx];
	if(Max[1] < lpPY[MaxPointIdx])
		Max[1] = lpPY[MaxPointIdx];
	if(Min[1] > lpPY[MaxPointIdx])
		Min[1] = lpPY[MaxPointIdx];
	if(Max[2] < lpPZ[MaxPointIdx])
		Max[2] = lpPZ[MaxPointIdx];
	if(Min[2] > lpPZ[MaxPointIdx])
		Min[2] = lpPZ[MaxPointIdx];
	return TRUE;
	};

BOOL TCurve::FastPGet(float &x,float &y,float &z)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::FastPGet(float &x,float &y,float &z)\n",time(zidx));
//pph***************************************************************************
	if(bEnd)
		return FALSE;
	if(-1 == MaxPointIdx)
		return FALSE;
	if(!bStreamOpen)
		if(!FastOpen())
			return FALSE;
	bEnd = (ActualIdx == MaxPointIdx);
	if(lpPV[ActualIdx])
		{
		x = lpPX[ActualIdx];
		y = lpPY[ActualIdx];
		z = lpPZ[ActualIdx];
		}
		else
		x = y = z = 0.0;
	if(!bEnd)
		ActualIdx++;
	return TRUE;
	};

BOOL TCurve::FastOpen(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::FastOpen(void)\n",time(zidx));
//pph***************************************************************************
	BOOL	bTryCompact = FALSE;

	if(bStreamOpen)
		FastClose();
	if(MaxPointIdx > (MaxMemIdx-5))
		{
		MaxMemIdx += GrowUnit;
		while(1)
			{
			// Segment erweitern
			hMemX = GlobalReAlloc(hMemX,(MaxMemIdx+1) * sizeof(float),0);
			hMemY = GlobalReAlloc(hMemY,(MaxMemIdx+1) * sizeof(float),0);
			hMemZ = GlobalReAlloc(hMemZ,(MaxMemIdx+1) * sizeof(float),0);
			hMemV = GlobalReAlloc(hMemV,(MaxMemIdx+1) * sizeof(BOOL),0);
			if(hMemX && hMemY && hMemZ && hMemV)
				{
				lpPV  = (BOOL*)GlobalLock(hMemV);
				memset(&(lpPV[MaxPointIdx+1]),FALSE,(MaxMemIdx-MaxPointIdx+1)*sizeof(BOOL));
				goto Open;
				}
			if(bTryCompact)
				{
				ActualIdx    = -1;
				MaxPointIdx  = -1;
				MaxMemIdx 	 = -1;
				return FALSE;
				}
         //! GlobalCompact hat keine Bedeutung bei Win32API
			GlobalCompact(MaxMemIdx * (3*sizeof(float) + sizeof(BOOL)));
			bTryCompact = TRUE;
			}
		}
	lpPV  = (BOOL*)GlobalLock(hMemV);
Open:
	lpPX  = (float*)GlobalLock(hMemX);
	lpPY  = (float*)GlobalLock(hMemY);
	lpPZ  = (float*)GlobalLock(hMemZ);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		{
		ActualIdx    = -1;
		MaxPointIdx  = -1;
		return FALSE;
		}
	bStreamOpen = TRUE;
	return TRUE;
	};

BOOL TCurve::FastClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::FastClose(void)\n",time(zidx));
//pph***************************************************************************
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	bStreamOpen = FALSE;
	return TRUE;
	};

BOOL TCurve::PAdd(float &x,float &y,float &z)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::PAdd(float &x,float &y,float &z)\n",time(zidx));
//pph***************************************************************************
	if(!FastOpen()) return FALSE;
	++MaxPointIdx;
	bEnd = FALSE;
	ActualIdx = MaxPointIdx;
	lpPX[MaxPointIdx] = x;
	lpPY[MaxPointIdx] = y;
	lpPZ[MaxPointIdx] = z;
	lpPV[MaxPointIdx] = TRUE;
	if(Max[0] < lpPX[MaxPointIdx])
		Max[0] = lpPX[MaxPointIdx];
	if(Min[0] > lpPX[MaxPointIdx])
		Min[0] = lpPX[MaxPointIdx];
	if(Max[1] < lpPY[MaxPointIdx])
		Max[1] = lpPY[MaxPointIdx];
	if(Min[1] > lpPY[MaxPointIdx])
		Min[1] = lpPY[MaxPointIdx];
	if(Max[2] < lpPZ[MaxPointIdx])
		Max[2] = lpPZ[MaxPointIdx];
	if(Min[2] > lpPZ[MaxPointIdx])
		Min[2] = lpPZ[MaxPointIdx];
	FastClose();
	return TRUE;
	};

BOOL TCurve::PGet(float &x,float &y,float &z)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::PGet(float &x,float &y,float &z)\n",time(zidx));
//pph***************************************************************************
	BOOL	bWasOpen = bStreamOpen;

	if(bEnd)
		return FALSE;
	if(-1 == MaxPointIdx)
		return FALSE;
	if(!bStreamOpen)
		if(!FastOpen())
			return FALSE;
	bEnd = (ActualIdx == MaxPointIdx);
	if(lpPV[ActualIdx])
		{
		x = lpPX[ActualIdx];
		y = lpPY[ActualIdx];
		z = lpPZ[ActualIdx];
		}
		else
		x = y = z = 0.0;
	if(!bEnd)
		ActualIdx++;
	if(!bWasOpen)
		FastClose();
	return TRUE;
	};

int	TCurve::GetValueByValue(float search,float&delta,float&value)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::GetValueByValue(float search,float&delta,float&value)\n",time(zidx));
//pph***************************************************************************
	int	Sign,Idx,BB;

	// the X column should be sorted
	delta = value = 0.0;
	if((search > Max[0]) || (search < Min[0]))
		return 0;
	if(-1 == MaxPointIdx)
		return 0;
	if(!FastOpen())
		return 0;
	Idx = BB = MaxPointIdx / 2;
	while(BB)
		{
		BB /= 2;
		Sign = (search > lpPX[Idx])?0:1;
		if(Sign)
			Idx -= BB;
			else
			Idx += BB;
		};
	if(Sign)
		if((search - lpPX[Idx]) > (lpPX[Idx+1] - search))
			Idx++;
		else
		if((search - lpPX[Idx-1]) < (lpPX[Idx] - search))
			Idx--;
	value = lpPY[Idx];
	delta = search - lpPX[Idx];
	FastClose();
	return Idx;
	};


BOOL TCurve::SetPP(int pos)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::SetPP(int pos)\n",time(zidx));
//pph***************************************************************************
	if(MaxMemIdx == -1)
		return FALSE;
	ActualIdx = (pos>MaxPointIdx) ? MaxPointIdx:pos;
	ActualIdx = (ActualIdx<0) ? 0:ActualIdx;
	bEnd = FALSE;
	return TRUE;
	};

BOOL TCurve::ValueAdd(float &val)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::ValueAdd(float &val)\n",time(zidx));
//pph***************************************************************************
	// Addiert val jeweils zu [1] des aktuellen Punktes
	if(MaxPointIdx == -1)
		return FALSE;
	if(bEnd)
		return FALSE;
	bEnd = (ActualIdx == MaxPointIdx);
	lpPY = (float*)GlobalLock(hMemY);
	if(!lpPY)
		{
		ActualIdx    = -1;
		MaxPointIdx  = -1;
		return FALSE;
		}
	lpPY[ActualIdx] += val;
	if(!bEnd)
		ActualIdx++;
	GlobalUnlock(hMemY);
	return TRUE;
	};

BOOL TCurve::Save(LPCSTR filename)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::Save(LPCSTR filename)\n",time(zidx));
//pph***************************************************************************
	OFSTRUCT    of;
	int         hFile;
	float      	x,y,z;
	char       	buf[MaxString];

	hFile = OpenFile(filename,&of,OF_CREATE);
	if(-1 == hFile) return FALSE;
	SetPP(0);
	_llseek(hFile,0,SEEK_END);
	FastOpen();
	while(FastPGet(x,y,z))
		{
		sprintf(buf,"%.3f %.3f %.3f\n",x,y,z);
		_lwrite(hFile,(LPSTR)buf,strlen(buf));
		}
	_lclose(hFile);
	FastClose();
	return TRUE;
	};

BOOL TCurve::Save(LPCSTR filename,int type,int)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::Save(LPCSTR filename,int type,int)\n",time(zidx));
//pph***************************************************************************
	OFSTRUCT    of;
	int         hFile;
	float      	x,y,z;
	char       	buf[MaxString];

	hFile = OpenFile(filename,&of,OF_CREATE);
	if(-1 == hFile)
		return FALSE;
	SetPP(0);
	_llseek(hFile,0,SEEK_END);
	FastOpen();
	switch(type) {
		case 100:
		while(FastPGet(x,y,z))
			{
			sprintf(buf,"%.5f\n",y);
			_lwrite(hFile,(LPSTR)buf,strlen(buf));
			}
		break;
		}
	_lclose(hFile);
	FastClose();
	return TRUE;
	};


BOOL TCurve::GetGravityCenter(float &x,float &y,float &z,int func)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::GetGravityCenter(float &x,float &y,float &z,int func)\n",time(zidx));
//pph***************************************************************************
	int       idx,maxpos;
	//! float     retval = 0.0;
	double    integral,weigth, dx;

	if(2 > MaxPointIdx)
		return FALSE;
	// berechnet den Schwerpunkt der Kurve und gibt den entsprechenden relativen
	// Winkel zurck
	lpPX = (float*)GlobalLock(hMemX);
	lpPY = (float*)GlobalLock(hMemY);
	lpPZ = (float*)GlobalLock(hMemZ);
	lpPV = (BOOL*)GlobalLock(hMemV);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		{
		ActualIdx    = -1;
		MaxPointIdx  = -1;
		return FALSE;
		}
	switch(func) {
		case 2:
		maxpos = 0;
		for(idx=0;idx<=MaxPointIdx;idx++)
			if(lpPY[idx] > lpPY[maxpos])
				maxpos = idx;
		x = lpPX[maxpos];
		y = lpPY[maxpos];
		z = lpPZ[maxpos];
		break;

		default:
		integral  = weigth = 0.0;
		dx = lpPX[1] - lpPX[0];
		for(idx=0;idx<=MaxPointIdx;idx++)
			{
			weigth    += lpPY[idx] * dx;
			integral  += lpPY[idx] * (idx * dx) * dx;
			}
		if(weigth)
			x = (integral / weigth);

		for(idx=0;idx<=MaxPointIdx;idx++)
			if(lpPX[idx] >= x)
				{
				y = lpPY[idx];
				z = lpPZ[idx];
				break;
				}
		break;
		}
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	return TRUE;
	};

BOOL TCurve::DeleteUnderGround(float Level)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::DeleteUnderGround(float Level)\n",time(zidx));
//pph***************************************************************************
	int      Idx = 0;
	double   PeakMin = (Max[1]- Min[1]) * Level;

	// Trennen der Peaks vom Untergrund
	// Es wird nur y bearbeitet
	// Die gltigen Punkte sind noch durch ungltige getrennt

	if(-1 == MaxPointIdx)
		return FALSE;
	lpPX = (float*)GlobalLock(hMemX);
	lpPY = (float*)GlobalLock(hMemY);
	lpPZ = (float*)GlobalLock(hMemZ);
	lpPV = (BOOL*)GlobalLock(hMemV);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		return FALSE;
	while(Idx <= MaxPointIdx)
		{
		if((lpPY[Idx] - Min[1]) <= PeakMin)
			lpPV[Idx] = FALSE;
		Idx++;
		};
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	return TRUE;
	};

BOOL TCurve::DeleteFlanks()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::DeleteFlanks()\n",time(zidx));
//pph***************************************************************************
	int       MaxValIdx;
	int       Idx = 0;

	// Flanken der Peaks beseitigen
	// Es wird nur y bearbeitet
	// Die gltigen Punkte werden nach vorn geschoben und der Rest wird gelscht
	if(-1 == MaxPointIdx)
		return FALSE;
	lpPX = (float*)GlobalLock(hMemX);
	lpPY = (float*)GlobalLock(hMemY);
	lpPZ = (float*)GlobalLock(hMemZ);
	lpPV = (BOOL*)GlobalLock(hMemV);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		return FALSE;
	while(Idx <= MaxPointIdx)
		{
		// Bis zum nchsten Peak
		while(!lpPV[Idx])
			if(Idx < MaxPointIdx)
				Idx++;
				else break;  // Ende erreicht
		// Grten Wert suchen
		MaxValIdx = Idx;
		if(Idx < MaxPointIdx)
				Idx++;
				else break;  // Ende erreicht
		while(lpPV[Idx])
			{
			if(lpPY[Idx] > lpPY[MaxValIdx])
				{
				lpPV[MaxValIdx] = FALSE;
				MaxValIdx = Idx;
				}
				else
				lpPV[Idx] = FALSE;
			if(Idx < MaxPointIdx)
				Idx++;
				else break;  // Ende erreicht
			}
		// Peak nach vorn kopieren
		/*
		lpPnts[Idx] = lpPoints[MaxValIdx];
		*/
		lpPV[Idx] = TRUE;
		lpPV[MaxValIdx] = FALSE;
		if(Idx < MaxPointIdx)
			Idx++;
		}
	// es wurden peaks gefunden
//! Exit:
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	return TRUE;
	};


//! BOOL TCurve::GetReflection(int /*order*/,LPCPoint /*Peak*/)
/*
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		/*\n",time(zidx));
//pph***************************************************************************
	//! static BOOL   bSorted = FALSE;    // ndern
	//! BOOL          bChange = FALSE; //wird nur im auskomm. Teil benutzt
	BOOL          Ok = FALSE;
	// int           Idx, MaxValIdx;
	// CPoint        merker;

	// Alle Peak-Maxima werden der Gre nach sortiert
	// Der grte Peak hat die Ordnung 0 usw.
	// Es sind mit weniger als 20 Peaks zu rechnen
	if(-1 == MaxPointIdx)
		return FALSE;
	lpPX = (float*)GlobalLock(hMemX);
	lpPY = (float*)GlobalLock(hMemY);
	lpPZ = (float*)GlobalLock(hMemZ);
	lpPV = (BOOL*)GlobalLock(hMemV);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		goto Exit;
//Kommentarbeginn
	if(!lpPV[0])
		goto Exit;
	if(0 < MaxPointIdx)
		Idx = 1;
		else
		{
		bSorted = TRUE;
		//*Peak = lpPoints[0];
		if(order == 0)
			Ok = TRUE;
			else
			Ok = FALSE;
		goto Exit;
		}
	if(!bSorted)
		{
		// Sortieren  (Bubblesort)
		Idx = 0;
		// nchsten grten Wert suchen
		while(Idx < MaxPointIdx)
			{
			while(Idx <= MaxPointIdx)
				{
				if(lpPY[Idx] > lpPY[ActualIdx])
					{
					MaxValIdx = Idx;
					bChange = TRUE;
					}
				Idx++;
				}
			if(bChange)
				{
				// Mit ersten Punkt austauschen
				merker = lpPoints[ActualIdx];
				lpPoints[ActualIdx] = lpPoints[MaxValIdx];
				lpPoints[MaxValIdx] = merker;
				bChange = FALSE;
				// point geht weiter als ThisPoint
				if(ActualIdx < MaxPointIdx)
					ActualIdx++;
				Idx = ActualIdx+1;
				}
			}
		bSorted = TRUE;
		}
	ActualIdx = 0;
	while(order--)
		if(ActualIdx < MaxPointIdx)
			ActualIdx++;
			else
			// Peak der angegebenen Ordnung ist nicht vorhanden
			Ok = FALSE;
	// Werte kopieren
	(*Peak) = lpPoints[ActualIdx];
//Kommentarende
Exit:
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	if(Ok)
		return TRUE;
		else
		return FALSE;
	};
*/

BOOL TCurve::GetPeakProperties(float &hw,float &pos,float &intens)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_curve.cpp		TCurve::GetPeakProperties(float &hw,float &pos,float &intens)\n",time(zidx));
//pph***************************************************************************
	int  	LeftPIdx,RightPIdx,MaxPIdx,Idx;
	BOOL  retval = FALSE;

	if(-1 == MaxPointIdx)
		return FALSE;
	if(!DeleteUnderGround(0.5)) return FALSE;
	// 000001111111100000
	// Bis zum nchsten Peak
	Idx = 0;
	lpPX = (float*)GlobalLock(hMemX);
	lpPY = (float*)GlobalLock(hMemY);
	lpPZ = (float*)GlobalLock(hMemZ);
	lpPV = (BOOL*)GlobalLock(hMemV);
	if(!lpPX || !lpPY || !lpPZ || !lpPV)
		goto Exit;
	while(!lpPV[Idx])
		if(Idx < MaxPointIdx)
			Idx++;
			else
			goto Exit; // Ende erreicht
	// linke Flanke
	LeftPIdx = MaxPIdx = Idx;
	while(lpPV[Idx])
		{
		if(lpPY[Idx] > lpPY[MaxPIdx])
			MaxPIdx = Idx;
		if(Idx < MaxPointIdx)
			Idx++;
			else
			goto Exit; // Ende erreicht
		 }
	// rechte Flanke
	RightPIdx = Idx-1;
	hw        = fabs(lpPX[RightPIdx] - lpPX[LeftPIdx]);
	pos       = lpPX[MaxPIdx];
	intens    = lpPY[MaxPIdx];
	retval = TRUE;
Exit:
	GlobalUnlock(hMemX);
	GlobalUnlock(hMemY);
	GlobalUnlock(hMemZ);
	GlobalUnlock(hMemV);
	return retval;
	};
// __LastLine__



