#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

//hpp***************************************************************************
#include <time.h>
//pph***************************************************************************

//hpp***************************************************************************
extern FILE *trace;
extern time_t *zidx;
//pph***************************************************************************

// m_scan.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Rntgenbeugung"
/*
- Einlesen alter Datenfiles [Data]
*/

// #define ContinuousScanCapability
#include		"m_devcom.h"
#include    "m_steerg.h"
#include    "m_xscan.h"
#include		"c_layer.h"
#include		"m_layer.h"

int TMDIWindow::WindowId = 0;

#ifdef __WIN32__
	#define	WRITE OF_WRITE
#endif

extern  TMain       Main;
extern	LPDList 		lpDList;
extern	TSteering  	Steering;
static  int         nScanTask;
static	BOOL				bScanSetupOk = FALSE;

// #define DEBUG

//******************************************************************************
//**********         Klasse Diffraktometrie            *************************
//******************************************************************************
TScanParameters::TScanParameters()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScanParameters::TScanParameters()\n",time(zidx));
//pph***************************************************************************
	char    Param[MaxString];
	char    buf[MaxString];
	int			idx,mid = mlGetAxis();

	fFailure          	= 0.02;
	nNumberCycle        = 1;
	eSaveFormat         = Tupel;
	eScanType           = StandardScan;
	bSaveContinuous     = FALSE;
	bMonitorUsed     	  = FALSE;
	nMFunctionId     	  = D_DiffractionScan;
	Device             	= lpDList->DP();
	if(dlIsDeviceValid(MonitorDevice))
		Monitor = lpDList->DP(dlGetIdByName(MonitorDevice));
		else
		Monitor = lpDList->DP();
	if(mlIsAxisValid(Omega))
		{
		nMotor = mlGetIdByName(Omega);
		mlSetAxis(nMotor);
		}
		else
		nMotor = mlGetAxis();
	dArgumentWidth    	  = mGetValue(Width);
	dArgumentMax      	  = dArgumentWidth * 100.0;
	dArgumentMin      	  = -dArgumentWidth * 100.0;
	dSpeed								= mGetValue(Speed);
	nCollectionAmount			= 100;
	GetPrivateProfileString("Scan","ExposureTime","1.0",buf,MaxString,GetCFile());
	fMaxTime = atof(buf);
	GetPrivateProfileString("Scan","ExposureCounts","10000",buf,MaxString,GetCFile());
	dwMaxCounts = atol(buf);
	if(CreateDefaults())
		WritePrivateProfileString("Scan","ExposureCounts",buf,GetCFile());
	GetPrivateProfileString("Scan","DynamicStepWidth","0",buf,MaxString,GetCFile());
	bDynamicStepWidth = atoi(buf);
	idx = 0;
	do
		{
		sprintf(Param,"Level%d",idx);
		GetPrivateProfileString("Scan",Param,"",buf,MaxString,GetCFile());
		// Intensity StepFactor
		sscanf(buf,"%f %f",&Scaler[idx],&Scaler[idx+nMaxScaleIdx]);
		idx++;
		if(nMaxScaleIdx == idx) break;
		}
	while(strlen(buf));
	nStepScaleLevels = idx - 1;
	bSaveOnReady = GetPrivateProfileInt("Scan","SaveOnReady",1,GetCFile());
	mlSetAxis(mid);
	};

TScan::TScan(void) : TPlotData(), TScanParameters()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScanParameters()\n",time(zidx));
//pph***************************************************************************
	//! HMENU   hM1,hM2;
   HMENU   hM2;
	bInterrupted    = FALSE;
	bMacroRunning   = FALSE;

	// Registrieren der Kindfenster-Klasse
	TMDIWindow::RegisterWnd();
	WindowType = W_DiffractionWindow;
	bMeasurementActive = FALSE;
	TheMenu = CreatePopupMenu();
   //! hM1 = CreatePopupMenu();
	hM2 = CreatePopupMenu();
	AppendMenu(TheMenu,MF_STRING,cm_SetupStepScan,"Setup &StepScan...");
	AppendMenu(TheMenu,MF_STRING,cm_SetupContinuousScan,"Setup &ContinuousScan...");
#ifndef ContinuousScanCapability
	EnableMenuItem(TheMenu,cm_SetupContinuousScan,MF_GRAYED);
#endif
#ifdef GermanVersion
	AppendMenu(TheMenu,MF_STRING,cm_ShowCurveParam,"&Darstellungs-Optionen...");
	AppendMenu(TheMenu,MF_STRING,cm_InitializeScan,"&Scan starten");
	AppendMenu(TheMenu,MF_SEPARATOR,0,NULL);
	AppendMenu(hM2,MF_STRING,cm_FreezeCurve,"&Fixieren");
	AppendMenu(hM2,MF_STRING,cm_KillSecondCurve,"&Lschen");
	AppendMenu(hM2,MF_STRING,cm_SaveSecondCurve,"&Speichern");
#else
	AppendMenu(TheMenu,MF_STRING,cm_ShowCurveParam,"&Display-Options...");
	AppendMenu(TheMenu,MF_STRING,cm_InitializeScan,"&Scan execute");
	AppendMenu(TheMenu,MF_SEPARATOR,0,NULL);
	AppendMenu(hM2,MF_STRING,cm_FreezeCurve,"&Fixing");
	AppendMenu(hM2,MF_STRING,cm_KillSecondCurve,"&Delete");
	AppendMenu(hM2,MF_STRING,cm_SaveSecondCurve,"&Save");
#endif
	AppendMenu(TheMenu,MF_POPUP,(WORD)hM2,"Sca&n");
	MainCurve = (TCurve*)new TCurve(50);
	};

TScan::~TScan()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::~TScan()\n",time(zidx));
//pph***************************************************************************
	char			buf[MaxString];
	RECT			rc,rcm;

	delete MainCurve;
	DestroyMenu(TheMenu);
	mSetCorrectionState(FALSE);
	Device->MeasureStop();
	Device->SetHost(NULL);
	Device->MeasureStart();
	GetWindowRect(GetFrameHandle(),&rcm);
	GetWindowRect(hWndChild,&rc);
	sprintf(buf,"%d",rc.left - rcm.left - 4);
	WritePrivateProfileString("Scan","xo",buf,GetCFile());
	sprintf(buf,"%d",rc.top - rcm.top - 42);
	WritePrivateProfileString("Scan","yo",buf,GetCFile());
	sprintf(buf,"%d",rc.right - rc.left);
	WritePrivateProfileString("Scan","dx",buf,GetCFile());
	sprintf(buf,"%d",rc.bottom - rc.top);
	WritePrivateProfileString("Scan","dy",buf,GetCFile());
	WritePrivateProfileString("Scan","DataPath",szDataPath,GetCFile());
	sprintf(buf,"%.2f",fMaxTime);
	WritePrivateProfileString("Scan","ExposureTime",buf,GetCFile());
	sprintf(buf,"%d",bSaveOnReady);
	WritePrivateProfileString("Scan","SaveOnReady",buf,GetCFile());
	Main.hScanWindow = NULL;
	Main.ScanWindow = NULL;
	};

BOOL TScan::New(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::New(void)\n",time(zidx));
//pph***************************************************************************
	MainCurve->New();
	return TPlotData::New();
	};

BOOL TScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	if(!TMDIWindow::CanClose()) return FALSE;
	return TRUE;
	};

void TScan::Create(HWND hwnd)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::Create(HWND hwnd)\n",time(zidx));
//pph***************************************************************************
	RECT		rc;

	hWndChild = hwnd;
	Main.hScanWindow = hwnd;
	Main.ScanWindow = this;
	rc.left 	= GetPrivateProfileInt("Scan","xo",500,GetCFile());
	rc.top  	= GetPrivateProfileInt("Scan","yo",400,GetCFile());
	rc.right	= rc.left + GetPrivateProfileInt("Scan","dx",170,GetCFile());
	rc.bottom = rc.top + GetPrivateProfileInt("Scan","dy",50,GetCFile());
	strcpy(szExtension,"crv");
	strcpy(szFilter,"Scan Standard(*.crv)|*.crv||");
	GetPrivateProfileString("Scan","DataPath","c:\\",szDataPath,MAXPATH,GetCFile());
	if(szDataPath[strlen(szDataPath) - 1] != '\\')
		strcat(szDataPath,"\\");
	SetTitle();
	Delay(5000);
	UpdateMenu();
	SetRanges();
	SetWindowPos(	hWndChild,NULL,rc.left,rc.top,rc.right - rc.left,
								rc.bottom - rc.top,SWP_NOZORDER);
	};

BOOL TScan::SetTitle()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SetTitle()\n",time(zidx));
//pph***************************************************************************
	char  aTitle[MaxString];

#ifdef GermanVersion
	strcpy(aTitle,"Diffraktometrie:");
#else
	strcpy(aTitle,"Diffractometry:");
#endif
	if(bIsNewFile)
		strcat(aTitle,"<untitled.crv>");
		else
		strcat(aTitle,FileName);
	SetWindowText(hWndChild,aTitle);
	return TRUE;
	};

void TScan::SetRanges(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SetRanges(void)\n",time(zidx));
//pph***************************************************************************
	TPlotData::SetRanges();
	CoorSys.xMin = dArgumentMin;
	CoorSys.xMax = dArgumentMax;
	};

void TScan::InitializeDlg(WPARAM task,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::InitializeDlg(WPARAM task,LPARAM)\n",time(zidx));
//pph***************************************************************************
	TModalDlg*	dlg;

	switch(task) {
		case cm_SetupStepScan:
		dlg = (TSetupStepScan*)new TSetupStepScan(this);
		dlg->ExecuteDialog(hWndChild);
		delete dlg;
		break;

		case cm_SetupContinuousScan:
		dlg = (TSetupContinuousScan*)new TSetupContinuousScan(this);
		dlg->ExecuteDialog(hWndChild);
		delete dlg;
		break;
		}
	SetRanges();
	bScanSetupOk = TRUE;
	UpdateWnd(0);
	};

void TScan::InitializeTask(WPARAM,LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::InitializeTask(WPARAM,LPARAM)\n",time(zidx));
//pph***************************************************************************
	double        distance;
#ifdef GermanVersion
	char					HeadLine[] = "Start Scan";
#else
	char					HeadLine[] = "Starting Scan";
#endif
	char    			fmt[MaxString];
	char   				buf[MaxString];

	SaveFile(SaveWithNewName);
	switch(eScanType) {
		case StandardScan:
		mSetValue(Speed,1000.0);
		mSetCorrectionState(TRUE);
		// Motor initialisieren
		mlSetAxis(nMotor);
#ifdef GermanVersion
		sprintf(fmt,"Einen Standard-Scan mit %s\r\n Bereich (%s >> %s) \r\nstarten ?",
								mGetAxisName(),mGetDF(),mGetDF());
#else
		sprintf(fmt,"Execute Scan with %s\r\nfrom %s to %s ?",
								mGetAxisName(),mGetDF(),mGetDF());
#endif
		sprintf(buf,fmt,dArgumentMin,dArgumentMax);
		if(IDNO == MessageBox(GetFocus(),buf,HeadLine,MBASK))
			return;
		Device->MeasureStop();
		Device->SetExposureValues(fMaxTime,dwMaxCounts,fFailure);
		if(bSaveContinuous || bSaveOnReady || bOldDataLoaded)
			SaveFile(SaveWithNewName);
		Steering.Reset();
		Steering.StartUp(hWndChild,nMotor,Device->GetId());
		// Scan starten
		Steering.Visualising(1,0,0,0,0,0);
		strcpy(buf,"");
		Steering.StartCmdExecution(Scan,ForScan,0,buf,GetWndHandle());
		break;

		case Omega2ThetaScan:
		// Motor initialisieren
		mlSetAxis(nMotor);
		mSetValue(Speed,1000);
		mSetCorrectionState(TRUE);
		// Sensoren initialisieren
#ifdef GermanVersion
		sprintf(fmt,"Einen Omega2Theta-Scan mit Omega\r\nvon %s bis %s starten ?",
									mGetDF(),mGetDF());
#else
		sprintf(fmt,"Do you want to start a Omega2Theta-Scan\r\n with Omega from %s to %s ?",
									mGetDF(),mGetDF());
#endif
		sprintf(buf,fmt,dArgumentMin,dArgumentMax);
		if(IDNO == MessageBox(GetFocus(),buf,HeadLine,MBASK))
			return;
		Device->MeasureStop();
		Device->SetExposureValues(fMaxTime,dwMaxCounts,fFailure);
		Steering.Reset();
		if(bSaveContinuous || bSaveOnReady || bOldDataLoaded)
			SaveFile(SaveWithNewName);
		Steering.StartUp(hWndChild,nMotor,Device->GetId());
		// Scan starten
		Steering.Visualising(1,0,0,0,0,0);
		strcpy(buf,"");
		Steering.StartCmdExecution(Scan,ForScan,Omega2ThetaScan,buf,GetWndHandle());
		break;

		case ContinuousScan:
		bSaveContinuous = bSaveOnReady = FALSE;
		#ifdef GermanVersion
		sprintf(fmt,"%smit Omega von %s bis %s starten ?",
								"Einen kontinuierlichen Scan\r\n",mGetDF(),mGetDF());
		#else
		sprintf(fmt,"%swith Omega from %s to %s ?",
								"Do you want to start a continuous Scan\r\n",mGetDF(),mGetDF());
		#endif
		sprintf(buf,fmt,dArgumentMin,dArgumentMax);
		if(IDNO == MessageBox(GetFocus(),buf,HeadLine,MBASK))
			return;
		New();
		lpDList->SetDevice(Device->GetId());
		mlSetAxis(nMotor);
		Device->MeasureStop();
		if(bSaveContinuous || bSaveOnReady  || bOldDataLoaded)
			SaveFile(SaveWithNewName);
		Device->SetExposureValues(fMaxTime,dwMaxCounts,fFailure);
		mSetValue(Speed,dSpeed);
		distance = nCollectionAmount * dSpeed * fMaxTime;
		mMoveByDistance(distance);
		lpDList->DP()->InitializeEvent(GetWndHandle(),nCollectionAmount);
		UpdateWnd(0);
		UpdateMenu();
		bMeasurementActive = TRUE;
		return;
		}
	};

//********* Schnittstellen fr Ablaufsteuerung *********************************
void TScan::CounterSetRequest(LPARAM)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::CounterSetRequest(LPARAM)\n",time(zidx));
//pph***************************************************************************
	float     x,y,z = 0.0;
	double		dDistance;

	// Funktion behandelt Meldung cm_CounterSet
	if(bInterrupted)
		return;
	if(!bMeasurementActive)
		return;
	bFileChanged = TRUE;
	switch(eScanType) {
		case StandardScan:
		if(bMonitorUsed)
			{
			// normalize signal
			Monitor->GetData(z);
			Steering.SetNorm(z);
			}
			else
			z = 0.0;
		if(Steering.IsPositionValid())
			{
			// take new data
			x = mlGetValue(nMotor,Distance);
			Device->GetData(y);
			MainCurve->PAdd(x,y,z);
			UpdateWnd(O_PaintPoint);    // update data window
			if(bSaveContinuous)  				// store actual value
				SendMessage(hWndChild,WM_COMMAND,cm_UpdateFile,0);
			}
		Device->UpdateDisplay();
		Steering.DeviceRequest();
		break;

		case Omega2ThetaScan:
		if(bMonitorUsed)
			{
			// normalize signal
			Monitor->GetData(z);
			Steering.SetNorm(z);
			}
			else
			z = 0.0;
		if(Steering.IsPositionValid())
			{
			// take new data
			x = mlGetValue(nMotor,Distance);
			z = mlGetValue(mlGetIdByName(Theta),Distance);
			Device->GetData(y);
			MainCurve->PAdd(x,y,z);
			UpdateWnd(O_PaintPoint);    // update data window
			if(bSaveContinuous)  				// store actual value
				SendMessage(hWndChild,WM_COMMAND,cm_UpdateFile,0);
			}
		Device->UpdateDisplay();
		Steering.DeviceRequest();
		break;

		case ContinuousScan:
		mGetDistance(dDistance);
		x = dDistance;
		lpDList->DP()->GetData(y);
		MainCurve->PAdd(x,y,z);
		UpdateWnd(O_PaintPoint);
		break;
		}
	};

void TScan::SteeringReady(LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SteeringReady(LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];

	// Funktion behandelt Meldung cm_SteeringReady
	bMeasurementActive = FALSE;
	switch(eScanType) {
		case StandardScan: case Omega2ThetaScan:
		// Step-Scan wurde ausgefhrt
		switch(HIWORD(lParam)){
			case R_Failure:
			sprintf(buf,"Es ist ein Fehler aufgetreten. %d",LOWORD(lParam));
			MessageBox(hWndChild,buf,"Fehler",MB_OK | MB_ICONSTOP);
			break;
			default:
			if(bSaveContinuous)
				// Header aktualisieren
				SaveMeasurementInfo(1);  // 1 means update file header
			if(bSaveOnReady)
				if(SaveFile(NoAskForSave))
#ifdef GermanVersion
					sprintf(buf,"Die Messung wurde abgeschlossen und gespeichert.");
					else
					sprintf(buf,"Die Messung wurde abgeschlossen. Fehler beim Speichern.");
				else
				sprintf(buf,"Die Messung wurde abgeschlossen.");
				MessageBox(hWndChild,buf,"Meldung",MBINFO);
#else
					sprintf(buf,"The Measurement is completed\r\nand the data were saved.");
					else
					sprintf(buf,"The Measurement is completed.\r\nFailure on saving data.");
				else
				sprintf(buf,"The Measurement is completed.");
				MessageBox(hWndChild,buf,"Message",MBINFO);
#endif
			}
		mSetCorrectionState(FALSE);
		Device->MeasureStop();
		Device->PopSettings();
		Device->SetHost(NULL);
		Device->MeasureStart();
		break;

		case ContinuousScan:
		Device->PopSettings();
		mStopDrive(TRUE);
		Device->MeasureStart();
		UpdateWnd(0);
		MessageBox(GetFocus(),"ContinuousScan wurde ausgefhrt !","Justagen",MBINFO);
		break;
		}
	};

void  TScan::Interrupt()
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::Interrupt()\n",time(zidx));
//pph***************************************************************************
	switch(eScanType) {
		case StandardScan: case Omega2ThetaScan:
		TMDIWindow::Interrupt();
		if(bInterrupted)
			{
			Steering.ToggleInterrupt();
			mSetCorrectionState(FALSE);
#ifdef GermanVersion
			SetInfo("Messung wurde unterbrochen !");
#else
			SetInfo("The Measurement was interrupted !");
#endif
			}
		if(!bInterrupted && bMeasurementActive)
			{
			mSetCorrectionState(TRUE);
			Steering.ToggleInterrupt();
			}
		break;

		case ContinuousScan:
		mStopDrive(TRUE);
		nScanTask = 0;
		break;
		}
	};

//******************* Read/Write ***********************************************
BOOL TScan::LoadMeasurementInfo(HFILE hFile)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::LoadMeasurementInfo(HFILE hFile)\n",time(zidx));
//pph***************************************************************************
	char        header[2048];
	UINT        nReadCnt;
	char        *token,*info,*keyword;
	BOOL        retval = FALSE;

	// Header-Marke suchen
	nReadCnt = _lread(hFile,(LPSTR)header,2048);
	if(nReadCnt < 100)
		goto Exit;  // File korrupt
	token = strtok(header," \r\n");
	do
		{
		if(strstr(token,"[Header]"))
			break;
		token = strtok(NULL," \r\n");
		if(!token)
			goto Exit; // Kein Header enthalten
		}
		while(1);
	// Header-Informationen auswerten
	while(1) {
		keyword = strtok(NULL," =\n\r"); info = strtok(NULL," =\n\r");
		if(	!strcmp("Date",keyword) ||
				!strcmp("Time",keyword) ||
				!strcmp("HV",keyword)) continue;
		if(!strcmp("User",keyword))
			{
			strcpy(Main.User,info); continue;
			}
		if(!strcmp("Target",keyword))
			{
			strcpy(Main.Target,info); continue;
			}
		if(!strcmp("Orientation",keyword))
			{
			SetHKL(Main.Orientation,info);
			continue;
			}
		if(!strcmp("Reflection",keyword))
			{
			SetHKL(Main.Reflection,info);
			continue;
			}
		if(!strcmp("WaveLength",keyword))
			{
			Main.WaveLength = atof(info); continue;
			}
		if(!strcmp("ArgumentMin",keyword))
			{
			dArgumentMin = atof(info); continue;
			}
		if(!strcmp("ArgumentMax",keyword))
			{
			dArgumentMax = atof(info); continue;
			}
		if(!strcmp("ArgumentWidth",keyword))
			{
			dArgumentWidth = atof(info); continue;
			}
		if(!strcmp("TimePerScan",keyword))
			{
			fMaxTime = atof(info); continue;
			}
		if(!strcmp(keyword,"FileType"))
			{
			if(*info == '1')
				eSaveFormat = StandardFile;
				else
				goto Exit; // Falsches File-Format
			continue;
			}
		if(strstr(keyword,"[Data]")) break;
		if(strstr(info,"[Data]"))    break;
		}
	// check infos
	retval = TRUE;
	Exit:
	return retval;
	};

BOOL TScan::SaveMeasurementInfo(BOOL UpdateHeader)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SaveMeasurementInfo(BOOL UpdateHeader)\n",time(zidx));
//pph***************************************************************************
	FILE*        	hFile;
	UINT        	nSize;
	char          format[MaxString];
	char					buf[2*MaxString],buf2[20],buf3[20];
	char         	*data;
	const int			dataoffset = 1000;
	struct date  	d;
	struct time  	t;

	if(UpdateHeader)
		hFile = fopen(FileName,"rb+");
		else
		hFile = fopen(FileName,"w");
	if(!hFile)
		return FALSE;
	getdate(&d); gettime(&t);
	data = new char[dataoffset+1];
	strcpy(format,"Comment=%s");
	sprintf(buf,format,Main.Comment);
	strcpy(data,buf); strcat(data,EOL);

	strcat(data,"[Header]"); strcat(data,EOL);
	strcpy(format,"User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d DataOffset=%d");
	sprintf(buf,format,Main.User,d.da_day,d.da_mon,d.da_year,t.ti_hour,\
											t.ti_min,t.ti_sec,dataoffset);
	strcat(data,buf); strcat(data,EOL);

	strcpy(format,"Point_Number=%d FileType=%d");
	sprintf(buf,format,MainCurve->GetPNumber(),1);
	strcat(data,buf); strcat(data,EOL);

	strcpy(format,"Target=%s  Reflection=%s Orientation=%s");
	GetHKL(Main.Reflection,buf2);
	GetHKL(Main.Orientation,buf3);
	sprintf(buf,format,Main.Target,buf2,buf3);
	strcat(data,buf); strcat(data,EOL);

	mlSetAxis(nMotor);
	sprintf(format,"ArgumentMin=%s  ArgumentWidth=%s ArgumentMax=%s",mGetDF(),mGetSF(),mGetDF());
	sprintf(buf,format,dArgumentMin,dArgumentWidth,dArgumentMax);
	strcat(data,buf); strcat(data,EOL);

	strcpy(format,"WaveLength=%.3f Current=%d  HV=%d");
	sprintf(buf,format,Main.WaveLength,Main.Current,Main.Voltage);
	strcat(data,buf); strcat(data,EOL);

	strcpy(format,"TimePerScan=%.2f");
	sprintf(buf,format,fMaxTime);
	strcat(data,buf);

	nSize = strlen(data);
	for(;nSize < dataoffset-10;nSize++)
		data[nSize] = ' ';
	data[nSize] = 0x0;
	strcat(data,EOL); strcat(data,"[Data]"); strcat(data,EOL);
	fwrite(data,strlen(data),1,hFile);
	fclose(hFile);
	delete[] data;
	return TRUE;
	};


BOOL TScan::SaveFile(int ask)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SaveFile(int ask)\n",time(zidx));
//pph***************************************************************************
	char        fmt[30],buf[MaxString];
	FILE*       hFile;
	HCURSOR    	hCursor;
	float      	x,y,z;
	//! int nNumber = 0;

	if(!TMDIWindow::SaveFile(ask))
		return FALSE;
	if(!SaveMeasurementInfo(0))
		{
		#ifdef GermanVersion
		MessageBox(GetFocus(),"Header ist nicht korrekt","Meldung",MBINFO);
		#else
		MessageBox(GetFocus(),"Incorrect Header.","Message",MBINFO);
		#endif
		return FALSE;
		}
	hFile = fopen(FileName,"r+");
	hCursor = SetCursor(LoadCursor(NULL,IDC_WAIT));
	MainCurve->SetPP(0);
	fseek(hFile,0,SEEK_END);
	sprintf(fmt,"%s %s %s\r\n",mGetSF(),"%.4f","%.4f");
	MainCurve->FastOpen();
	while(MainCurve->FastPGet(x,y,z))
		{
		sprintf(buf,fmt,x,y,z);
		fwrite(buf,strlen(buf),1,hFile);
		}
   //! nNumber sollte evtl. zur Fehlerbehandlung verwendet werden
	//! nNumber = fclose(hFile);
   fclose(hFile);
	SetCursor(hCursor);
	MainCurve->FastClose();
	bFileChanged = FALSE;
	return TRUE;
	};

BOOL TScan::UpdateFile(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::UpdateFile(void)\n",time(zidx));
//pph***************************************************************************
	float    		x,y,z;
	char        buf[MaxString];
	char        fmt[MaxString];
	int         hFile;
	OFSTRUCT    of;

	if(bIsNewFile)
		SaveFileAs();
	hFile = OpenFile(FileName,&of,OF_WRITE);
	if(-1 == hFile)
		{
		MessageBox(GetFocus()," File existiert nicht !", "Fehler", MB_OK);
		return FALSE;
		}
	MainCurve->PGet(x,y,z);
	sprintf(fmt,"%s %s %s\r\n",mGetSF(),"%.4f","%.4f");
	sprintf(buf,fmt,x,y,z);
	_llseek(hFile,0,SEEK_END);
	_lwrite(hFile,(LPSTR)buf,strlen(buf));
	_lclose(hFile);
	return TRUE;
	};

BOOL TScan::LoadOldData(int)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::LoadOldData(int)\n",time(zidx));
//pph***************************************************************************
	char      	NewFileName[MAXPATH];
	const int		LLength = 2500;
	HCURSOR    	hCursor;
	LPSTR      	lpBuf;
	char				buf[MaxString];
	float       x,y,z;
	int        	hFile,cnt;
	OFSTRUCT   	of;
	char    		dir[MAXDIR],drv[MAXDRIVE],name[MAXFILE],ext[MAXEXT];

	chdir(szDataPath);
	char Filter[] = "Curve Standard (*.crv)|*.crv|Compare Curve (*.bk)|*.bk||";
	strcpy(NewFileName,"");
	FileOpen("Altes Datenfile laden ...",Filter,NewFileName,szDataPath);
	strcpy(FileName,NewFileName);
	hFile = OpenFile(FileName,&of,OF_READ);
	if(-1 == hFile)
		{
		MessageBox(GetFocus()," File wurde nicht geffnet !", "Fehler", MBINFO);
		return FALSE;
		}
	hCursor = SetCursor(LoadCursor(NULL,IDC_WAIT));
	fnsplit(FileName,drv,dir,name,ext);
	sprintf(szDataPath,"%s%s",drv,dir);
	if(!LoadMeasurementInfo(hFile))
		{
		#ifdef GermanVersion
		MessageBox(GetFocus(),"Header ist nicht korrekt","Meldung",MBINFO);
		#else
		MessageBox(GetFocus(),"Incorrect Header.","Message",MBINFO);
		#endif
		return FALSE;
		}
	MainCurve->New();
	MainCurve->FastOpen();
	lpBuf = new char [LLength];
	if(!SetFPOnData(hFile)) return FALSE;
	for(cnt = 0;;cnt++)
		switch(GetFileLine(hFile,lpBuf,LLength)){
			case R_Overflow:  goto Ready;
			case R_EndOfFile: goto Ready;

			default:
			if(3 != sscanf(lpBuf,"%f %f %f",&x,&y,&z)) continue;
			if(0==(cnt % 30))
				{
				sprintf(buf,"Points : %d",cnt);
				SetInfo(buf);
				}
			MainCurve->FastPAdd(x,y,z);
			}
Ready:
	SetCursor(hCursor);
	MainCurve->FastClose();
	dArgumentMin = MainCurve->Min[P_X];
	dArgumentMax = MainCurve->Max[P_X];
	delete[] lpBuf;
	bIsNewFile = FALSE;
	SetRanges();
	UpdateWnd(0);
	bOldDataLoaded = TRUE;
	return TRUE;
	};

//***************** Mausbedienung **********************************************
void TScan::rButtonDown(LONG lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::rButtonDown(LONG lParam)\n",time(zidx));
//pph***************************************************************************
	POINT pp;
	if(bMeasurementActive && !bInterrupted && !bScanSetupOk)
		EnableMenuItem(TheMenu,cm_InitializeScan,MF_GRAYED);
		else
		EnableMenuItem(TheMenu,cm_InitializeScan,MF_ENABLED);
	pp.x = LOWORD(lParam);
	pp.y = HIWORD(lParam);
	ClientToScreen(hWndChild,&pp);
	TrackPopupMenu(TheMenu,0,pp.x,pp.y,0,hWndChild,NULL);
	};

BOOL TScan::SaveDataBase(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TScan::SaveDataBase(void)\n",time(zidx));
//pph***************************************************************************
	return TRUE;
	};

//******************************************************************************
//******* Dialog zum Setzen der Scan-Parameter *********************************
//******************************************************************************
#ifdef GermanVersion
TSetupStepScan::TSetupStepScan(TScan* scan) : TModalDlg("ScanParameters")
#else
TSetupStepScan::TSetupStepScan(TScan* scan) : TModalDlg("ScanParametersEng")
#endif
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		#endif\n",time(zidx));
//pph***************************************************************************
	Scan = scan;
	nMotorOld = Scan->nMotor;
	eSaveFormat = Scan->eSaveFormat;
	eScanType = Scan->eScanType;
	bSaveOnReady = Scan->bSaveOnReady;
	dArgumentMin = Scan->dArgumentMin;
	dArgumentMax= Scan->dArgumentMax;
	dArgumentWidth= Scan->dArgumentWidth;
	DeviceOld = Scan->Device;
	fMaxTime = Scan->fMaxTime;
	dwMaxCounts = Scan->dwMaxCounts;
	bMonitorUsed = Scan->bMonitorUsed;
	MonitorOld = Scan->Monitor;
	bSaveContinuous = Scan->bSaveContinuous;
	strcpy(szPath,Scan->szDataPath);
	if(Scan->eScanType == ContinuousScan)
		Scan->eScanType = StandardScan;
	};

#pragma argsused
BOOL TSetupStepScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupStepScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	int       i=0;
	char      buf[MaxString];

	hDeviceList   = GetDlgItem(GetHandle(),id_ChooseDevice);
	hMotorList    = GetDlgItem(GetHandle(),id_ChooseMotor);
	hScanTypeList = GetDlgItem(GetHandle(),id_ChooseScanType);
	nMotor        = Scan->nMotor;
	Device        = Scan->Device;
	Monitor       = Scan->Monitor;
	ComboBox_AddString(hScanTypeList,"Standard");
	ComboBox_AddString(hScanTypeList,"Omega-2Theta");
	i=0;
	while(i <= lpDList->LastId())
		ComboBox_AddString(hDeviceList,lpDList->DP(i++)->Characteristic);
	ComboBox_SelectString(hDeviceList,0,Device->Characteristic);
	i = -1;
	while(++i < mlGetAxisNumber())
		{
		mlSetAxis(i);
		ComboBox_AddString(hMotorList,mGetAxisName());
		}
	mlSetAxis(nMotor);
	ComboBox_SelectString(hMotorList,0,mGetAxisName());
	if(!Monitor)
		EnableWindow(GetDlgItem(GetHandle(),id_MonitorUsed),FALSE);
		else
		CheckDlgButton(GetHandle(),id_MonitorUsed,Scan->bMonitorUsed);
	if(!IsDlgButtonChecked(GetHandle(),id_MonitorUsed))
		EnableWindow(GetDlgItem(GetHandle(),cm_RotateDevice),FALSE);
	CheckDlgButton(GetHandle(),id_SaveOnReady,Scan->bSaveOnReady);
	CheckDlgButton(GetHandle(),id_SaveContinuous,Scan->bSaveContinuous);
	sprintf(buf,"%.1f",Scan->fMaxTime);
	SetDlgItemText(GetHandle(),id_MaxTime,(LPSTR)buf);
	sprintf(buf,"%lu",Scan->dwMaxCounts);
	SetDlgItemText(GetHandle(),id_MaxCounts,(LPSTR)buf);
	SetFocus(GetDlgItem(GetHandle(),id_ChooseMotor));
	switch(eScanType) {
		case StandardScan:
		ComboBox_SelectString(hScanTypeList,0,"Standard");
		EnableWindow(GetDlgItem(GetHandle(),id_ChooseMotor),TRUE);
		break;
		case Omega2ThetaScan:
		ComboBox_SelectString(hScanTypeList,0,"Omega-2Theta");
		EnableWindow(GetDlgItem(GetHandle(),id_ChooseMotor),FALSE);
		break;
		}
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	return TRUE;
	};

void TSetupStepScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupStepScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	int       idx;
	char     	buf[MaxString];

	switch(id)
		{
		case cm_ParamSet:
		SetDlgItemText(GetHandle(),id_Unit,mGetAxisUnit());
		if(Monitor)
			SetWindowText(GetDlgItem(GetHandle(),cm_RotateDevice),Monitor->Characteristic);
			else
			SetWindowText(GetDlgItem(GetHandle(),cm_RotateDevice),(LPSTR)"Kein Gert");
		SetFocus(GetDlgItem(GetHandle(),IDOK));
		// Bereich sollte den Motor nicht beeinflussen
		sprintf(buf,mGetSF(),Scan->dArgumentWidth);
		SetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf);
		if(Scan->dArgumentMax >= mGetValue(MaxDistance))
			Scan->dArgumentMax = mGetValue(MaxDistance) - mGetValue(Width);
		sprintf(buf,mGetDF(),Scan->dArgumentMax);
		SetDlgItemText(GetHandle(),id_AngleMax,(LPSTR)buf);
		if(Scan->dArgumentMin <= mGetValue(MinDistance))
			Scan->dArgumentMin = mGetValue(MinDistance) + mGetValue(Width);
		sprintf(buf,mGetDF(),Scan->dArgumentMin);
		SetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf);
		SetDlgItemText(GetHandle(),id_Catalog,(LPSTR)Scan->szDataPath);
		ComboBox_SelectString(hMotorList,0,mGetAxisName());
		ComboBox_SelectString(hDeviceList,0,Device->Characteristic);
		break;

		case id_ChooseScanType:
		switch(eScanType) {
			case StandardScan:
			SendMessage(hScanTypeList,WM_SETTEXT,0,(LPARAM)"Standard");
			break;
			case Omega2ThetaScan:
			SendMessage(hScanTypeList,WM_SETTEXT,0,(LPARAM)"Omega-2Theta");
			break;
			}
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			switch(ComboBox_GetCurSel(hScanTypeList)) {
				case 0: // StandardScan
				eScanType = StandardScan;
				ComboBox_SelectString(hScanTypeList,0,"Standard");
				EnableWindow(GetDlgItem(GetHandle(),id_ChooseMotor),TRUE);
				break;

				case 1: // Omega2ThetaScan
				eScanType = Omega2ThetaScan;
				if(!mlIsAxisValid(Omega) || !mlIsAxisValid(Theta))
					{
					eScanType = StandardScan;
					ComboBox_SelectString(hScanTypeList,0,"Standard");
					break;
					}
				nMotor = mlGetIdByName(Omega);
				mlSetAxis(nMotor);
				ComboBox_SelectString(hScanTypeList,0,"Omega-2Theta");
				EnableWindow(GetDlgItem(GetHandle(),id_ChooseMotor),FALSE);
				}
			}
		break;

		case id_ChooseMotor:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hMotorList);
			if((nMotor != idx) && (idx != CB_ERR))
				{
				mlSetAxis(idx);
				nMotor = mlGetAxis();
				}
			}
		break;

		case id_ChooseDevice:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hDeviceList);
			if((Device != lpDList->DP(idx)) && (idx != CB_ERR))
				Device = lpDList->DP(idx);
			}
		break;

		case cm_RotateDevice: // monitor select
		Monitor = lpDList->DP(Monitor->GetId()+1);
		SetDlgItemText(GetHandle(),cm_RotateDevice,(LPSTR)Monitor->Characteristic);
		break;

		case id_MonitorUsed:
		if(!Monitor)
			break;
		if(IsDlgButtonChecked(GetHandle(),id_MonitorUsed))
			EnableWindow(GetDlgItem(GetHandle(),cm_RotateDevice),TRUE);
			else
			EnableWindow(GetDlgItem(GetHandle(),cm_RotateDevice),FALSE);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TSetupStepScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupStepScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char    	buf[MaxString];
	BOOL    	bFailure = FALSE;
	OFSTRUCT	of;
	float   	valueF;
	long    	valueL;
	int     	hfile;
	char    	dir[MAXDIR],drv[MAXDRIVE],name[MAXFILE],ext[MAXEXT];

	Scan->bSaveContinuous = IsDlgButtonChecked(GetHandle(),id_SaveContinuous);
	Scan->bSaveOnReady    = IsDlgButtonChecked(GetHandle(),id_SaveOnReady);

	GetDlgItemText(GetHandle(),id_AngleMax,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(valueF <= mGetValue(MaxDistance))
		Scan->dArgumentMax = valueF;
		else
		{
		Scan->dArgumentMax = mGetValue(MaxDistance) - mGetValue(Width);
		sprintf(buf,mGetDF(),Scan->dArgumentMax);
		SetDlgItemText(GetHandle(),id_AngleMax,(LPSTR)buf);
		bFailure = TRUE;
		}
	GetDlgItemText(GetHandle(),id_AngleWidth,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(0.0 != valueF)
		Scan->dArgumentWidth = valueF;
		else
		bFailure = TRUE;

	GetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(valueF >= mGetValue(MinDistance))
		{
		Scan->dArgumentMin = valueF;
		if(Scan->dArgumentMin >= Scan->dArgumentMax)
			{
			Scan->dArgumentMin = Scan->dArgumentMax - 10.0 * mGetValue(Width);
			sprintf(buf,mGetDF(),Scan->dArgumentMin);
			SetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf);
			bFailure = TRUE;
			}
		}
		else
		{
		Scan->dArgumentMin = mGetValue(MinDistance) + 10.0 * mGetValue(Width);
		sprintf(buf,mGetDF(),Scan->dArgumentMin);
		SetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf);
		bFailure = TRUE;
		}
	GetDlgItemText(GetHandle(),id_MaxTime,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(0.0 != valueF)
		Scan->fMaxTime = valueF;
		else
		bFailure = TRUE;

	GetDlgItemText(GetHandle(),id_MaxCounts,(LPSTR)buf,MaxString);
	valueL = atol(buf);
	if(0 != valueL)
		Scan->dwMaxCounts = valueL;
		else
		bFailure = TRUE;

	GetDlgItemText(GetHandle(),id_Catalog,(LPSTR)Scan->szDataPath,MAXPATH);
	// is path writeable
	if(Scan->szDataPath[strlen(Scan->szDataPath) - 1] != '\\')
		strcat(Scan->szDataPath,"\\");
	fnsplit(Scan->szDataPath,drv,dir,name,ext);
	fnmerge(Scan->szDataPath,drv,dir,"check","tmp");
	hfile = OpenFile(Scan->szDataPath,&of,OF_CREATE);
	if(-1 != hfile)
		{
		_lclose(hfile);
		remove(Scan->szDataPath);
		fnmerge(Scan->szDataPath,drv,dir,"","");
		}
		else
		{
		bFailure = TRUE;
		strcpy(Scan->szDataPath,"c:\\");
		}
	if(bFailure)
		{
		PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
		return FALSE;
		}
	Scan->eScanType			= eScanType;
	Scan->nMotor        = nMotor;
	Scan->Device        = Device;
	Scan->Monitor       = Monitor;
	Scan->bMonitorUsed  = IsDlgButtonChecked(GetHandle(),id_MonitorUsed);
	return TRUE;
	};

//******************************************************************************
//******* Dialog zum Setzen der Scan-Parameter *********************************
//******************************************************************************
TSetupContinuousScan::TSetupContinuousScan(TScan* scan) : TModalDlg("ContinouosScan")
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TModalDlg(ContinouosScan)\n",time(zidx));
//pph***************************************************************************
	Scan					= scan;
	nMotorOld 		= Scan->nMotor;
	eSaveFormat 	= Scan->eSaveFormat;
	eScanType 		= Scan->eScanType;
	bSaveOnReady 	= Scan->bSaveOnReady;
	dArgumentMin 	= Scan->dArgumentMin;
	dArgumentMax	= Scan->dArgumentMax;
	DeviceOld 		= Scan->Device;
	fMaxTime 			= Scan->fMaxTime;
	nCollectionAmount = Scan->nCollectionAmount;
	dSpeed				= Scan->dSpeed;
	dwMaxCounts 	= Scan->dwMaxCounts;
	Scan->bSaveContinuous = FALSE;
	Scan->eScanType = ContinuousScan;
	};

#pragma argsused
BOOL TSetupContinuousScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupContinuousScan::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM lParam)\n",time(zidx));
//pph***************************************************************************
	int       i=0;
	char      buf[MaxString];

	nMotor = Scan->nMotor;
	Device = Scan->Device;
	SetFocus(GetDlgItem(GetHandle(),id_Actor));
	hDeviceList = GetDlgItem(GetHandle(),id_ChooseDevice);
	hMotorList = GetDlgItem(GetHandle(),id_ChooseMotor);
	i = 0;
	while(i <= lpDList->LastId())
		ComboBox_AddString(hDeviceList,lpDList->DP(i++)->Characteristic);
	i = -1;
	while(++i < mlGetAxisNumber())
		{
		mlSetAxis(i);
		ComboBox_AddString(hMotorList,mGetAxisName());
		}
	sprintf(buf,"%.1f",fMaxTime);
	SetDlgItemText(GetHandle(),id_MaxTime,(LPSTR)buf);
	FORWARD_WM_COMMAND(hwnd,cm_ParamSet,hwndCtl,0,SendMessage);
	return TRUE;
	};

void TSetupContinuousScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupContinuousScan::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)\n",time(zidx));
//pph***************************************************************************
	char     	buf[MaxString];
	int       idx;

	switch(id) {
		case cm_ParamSet:
		ComboBox_SelectString(hMotorList,0,mGetAxisName());
		ComboBox_SelectString(hDeviceList,0,Device->Characteristic);
		SetDlgItemText(GetHandle(),id_Unit,(LPSTR)mGetAxisUnit());
		SetFocus(GetDlgItem(GetHandle(),cm_InitializeScan));
		// Bereich sollte den Motor nicht beeinflussen
		sprintf(buf,mGetSF(),(double)dArgumentMin);
		SetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf);
		sprintf(buf,mGetSF(),(double)dSpeed);
		SetDlgItemText(GetHandle(),id_Velocity,(LPSTR)buf);
		sprintf(buf,"%d",nCollectionAmount);
		SetDlgItemText(GetHandle(),id_NumberSteps,(LPSTR)buf);
		sprintf(buf,mGetSF(),dSpeed);
		SetDlgItemText(GetHandle(),id_Velocity,(LPSTR)buf);
		break;

		case cm_InitializeScan:
		if(CanClose())
			PostMessage(GetFrameHandle(),WM_COMMAND,cm_InitializeScan,0l);
		break;

		case id_ChooseMotor:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hMotorList);
			if((nMotor != idx) && (idx != CB_ERR))
				{
				mlSetAxis(idx);
				nMotor = mlGetAxis();
				FORWARD_WM_COMMAND(GetHandle(),cm_ParamSet,0,0,PostMessage);
				}
			}
		break;

		case id_ChooseDevice:
		switch(codeNotify)
			{
			case CBN_SELCHANGE:
			idx = ComboBox_GetCurSel(hDeviceList);
			if((Device != lpDList->DP(idx)) && (idx != CB_ERR))
				{
				Device = lpDList->DP(idx);
				PostMessage(GetHandle(),WM_COMMAND,cm_ParamSet,0);
				}
			}
		break;

		case cm_RotateMotor:
		mlSetAxis(nMotor+1);
		nMotor = mlGetAxis();
		PostMessage(GetHandle(),WM_COMMAND,(WPARAM)cm_ParamSet,0);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

BOOL TSetupContinuousScan::CanClose(void)
	{
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupContinuousScan::CanClose(void)\n",time(zidx));
//pph***************************************************************************
	char    buf[MaxString];
	float   valueF;

	GetDlgItemText(GetHandle(),id_NumberSteps,(LPSTR)buf,MaxString);
	Scan->nCollectionAmount = atoi(buf);
	if(0 == Scan->nCollectionAmount)
		{
		Scan->nCollectionAmount = 10;
		return FALSE;
		}

	GetDlgItemText(GetHandle(),id_AngleMin,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(valueF >= mGetValue(MinDistance))
		Scan->dArgumentMin = valueF;
		else
		{
		Scan->dArgumentMin = mGetValue(Distance) - 30.0;
		return FALSE;
		}

	GetDlgItemText(GetHandle(),id_Velocity,(LPSTR)buf,MaxString);
	Scan->dSpeed = atof(buf);

	GetDlgItemText(GetHandle(),id_MaxTime,(LPSTR)buf,MaxString);
	valueF = atof(buf);
	if(0.0 != valueF)
		{
		Scan->fMaxTime = valueF;
		}
		else return FALSE;
	Scan->Device 	= Device;
	Scan->nMotor 	= nMotor;
	return TRUE;
	};

BOOL TSetupContinuousScan::LeaveDialog(void)
 {
//hpp***************************************************************************
fprintf(trace,"%u		m_scan.cpp		TSetupContinuousScan::LeaveDialog(void)\n",time(zidx));
//pph***************************************************************************
 return TRUE;
 };
// __LastLine__
